#include "basMT.h"

/* OtBbNIuWFNg̏ */
static BOOL		InitWinObj(HWND hWnd)
{
	ghDC = ghVDC = NULL;
	ghVBmp = NULL;

	if ((ghDC = GetDC(hWnd)) == NULL ||
		(ghVDC = CreateCompatibleDC(ghDC)) == NULL ||
		(ghVBmp = CreateCompatibleBitmap(ghDC,WIN_WIDTH,WIN_HEIGHT)) == NULL)
		return FALSE;

	SelectObject(ghVDC,ghVBmp);
	SelectObject(ghVDC,GetStockObject(BLACK_BRUSH));
	SelectObject(ghDC,GetStockObject(BLACK_BRUSH));
	PatBlt(ghVDC,0,0,WIN_WIDTH,WIN_HEIGHT,PATCOPY);

	return TRUE;
}

/* OtBbNIuWFNg̔j */
static VOID		DelWindowObj(HWND hWnd)
{
	if (ghDC) ReleaseDC(hWnd,ghDC);
	if (ghVDC) DeleteDC(ghVDC);
	if (ghVBmp) DeleteObject(ghVBmp);
}

/* BASIC ֘Ȁ */
static BOOL		Init_SCInfo(PTHREADINFO pinf,INT id)
{
	static USERSTATEMENT		user[] = { /* userst.c */
		{ "pset", 4, (USFUNC)usr_pset, NULL }  /* @pset */
	};

	if (!StrCalc_init(&pinf->sc)) /* StrCalc  */
		return FALSE;

	/*
	      mkrgb ... ֐ mkrgbifunc.cj
	  win_width ... EChE
	 win_height ... EChE
	 thread_cnt ... Xbh
	  thread_id ... Xbhԍ
	*/

	if (StrCalc_setfunc(&pinf->sc,"mkrgb",3,user_f_mkrgb,0) <= 0 ||
		StrCalc_setconst(&pinf->sc,"win_width",WIN_WIDTH) <= 0 ||
		StrCalc_setconst(&pinf->sc,"win_height",WIN_HEIGHT) <= 0 ||
		StrCalc_setconst(&pinf->sc,"thread_cnt",THREAD_CNT) <= 0 ||
		StrCalc_setconst(&pinf->sc,"thread_id",(double)id) <= 0)
	{
		StrCalc_term(&pinf->sc);
		return FALSE;
	}

	pinf->sc.b_hexchk = 1;

	pinf->bas.random_seed = 0;
	pinf->bas.psource = gpsrc;
	pinf->bas.src_size = gsize;
	pinf->bas.b_srand = 0;
	pinf->bas.b_localparam = 0;
	pinf->bas.b_remark_colontype = 0;
	pinf->bas.b_remark_ignorestr = 0;
	pinf->bas.b_check_dup_label = 1;
	pinf->bas.b_naked_us = 0;
	pinf->bas.b_us_check = 0;
	pinf->bas.b_removespace = 0;
	pinf->bas.b_ignore_subcnt = 1;
	pinf->bas.stackcnt_if = 16;
	pinf->bas.stackcnt_for = 16;
	pinf->bas.stackcnt_gosub = 16;
	pinf->bas.pus = user;
	pinf->bas.uscnt = sizeof(user) / sizeof(USERSTATEMENT);
	pinf->bas.fevery = func_stopevent;
	pinf->bas.fprologue = func_prologue;
	pinf->bas.fepilogue = NULL;
	pinf->bas.proc_exparam = ghStop;
	pinf->bas.psubst = NULL;
	pinf->bas.subst_exparam = NULL;

	return TRUE;
}

/* WM_CREATE */
BOOL		OnCreate(HWND hWnd)
{
	INT			i,j,k;

	/* OtBbN֘Ȁ */
	if (InitWinObj(hWnd) == FALSE){
		DelWindowObj(hWnd);
		return FALSE;
	}

	/* Xbhɓn̏ */
	for(i = 0;i < THREAD_CNT;i++){
		if (Init_SCInfo(gti + i,i) == FALSE){ /* Pvfs */
			while(--i >= 0)
				StrCalc_term(&gti[i].sc); /* G[̏ꍇ͑SĂ */

			DelWindowObj(hWnd);
			return FALSE;
		}
		gti[i].hWnd = hWnd;
	}

	/* Xbh̐ */
	for(j = 0;j < THREAD_CNT;j++){
		ghThread[j] = (HANDLE)_beginthreadex(
							NULL,
							0,
							(THREAD_ROUTINE)basic_proc, /* basic.c */
							(LPVOID)(gti + j),
							CREATE_SUSPENDED, /* ꎞ~ */
							NULL);
		if (!ghThread[j]){
			SetEvent(ghStop);
			for(k = j - 1;k >= 0;k--)
				ResumeThread(ghThread[k]);
			WaitForMultipleObjects(j,ghThread,TRUE,INFINITE);
			OnClose(hWnd,i,j);
			return FALSE;
		}
	}

	return TRUE;
}

/* WM_CLOSE */
VOID		OnClose(HWND hWnd,INT cnt_sc,INT cnt_thread)
{
	INT		i;

	for(i = 0;i < cnt_thread;i++)
		CloseHandle(ghThread[i]);

	for(i = 0;i < cnt_sc;i++)
		StrCalc_term(&gti[i].sc); /* StrCalc  */

	DelWindowObj(hWnd); /* OtBbNIuWFNg̉ */
}

/*
  EOtBbÑXe[gg @pset ݂̂Ȃ̂ŁAKvȏꍇ͒ǉ
    B

  EXbh̏ɂẮAdˍ킹̕`ɉeꍇ܂B

  EEChẼNAAOtBbNʑSɉe`sꍇ́A
    sĂXbh̕`ɉeȂ悤AeXbh̓Kv
    ܂BNȀꍇ́A̓ɃCXbhōs
    Płi̈ƂăAvP[VsjB
*/
