#ifndef ___GRAPH_H_ONCE
#define ___GRAPH_H_ONCE

#define WIN_WIDTH			640
#define WIN_HEIGHT			480

#define MAX_FXSTR			256
#define PARAM_NAME			"x"

#ifdef ___GRAPH_MAIN_OBJECT
LPSTR					gpszWinName = "graph";
HINSTANCE				ghInst;
HDC						ghDC;
HBITMAP					ghBmp;
HPEN					ghCenterPen;
BOOL					gbSuccessInit;
STRCALC_PARAM			gsc;
CHAR					gFX[MAX_FXSTR+1];
INT						cx,cy;
double					mag = 1.0;
#else
extern LPSTR			gpszWinName;
extern HINSTANCE		ghInst;
extern HDC				ghDC;
extern HBITMAP			ghBmp;
extern HPEN				ghCenterPen;
extern BOOL				gbSuccessInit;
extern STRCALC_PARAM	gsc;
extern CHAR				gFX[MAX_FXSTR+1];
extern INT				cx,cy;
extern double			mag;
#endif

INT			Calc(HWND,INT,INT);
VOID		CenterLine(INT,INT);

INT			OnCreate(HWND);
VOID		OnClose(HWND);

VOID		OnLButtonDown(HWND,LPARAM);
VOID		OnMouseMove(HWND,LPARAM);
VOID		OnLButtonUp(HWND,LPARAM);
VOID		OnRButtonDown(HWND,LPARAM);

BOOL		StrSet(HWND);
BOOL		MagSet(HWND);

LPSTR		errormes(INT);

#endif
