#include <windows.h>
#include "sc39.h"
#include "graph.h"
#include "resource.h"

LRESULT CALLBACK	SetDlg(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	PAINTSTRUCT		ps;

	switch(Msg){
		case	WM_INITDIALOG:
				SetDlgItemText(hWnd,IDC_EDIT1,gFX);
				break;

		case	WM_PAINT:
				BeginPaint(hWnd,&ps);
				EndPaint(hWnd,&ps);
				break;

		case	WM_CLOSE:
				EndDialog(hWnd,IDCANCEL);
				break;

		case	WM_COMMAND:
				switch(LOWORD(wParam)){
					case	IDCANCEL:
							PostMessage(hWnd,WM_CLOSE,0L,0L);
							break;

					case	IDOK:
							GetDlgItemText(hWnd,IDC_EDIT1,gFX,MAX_FXSTR+1);
							EndDialog(hWnd,IDOK);
							break;
				}
				break;
		default:
				return FALSE;
	}
	return TRUE;
}

BOOL	StrSet(HWND hWnd)
{
	INT			ret;

	if ((ret = DialogBox(ghInst,MAKEINTRESOURCE(IDD_DIALOG1),
		hWnd,(DLGPROC)SetDlg)) < 0){
		MessageBox(hWnd,"EChE̍쐬Ɏs܂B",
			gpszWinName,MB_OK | MB_ICONHAND);
		return FALSE;
	}
	return (ret == IDOK)? TRUE : FALSE;
}
