#include <windows.h>
#include "sc39.h"
#include "lbas.h"
#include "local.h"
#include "resource.h"

BOOL WINAPI	DllMain(HINSTANCE hInstance,DWORD dwReason,LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
		ghInst = hInstance;
	return TRUE;
}

LRESULT CALLBACK	DialogProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	PAINTSTRUCT		ps;
	LPSTR			ptr;

	switch(Msg){
		case	WM_INITDIALOG:
				if ((ptr = OnInitDialog(hWnd)) == NULL) /* init.c */
					break;

				/*
				  ܂ł̃G[̓bZ[W{bNXŕ\܂B
				  ȍ~̃G[ IDC_EDIT2 ֏o͂܂B
				*/

				MessageBox(hWnd,ptr,gpszWinName,MB_OK | MB_ICONHAND);
				DestroyWindow(hWnd);
				break;

		case	WM_CLOSE:
				if (ghThread){
					if (WaitForSingleObject(ghThread,150) != WAIT_OBJECT_0){
						SetEvent((HANDLE)bt.bas.proc_exparam);
						PostMessage(hWnd,WM_CLOSE,0L,0L);
						break;
					}
					TerminateBas();  /* bas.c */
				}

				OnClose(hWnd); /* IFinit.c */
				DestroyWindow(hWnd);
				break;

		case	WM_PAINT:
				BeginPaint(hWnd,&ps);
				EndPaint(hWnd,&ps);
				break;

		case	WM_COMMAND:
				switch(LOWORD(wParam)){
					case	IDC_START: /* RUN {^ */
							OnStart(hWnd); /* bas.c */
							break;

					case	IDC_STOP: /* STOP {^ */
							OnStop(hWnd); /* bas.c */
							break;
				}
				break;

		case	WM_USER: /* BASIC Iʒm */

				if (!ghThread) break;
				TerminateBas(); /* bas.c */

				if (wParam != STATUS_NORMAL)
					errormes_V39(hWnd,(INT)wParam,bt.bas.sc_ret); /* error.c */

				EnableCtrl(hWnd,TRUE); /* bas.c */
				break;

		default:
				return FALSE;
	}

	return TRUE;
}

DECLARE HWND __stdcall		LineBasDlg(HWND hWndOwner)
{
	HWND		hWnd;

	/*
	  ĂяõEChEƋ邽߁A[_X_CAO{bNX
	  쐬܂B
	*/
	if ((hWnd = CreateDialog(ghInst,MAKEINTRESOURCE(IDD_DIALOG1),
		hWndOwner,(DLGPROC)DialogProc)) == NULL)
		return NULL;

	ShowWindow(hWnd,SW_SHOW);
	UpdateWindow(hWnd);

	return hWnd;
}
