#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include "sc39.h"
#include "test.h"

/* \[Xt@C̓ǂݍ */
char	*load_src(char *filename,unsigned long *psize)
{
	FILE		*fp;
	char		*ptr;
	size_t		ret;

	if ((fp = fopen(filename,"rb")) == NULL)
		return NULL;

	if ((long)(*psize = _filelength(_fileno(fp))) <= 0 ||
		(ptr = (char *)malloc(*psize + 1)) == NULL)
	{
		fclose(fp);
		return NULL;
	}

	ret = fread(ptr,1,*psize,fp);
	fclose(fp);

	if (ret < *psize){
		free(ptr);
		return NULL;
	}

	ptr[*psize] = 0;
	return ptr;
}
