#include <windows.h>
#include <string.h>
#include "sc39.h"
#include "cio.h"

typedef struct {
	LPSTR		name;
	INT			len;
	WORD		color;
} COLORTBL,*PCOLORTBL;

COLORTBL		txtcol_fore[] = {
	{ "BLACK", 5, 0 },
	{ "BLUE", 4, FOREGROUND_BLUE },
	{ "GREEN", 5, FOREGROUND_GREEN },
	{ "RED", 3, FOREGROUND_RED },
	{ "CYAN", 4, FOREGROUND_BLUE | FOREGROUND_GREEN },
	{ "YELLOW", 6, FOREGROUND_GREEN | FOREGROUND_RED },
	{ "PURPLE", 6, FOREGROUND_RED | FOREGROUND_BLUE },
	{ "WHITE", 5, FOREGROUND_BLUE | FOREGROUND_GREEN | FOREGROUND_RED },
	{ 0 }
};

COLORTBL		txtcol_back[] = {
	{ "BLACK", 5, 0 },
	{ "BLUE", 4, BACKGROUND_BLUE },
	{ "GREEN", 5, BACKGROUND_GREEN },
	{ "RED", 3, BACKGROUND_RED },
	{ "CYAN", 4, BACKGROUND_BLUE | BACKGROUND_GREEN },
	{ "YELLOW", 6, BACKGROUND_GREEN | BACKGROUND_RED },
	{ "PURPLE", 6, BACKGROUND_RED | BACKGROUND_BLUE },
	{ "WHITE", 5, BACKGROUND_BLUE | BACKGROUND_GREEN | BACKGROUND_RED },
	{ 0 }
};

/* eLXgF̎w */
DECLARE INT __stdcall	usr_color(
							PSTRCALC_PARAM		prm,
							LPSTR				arg,
							INT					len,
							PIOHANDLES			pio)
{
	LPSTR			ptr;
	PCOLORTBL		pfore,pback;

	if ((ptr = strtok(arg," \t,")) == 0)
		return STATUS_ERROR;

	pfore = txtcol_fore;
	do{
		if (!_strnicmp(ptr,pfore->name,pfore->len))
			break;
	}while((++pfore)->name);

	if (!pfore->name || (ptr = strtok(0," \t,")) == 0)
		return STATUS_ERROR;

	pback = txtcol_back;
	do{
		if (!_strnicmp(ptr,pback->name,pback->len))
			break;
	}while((++pback)->name);

	if (!pback->name)
		return STATUS_ERROR;

	SetConsoleTextAttribute(
		pio->hStdout,(WORD)(pfore->color | pback->color));

	/*
	  ̃Xe[ggł͋T|[gĂ܂B
	  Kvȏꍇ͋@\ǉĂB

	      FFOREGROUND_INTENSITY , BACKGROUND_INTENSITY
	*/

	return STATUS_NORMAL;
}
