#include "basMT.h"

LRESULT CALLBACK	WinProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	switch(Msg){
		case	WM_CREATE:
				if (OnCreate(hWnd) == FALSE) /* init.c */
					return -1;
				Start(); /* basic.c */
				break;

		case	WM_PAINT:
				OnPaint(hWnd);
				break;

		case	WM_CLOSE:
				if (WaitForMultipleObjects(
					THREAD_CNT,ghThread,TRUE,250) != WAIT_OBJECT_0)
				{
					SetEvent(ghStop);
					PostMessage(hWnd,WM_CLOSE,0L,0L);
					break;
				}

				OnClose(hWnd,THREAD_CNT,THREAD_CNT); /* init.c */
				DestroyWindow(hWnd);
				break;

		case	WM_DESTROY:
				PostQuitMessage(0);
				break;

		case	WM_LBUTTONDOWN: /* EChENbN BASIC f */
				SetEvent(ghStop);
				break;

		case	WM_USER:
				OnUser(hWnd); /* onuser.c */
				break;

		default:
				return DefWindowProc(hWnd,Msg,wParam,lParam);
	}

	return 0;
}

