#ifndef ___BMPPROC_H_ONCE
#define ___BMPPROC_H_ONCE

#define WIN_WIDTH				640
#define WIN_HEIGHT				480
#define WIDTH(S)				((S).right - (S).left)
#define HEIGHT(S)				((S).bottom - (S).top)

#define BMP_FILENAME			"sample.bmp"
#define SRC_FILENAME			"proc.txt"

typedef UINT		(*THREAD_ROUTINE)(LPVOID);

typedef struct {
	HWND				hWnd;
	HDC					hVDC;
	HBITMAP				hVBmp;
	BITMAPDATA			bmpdata;
	STRCALC_PARAM		sc;
	BASICPARAM			bas;
	BOOL				bReady;
} INFO,*PINFO;

INT		OnCreate(HWND);
VOID	OnDestroy(HWND);

LPSTR	StartBASIC(HWND);
VOID	errormes_V39(HWND,INT64,PBASICPARAM);
LPSTR	CurrentPath(LPSTR);

INT64	func_stopevent(PSTRCALC_PARAM,HANDLE);
INT64	func_substproc(PSTRCALC_PARAM,LPSTR,INT64,INT64,INT64 *,PINFO);

double	user_f_mem(double *,INT64,INT64 *,PBITMAPDATA);
double	user_f_mkrgb(double *,INT64,INT64 *,LPVOID);
double	user_f_getR(double *,INT64,INT64 *,LPVOID);
double	user_f_getG(double *,INT64,INT64 *,LPVOID);
double	user_f_getB(double *,INT64,INT64 *,LPVOID);

#ifdef ___MAIN_OBJECT
LPSTR					gpszWinName = "bmp process";
INFO					ginf;
HANDLE					ghThread;
#else
extern LPSTR			gpszWinName;
extern INFO				ginf;
extern HANDLE			ghThread;
#endif

#endif
