#include <windows.h>
#include "sc39x64.h"
#include "bmp.h"
#include "bmpproc.h"

/* Oz񂩂̓ */
double	user_f_mem(
			double			*arg,
			INT64			argcnt,
			INT64			*pret,
			PBITMAPDATA		pbmp)
{
	INT64		x,y;

	x = (INT64)arg[0]; y = (INT64)arg[1];
	if (x < 0 || x >= pbmp->nWidth || y < 0 || y >= pbmp->nHeight){
		*pret = STATUS_PARAM_RANGEOVER;
		return 0.0;
	}
	*pret = STATUS_NORMAL;
	return pbmp->pBmp[y * pbmp->nWidth + x];
}

/* RGBl̍쐬 */
double	user_f_mkrgb(
			double		*arg,
			INT64		argcnt,
			INT64		*pret,
			LPVOID		dmy)
{
	INT64	r,g,b;

	*pret = STATUS_NORMAL;

	if ((r = (INT64)arg[0]) < 0)
		r = 0;
	else if (r > 255)
		r = 255;

	if ((g = (INT64)arg[1]) < 0)
		g = 0;
	else if (g > 255)
		g = 255;

	if ((b = (INT64)arg[2]) < 0)
		b = 0;
	else if (b > 255)
		b = 255;

	return (double)RGB(r,g,b);
}

/* RGBlԗvf𒊏o */
double	user_f_getR(
			double		*arg,
			INT64		argcnt,
			INT64		*pret,
			LPVOID		dmy)
{
	*pret = STATUS_NORMAL;
	return GetRValue((DWORD)arg[0]);
}

/* RGBlΗvf𒊏o */
double	user_f_getG(
			double		*arg,
			INT64		argcnt,
			INT64		*pret,
			LPVOID		dmy)
{
	*pret = STATUS_NORMAL;
	return GetGValue((DWORD)arg[0]);
}

/* RGBlvf𒊏o */
double	user_f_getB(
			double		*arg,
			INT64		argcnt,
			INT64		*pret,
			LPVOID		dmy)
{
	*pret = STATUS_NORMAL;
	return GetBValue((DWORD)arg[0]);
}

