#include <windows.h>
#include "sc39x64.h"
#include "graph.h"
#include "resource.h"

/* x Ay̕` */
VOID		CenterLine(INT64 x,INT64 y)
{
	if (x >= 0 && x < WIN_WIDTH){
		MoveToEx(ghDC,(INT)x,0,NULL);
		LineTo(ghDC,(INT)x,WIN_HEIGHT-1);
	}
	if (y >= 0 && y < WIN_HEIGHT){
		MoveToEx(ghDC,0,(INT)y,NULL);
		LineTo(ghDC,WIN_WIDTH-1,(INT)y);
	}
}

/* vZƃOt` */
INT64		Calc(HWND hWnd,INT64 x,INT64 y)
{
	INT64			ix,iy,ret;
	double			*px;
	HPEN			hPen;
	PARAM_INFO		pinf;

	PatBlt(ghDC,0,0,WIN_WIDTH,WIN_HEIGHT,PATCOPY);
	hPen = SelectObject(ghDC,ghCenterPen);
	CenterLine(x,y);
	SelectObject(ghDC,hPen);

	StrCalc_search_param(&gsc,PARAM_NAME,&pinf);
	px = pinf.pval;

	gsc.str = gFX;
	for(ix = -1;ix < WIN_WIDTH;ix++){
		*px = (double)(ix - x) / mag;

		if ((ret = StrCalc(&gsc)) != STATUS_NORMAL)
			return ret;

		if ((iy = (INT64)(-mag * gsc.ans) + y) < 0)
			iy = 0;
		else if (iy >= WIN_HEIGHT)
			iy = WIN_HEIGHT - 1;

		if (ix >= 0)
			LineTo(ghDC,(INT)ix,(INT)iy);
		else
			MoveToEx(ghDC,(INT)ix,(INT)iy,NULL);
	}

	InvalidateRect(hWnd,NULL,FALSE);
	return STATUS_NORMAL;
}
