#include <windows.h>
#include <ctype.h>
#include "sc39x64.h"
#include "test.h"

/* t@Cǂݍ */
LPSTR		LoadFile(LPSTR pfilename,UINT64 *psize,HANDLE hHeap)
{
	HANDLE		hFile;
	DWORD		dwRead,dwsize;
	BOOL		bret;
	LPSTR		ptr;

	hFile = CreateFile(
				pfilename,
				GENERIC_READ,
				0,
				NULL,
				OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL,
				NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return NULL;

	dwsize = GetFileSize(hFile,NULL);
	*psize = (UINT64)dwsize;
	if ((LONG)dwsize <= 0 ||
		(ptr = HeapAlloc(hHeap,HEAP_ZERO_MEMORY,dwsize + 1)) == 0){
		CloseHandle(hFile);
		return NULL;
	}

	bret = ReadFile(hFile,ptr,dwsize,&dwRead,NULL);
	CloseHandle(hFile);

	if (bret == FALSE || dwRead < dwsize){
		HeapFree(hHeap,0,ptr);
		return NULL;
	}

	return ptr;
}

/* ̎荞݁itbN֐j*/
INT64		func_substproc(
				PSTRCALC_PARAM		prm,
				LPSTR				pstr,
				INT64				len,
				INT64				btemp,
				INT64				*pret,
				LPSTR				pdest)
{
	/*
	  ł title_str = "" ƂɂĂ܂Ȃ̏ł
	  肠܂BAɋÂ߂ƁAGh[UɂS|
	  ̂ŒӂĂB
	*/

	/* ϐ "title_str" ł͂Ȃꍇ̓ftHgs */
	if (_strnicmp(pstr,PARAMNAME_TITLE,PARAMNAME_TITLE_LEN)){
		*pret = STATUS_NORMAL;
		return 0;
	}

	/* ϐA|C^ړA󔒂Δ΂ */
	pstr += PARAMNAME_TITLE_LEN;
	while(isspace(*pstr))
		pstr++;

	/* ϐ̎CR[ł͂Ȃꍇ̓G[ */
 	if (*pstr != '='){
		*pret = STATUS_NEED_EQUAL;
		return 0;
	}

	/* _uNH[gŊĂ镶Rs[ */
	if (*StrCalc_stringcopy(pdest,pstr + 1,MAX_NAMELEN+1) != '\"'){
		*pret = STATUS_ERROR;
		return 0;
	}

	*pret = STATUS_NORMAL;
	return 1;
}

/*
  ϐe擾

  ʂȂ΁AStrCalc_search_paramgĒɎ擾Ăǂ̂łA
  ֐Ă΁AɎ悤ȏsہAg񂵂܂B
*/

typedef struct {
	char		name[SC_MAX_PARAMNAME+7];
	int			*pnval;
} PARAMTBL,*PPARAMTBL;

void		set_val(PSTRCALC_PARAM psc,PPARAMTBL ptbl,int cnt)
{
	PARAM_INFO			inf;

	while(cnt){
		if (StrCalc_search_param(psc,ptbl->name,&inf) &&
			inf.type == PRM_SINGLE)
			*ptbl->pnval = (INT)*inf.pval;
		ptbl++, cnt--;
	}
}

/* t@C̎sƏ̎擾 */
INT			Load_IniFile(PWIN_INIT pwi)
{
	HANDLE				hHeap = GetProcessHeap();
	STRCALC_PARAM		sc;
	BASICPARAM			bas = {0};
	INT					ret;

	if (!StrCalc_init(&sc))
		return STATUS_INIT_SCERROR;

	sc.b_hexchk = 1;

	/* BASIC ֘Ȁ */
	bas.random_seed = 0;
	bas.b_srand = 0;
	bas.b_localparam = 0;
	bas.b_remark_colontype = 0;
	bas.b_remark_ignorestr = 0;
	bas.b_check_dup_label = 1;
	bas.b_naked_us = 0;
	bas.b_us_check = 0;
	bas.b_removespace = 0;
	bas.b_ignore_subcnt = 1;
	bas.stackcnt_if = 16;
	bas.stackcnt_for = 16;
	bas.stackcnt_gosub = 16;

	bas.pus = NULL;
	bas.uscnt = 0;

	bas.fevery = NULL;
	bas.fprologue = NULL;
	bas.fepilogue = NULL;

	bas.psubst = func_substproc;
	bas.subst_exparam = pwi->name; /* EChE^Cg󂯎 */

	if (StrCalc_setconst(
		&sc,CONSTNAME_WIDTH,GetSystemMetrics(SM_CXSCREEN)) <= 0 ||
		StrCalc_setconst(
		&sc,CONSTNAME_HEIGHT,GetSystemMetrics(SM_CYSCREEN)) <= 0){

		StrCalc_term(&sc);
		return STATUS_INIT_CONSTERROR;
	}

	if ((bas.psource = LoadFile(INI_FILE,&bas.src_size,hHeap)) == NULL){
		StrCalc_term(&sc);
		return STATUS_INIT_LOADERROR;
	}

	ret = (INT)StrCalc_BASIC(&sc,&bas); /* t@C̓es */
	HeapFree(hHeap,0,bas.psource);

	if (ret != STATUS_NORMAL){
		StrCalc_term(&sc);
		return STATUS_BASERROR;
	}

	/*
	  t@CsAϐ𓾂
	  ł͊ȒP̂߁Aϐ𔭌łȂ̓ftHgl̂܂܂
	  Ă܂B
	*/
	{
		PARAMTBL			tbl[] = {
			{ PARAMNAME_XPOS, NULL }, { PARAMNAME_YPOS, NULL },
			{ PARAMNAME_WIDTH, NULL  }, { PARAMNAME_HEIGHT, NULL }
		};
		tbl[0].pnval = &pwi->x;
		tbl[1].pnval = &pwi->y;
		tbl[2].pnval = &pwi->width;
		tbl[3].pnval = &pwi->height;
		set_val(&sc,tbl,sizeof(tbl) / sizeof(PARAMTBL));
	}

	/* Ŏ擾l̃`FbNs܂B */

	StrCalc_term(&sc);
	return STATUS_NORMAL;
}

