#include "plotter.h"

/* WM_CLOSE */
VOID		OnClose(HWND hWnd)
{
	if (ghThread) CloseHandle(ghThread);

	/* OtBbN֘Ã\[X */
	if (ghDC) ReleaseDC(hWnd,ghDC);
	if (ghVDC) DeleteDC(ghVDC);
	if (ghVBmp) DeleteObject(ghVBmp);
	if (ghPen) DeleteObject(ghPen);
}

USERSTATEMENT		user[] = { /* userst.c */
	{ "move", 4, (USFUNC)usr_move, NULL },
	{ "draw", 4, (USFUNC)usr_draw, NULL },
	{ "chpen", 5, (USFUNC)usr_chpen, NULL },
	{ "resetpos", 8, (USFUNC)usr_resetpos, NULL }
};

LPSTR				ban_str[] = {
	"move", "draw", "chpen", "resetpos"
};

/* WM_CREATE */
LRESULT		OnCreate(HWND hWnd)
{
	ghThread = NULL;
	ghDC = ghVDC = NULL;
	ghVBmp = NULL;
	ghPen = NULL;

	if ((ghDC = GetDC(hWnd)) == NULL ||
		(ghVDC = CreateCompatibleDC(ghDC)) == NULL ||
		(ghVBmp = CreateCompatibleBitmap(ghDC,WIN_WIDTH,WIN_HEIGHT)) == NULL ||
		(ghPen = CreatePen(PS_SOLID,1,DEF_PENCOLOR)) == NULL){
		OnClose(hWnd);
		return -1;
	}

	SelectObject(ghVDC,ghVBmp);
	SelectObject(ghVDC,GetStockObject(BLACK_BRUSH));
	SelectObject(ghVDC,ghPen);
	SelectObject(ghDC,ghPen);
	PatBlt(ghVDC,0,0,WIN_WIDTH,WIN_HEIGHT,PATCOPY);

	/* StrCalc ֐ƒ萔̓o^ */
	if (StrCalc_setfunc(&gsc,"mkrgb",3,user_f_mkrgb,0) <= 0 ||
		StrCalc_setconst(&gsc,"win_width",WIN_WIDTH) <= 0 ||
		StrCalc_setconst(&gsc,"win_height",WIN_HEIGHT) <= 0){
		OnClose(hWnd);
		return -1;
	}

	/* BASIC ݒ */
	gsc.b_hexchk = 1;
	gbas.random_seed = 0;
	gbas.psource = gpsrc;
	gbas.src_size = gsize;
	gbas.b_srand = 0;
	gbas.b_localparam = 0;
	gbas.b_remark_colontype = 0;
	gbas.b_remark_ignorestr = 0;
	gbas.b_check_dup_label = 1;
	gbas.b_naked_us = 1;		/* @ tȂ */
	gbas.b_us_check = 0;
	gbas.b_removespace = 0;
	gbas.b_ignore_subcnt = 1;
	gbas.stackcnt_if = 16;
	gbas.stackcnt_for = 16;
	gbas.stackcnt_gosub = 16;
	gbas.pus = user;
	gbas.uscnt = sizeof(user) / sizeof(USERSTATEMENT);
	gbas.fevery = func_stopevent;
	gbas.fprologue = NULL;
	gbas.fepilogue = NULL;
	gbas.proc_exparam = ghStop;
	gbas.psubst = NULL;
	gbas.subst_exparam = NULL;

	gx = ORG_X; /* _ */
	gy = ORG_Y;

	/* ϐ̋֎~[h */
	gsc.ppcheck_paramname = ban_str;
	gsc.nametbl_cnt = sizeof(ban_str) / sizeof(LPSTR);

	/* Xbh̐ BASIC ̊Jn */
	ghThread = (HANDLE)_beginthreadex(
				NULL,
				0,
				(THREAD_ROUTINE)basic_proc,
				(LPVOID)hWnd,
				0,
				NULL);
	if (!ghThread){
		OnClose(hWnd);
		return -1;
	}

	return 0;
}
