#include "plotter.h"

/* StrCalc G[bZ[W */
static LPSTR		errormes_StrCalc(INT64 ret)
{
	LPSTR		ptr;

	switch(ret){
		case	STATUS_ERROR:
				ptr = "\G[";
				break;

		case	STATUS_DIVIDEBYZERO:
				ptr = "[̏ZE]vZs܂";
				break;

		case	STATUS_ILLEGAL_POWER:
				ptr = "ׂ̎gp@Ɍ肪܂";
				break;

		case	STATUS_ILLEGALPARENTHESIS:
				ptr = "ʂ̌⏇sł";
				break;

		case	STATUS_PARENTHESIS_OVERNEST:
				ptr = "ʂ̃lXg[߂܂";
				break;

		case	STATUS_MEMERROR:
				ptr = "ϐ̓o^ɎsAϐ̎擾Ɏs܂";
				break;

		case	STATUS_TOOMANYITEM:
				ptr = "߂܂";
				break;

		case	STATUS_INVALIDARGS:
				ptr = "zϐ̃CfbNXA֐̈J}ŋ؂Ă܂";
				break;

		case	STATUS_ILLEGALFUNCTIONCALL:
				ptr = "֐̎gp@Ɍ肪܂";
				break;

		case	STATUS_RANGEOVER:
				ptr = "lϊA܂͌vZɃI[o[t[܂";
				break;

		case	STATUS_TOOLONGNUM:
				ptr = "l߂܂";
				break;

		case	STATUS_OP_ERROR:
				ptr = "ƉZq̌܂";
				break;

		case	STATUS_ILLEGALNUM_BIN:
				ptr = "͂QilƔF܂AϊɎs܂";
				break;

		case	STATUS_ILLEGALNUM_OCT:
				ptr = "͂WilƔF܂AϊɎs܂";
				break;

		case	STATUS_ILLEGALNUM_DEC:
				ptr = "͂POiliwɂ鐮ljƔF܂AϊɎs܂";
				break;

		case	STATUS_ILLEGALNUM_HEX:
				ptr = "͂PUilƔF܂AϊɎs܂";
				break;

		case	STATUS_ONLY_PERIOD:
				ptr = "sIh̋Lq͋Ă܂";
				break;

		case	STATUS_INVALID_RADIX:
				ptr = "B AO AD AH (b Ao Ad Ah) ȊO̊w蕶gpĂ܂";
				break;

		case	STATUS_ILLEGALNUM_FP:
				ptr = "͎lA܂͕_lƂĔF܂AϊɎs܂";
				break;

		case	STATUS_PARAM_RANGEOVER:
				ptr = "zϐ̃CfbNXL͈͂𒴂Ă܂";
				break;

		case	STATUS_ILLEGALNUM_STR:
				ptr = "͉p܂ސlƂĔF܂AϊɎs܂";
				break;

		case	STATUS_NEED_START_PAREN:
				ptr = "Jn ( Kvł";
				break;

		case	STATUS_NEED_LAST_PAREN:
				ptr = "I ) Kvł";
				break;

		case	STATUS_CONSTCHR_SYNTAXERROR:
				ptr = "萔̏Ɍ肪܂";
				break;

		case	STATUS_CONSTCHR_NEED_SQ:
				ptr = "萔̓VONH[g \' ŊĂKv܂";
				break;

		case	STATUS_SCMEMORY_NOTREADY:
				ptr = "̃AvP[Vł single character memory gp鎖ł܂";
				break;

		case	STATUS_SCMEMORY_RANGEOVER:
				ptr = "w single character memory ́AAvP[V߂Ăgp\͈͂𒴂Ă܂";
				break;

		case	STATUS_BROKEN_PARAMETER_INFO:
				ptr = "ϐُł";
				break;

		case	STATUS_ILLEGAL_PARAMNAME:
				ptr = "ϐ܂";
				break;

		case	STATUS_DUPLICATE_DEFINITION:
				ptr = "ɓo^Ăϐg܂";
				break;

		case	STATUS_NEED_EQUAL:
				ptr = "CR[ = Kvł";
				break;

		case	STATUS_SUBST_SYNTAXERROR:
				ptr = "ƂĂ̋LqɌ肪܂";
				break;

		default:
				ptr = "";
	}

	return ptr;
}

/* StrCalc BASIC G[bZ[W */
static LPSTR		errormes_StrCalcBASIC(INT64 ret)
{
	LPSTR		ptr;

	switch(ret){
		case	STATUS_NOTENOUGHMEM:
				ptr = "p̃mۂɎs܂";
				break;

		case	STATUS_GOSUB_STACKOVERFLOW:
				ptr = "Tu[`̃lXg[߂܂";
				break;

		case	STATUS_IF_WITHOUT_THEN:
				ptr = "if ɑ΂ then ܂";
				break;

		case	STATUS_IFBLOCK_STACKOVERFLOW:
				ptr = "if ` endif ̃lXg[߂܂";
				break;

		case	STATUS_LABEL_SYNTAXERROR:
				ptr = "xKʂł͂܂";
				break;

		case	STATUS_ELSE_WITHOUT_IF:
				ptr = "if ubNgĂȂ̂ else gp܂";
				break;

		case	STATUS_ELSE_SYNTAXERROR:
				ptr = "else ̌ɕsvȕ܂";
				break;

		case	STATUS_ENDIF_WITHOUT_IF:
				ptr = "if ubNgĂȂ̂ endif gp܂";
				break;

		case	STATUS_ENDIF_SYNTAXERROR:
				ptr = "endif ̌ɕsvȕ܂";
				break;

		case	STATUS_THEN_SYNTAXERROR:
				ptr = "then ̒ else  endif u͂ł܂";
				break;

		case	STATUS_CONTINUE_WITHOUT_FOR:
				ptr = "for gĂȂ̂ continue gp܂";
				break;

		case	STATUS_BREAK_WITHOUT_FOR:
				ptr = "for gĂȂ̂ break gp܂";
				break;

		case	STATUS_NEXT_WITHOUT_FOR:
				ptr = "for gĂȂ̂ next gp܂";
				break;

		case	STATUS_FOR_WITHOUT_TO:
				ptr = "for ɑ΂ to ܂";
				break;

		case	STATUS_FORLOOP_STACKOVERFLOW:
				ptr = "for ` next ̃lXg[߂܂";
				break;

		case	STATUS_NEXT_SYNTAXERROR:
				ptr = "next ̌ɕsvȕ܂";
				break;

		case	STATUS_ON_WITHOUT_GOTO:
				ptr = "on ɑ΂ goto ܂ gosub ܂";
				break;

		case	STATUS_UNDEFINED_USERSTATEMENT:
				ptr = "`̃[UXe[ggĂяo܂";
				break;

		case	STATUS_IF_WITHOUT_ENDIF:
				ptr = "if ɑ΂ endif ܂";
				break;

		case	STATUS_FOR_WITHOUT_NEXT:
				ptr = "for ɑ΂ next ܂";
				break;

		case	STATUS_UNDEFINED_LABEL:
				ptr = "Wvɖ`̃xw肳܂";
				break;

		case	STATUS_RETURN_WITHOUT_GOSUB:
				ptr = "gosub gpĂȂ̂ return Ŗ߂낤Ƃ܂";
				break;

		case	STATUS_GOSUB_WITHOUT_RETURN:
				ptr = "gosub gpꂽ񐔕Areturn Ŗ߂Ă܂";
				break;

		case	STATUS_ILLEGAL_FORLOOP:
				ptr = "for xsĂ܂";
				break;

		case	STATUS_FORSTACK_INITERR:
				ptr = "for [ṽX^bN 1 ȏłKv܂";
				break;

		case	STATUS_IFSTACK_INITERR:
				ptr = "if ubÑX^bN 1 ȏłKv܂";
				break;

		case	STATUS_GOSUBSTACK_INITERR:
				ptr = "gosub ̃X^bN 1 ȏłKv܂";
				break;

		case	STATUS_USERSTATEMENT_INITERR:
				ptr = "KʂłȂ[UXe[gge[uɂ܂";
				break;

		case	STATUS_DUPLICATE_LABEL:
				ptr = "̃xɑ݂܂";
				break;

		case	STATUS_INVALID_NULLTERMINATION:
				ptr = "\[XR[hw̒ł͂܂";
				break;

		case	STATUS_UNDEFINED_PARAM:
				ptr = "`̕ϐw肳܂";
				break;

		case	STATUS_OUTOFDATA:
				ptr = "read Xe[ggǂݍ߂f[^܂";
				break;

		case	STATUS_UNDEFINED_DATALABEL:
				ptr = "w胉xȍ~ data Xe[ggAw肵x̂܂";
				break;

		case	STATUS_IF_CMP_ERROR:
				ptr = "if ̏ StrCalc ̃G[܂";
				break;

		case	STATUS_BREAK_CMP_ERROR:
				ptr = "break ̏ StrCalc ̃G[܂";
				break;

		case	STATUS_FOR_INIT_ERROR:
				ptr = "for ̕ϐ StrCalc ̃G[܂";
				break;

		case	STATUS_FOR_CMP_ERROR:
				ptr = "for ̏I StrCalc ̃G[܂";
				break;

		case	STATUS_FOR_STEP_ERROR:
				ptr = "for ̑ StrCalc ̃G[܂";
				break;

		case	STATUS_CONTINUE_CMP_ERROR:
				ptr = "continue ̏ StrCalc ̃G[܂";
				break;

		case	STATUS_ONGOTO_INDEX_ERROR:
				ptr = "on goto Aon gosub ̃CfbNX StrCalc ̃G[܂";
				break;

		case	STATUS_SUBST_ERROR:
				ptr = " StrCalc ̃G[܂";
				break;

		case	STATUS_DIM_ERROR:
				ptr = "dim  StrCalc ̃G[܂";
				break;

		case	STATUS_RETURN_CMP_ERROR:
				ptr = "return ̏ StrCalc ̃G[܂";
				break;

		case	STATUS_END_CMP_ERROR:
				ptr = "end ̏ StrCalc ̃G[܂";
				break;

		case	STATUS_READ_ERROR:
				ptr = "read  StrCalc ̃G[܂";
				break;

		case	STATUS_USERABORT:
				ptr = "AvP[VA܂̓[U璆f߂o܂";
				break;

		/*** [U`̃G[ ***/

		case	STATUS_CHANGEPEN_ERROR:
				ptr = "y̕ϊɃG[܂";
				break;

		default:
				ptr = "bZ[WpӂĂȂ[U`G[܂";
	}

	return ptr;
}

/* WM_USER */
VOID	OnUser(HWND hWnd,INT64 ret)
{
	InvalidateRect(hWnd,NULL,FALSE);
	SetWindowText(hWnd,gpszWinName_stop);

	if (ret != STATUS_NORMAL){
		/* IłȂ΁AG[ebZ[W{bNXŕ\ */
		CHAR		buf[1024];
		LPSTR		ptr;

		ptr = buf + sprintf(buf,"%I64us\r\n",gbas.stop_lineno);

		if (ret <= STATUS_IF_CMP_ERROR && ret >= STATUS_SKIP_ERROR){
			sprintf(ptr,"%s ... %s",
				errormes_StrCalcBASIC(ret),
				errormes_StrCalc(gbas.sc_ret));
		}else{
			if (ret <= STATUS_ERROR && ret >= STATUS_SUBST_SYNTAXERROR)
				sprintf(ptr,"%s",errormes_StrCalc(ret));
			else
				sprintf(ptr,"%s",errormes_StrCalcBASIC(ret));
		}

		MessageBox(hWnd,buf,gpszWinName,MB_OK | MB_ICONHAND);
	}
}
