#include <windows.h>
#include "sc39x64.h"
#include "smpbas.h"

// StrCalc BASIC \[Xt@Cǂݍ
BOOL		SimpleBasic::load_src(LPSTR pfilename)
{
	HANDLE		hFile;
	DWORD		dwRead,dwSize;
	BOOL		bret;

	if (psrc){
		delete []psrc;
		psrc = NULL;
	}

	if ((hFile = CreateFile(pfilename,GENERIC_READ,0,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL)) == INVALID_HANDLE_VALUE)
		return FALSE;

	if ((LONG)(dwSize = GetFileSize(hFile,NULL)) <= 0 ||
		(psrc = (LPSTR)new CHAR [dwSize + 1]) == NULL){
		CloseHandle(hFile);
		return FALSE;
	}
	src_size = (UINT64)dwSize;

	bret = ReadFile(hFile,psrc,dwSize,&dwRead,NULL);
	CloseHandle(hFile);

	if (bret == FALSE || dwRead < dwSize){
		delete []psrc;
		psrc = NULL;

		return FALSE;
	}

	psrc[dwSize] = 0;
	return TRUE;
}
