#include <windows.h>
#include <stdio.h>
#include <mbstring.h>
#include <conio.h>
#include "sc39x64.h"
#include "smpbas.h"
#include "callback.h"

#define STATUS_OTHERCHECK		-2147483647

// 󔒁E^u΂
static LPSTR	jmp_space(LPSTR ptr)
{
	do{
		ptr++;
	}while(isspace(*ptr));

	return ptr;
}

// 
static VOID		lend(HANDLE hStdout)
{
	DWORD			dwWrite;
	static CHAR		cRet = '\n';

	WriteConsole(hStdout,&cRet,1,&dwWrite,0);
}

static LPSTR	singlequote(LPSTR ptr)
{
	LPSTR	ps = ptr;
	INT64	temp,cnt;

	temp = *ptr;
	for(cnt = 3;*++ptr && (*ptr != '\'' || temp == '\\') && cnt;cnt--)
		temp = (temp == '\\')? 0 : *ptr;

	return (cnt)? ptr : ps + 1;
}

// _uNH[gŊꂽ̏
static INT64	doublequote(LPSTR *ppstr,HANDLE hStdout)
{
	LPSTR	pstart,ptr = *ppstr;
	DWORD	dwWrite;

	pstart = ++ptr;
	while(*ptr && *ptr != '\"'){
		if (*ptr == '\''){
			ptr = singlequote(ptr);
			ptr += (*ptr != 0);
		}else
			ptr = (LPSTR)_mbsinc((LPBYTE)ptr);
	}

	WriteConsole(hStdout,pstart,(DWORD)(ptr - pstart),&dwWrite,0);

	ptr += *ptr != 0;
	while(isspace(*ptr))
		ptr++;

	if (*ptr && *ptr != ';')
		return STATUS_ERROR;

	*ppstr = ptr;
	return STATUS_NORMAL;
}

// insspc
static INT64	insspc(PSTRCALC_PARAM prm,LPSTR *ppstr,HANDLE hStdout)
{
	LPSTR	ptr = *ppstr;
	INT64	ret;
	INT		t;

	if (_strnicmp(ptr,"insspc",6) || !isspace(ptr[6]))
		return STATUS_OTHERCHECK;

	ptr = StrCalc_search_char(
			prm->str = (ptr += 6 + 1),";");
	t = *ptr;
	*ptr = 0;

	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;
	*(*ppstr = ptr) = (CHAR)t;

	if ((t = (INT)prm->ans) < 0) // ̏ꍇ̓G[
		return STATUS_ILLEGALFUNCTIONCALL;
	else if (t){
		LPSTR		pdest;
		DWORD		dwWrite;

		if ((pdest = (LPSTR)malloc(t)) == NULL)
			return STATUS_NOTENOUGHMEM;
		memset(pdest,' ',t);

		WriteConsole(hStdout,pdest,t,&dwWrite,0);

		free(pdest);
	}

	return STATUS_NORMAL;
}

// chr
static INT64	character(PSTRCALC_PARAM prm,LPSTR *ppstr,HANDLE hStdout)
{
	LPSTR	ptr = *ppstr;
	DWORD	dwWrite;
	CHAR	c;
	INT64	t,ret;

	if (_strnicmp(ptr,"chr",3) || !isspace(ptr[3]))
		return STATUS_OTHERCHECK;

	ptr = StrCalc_search_char(
			prm->str = (ptr += 3 + 1),";");
	t = *ptr;
	*ptr = 0;

	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;
	*(*ppstr = ptr) = (CHAR)t;

	c = (BYTE)prm->ans;
	WriteConsole(hStdout,&c,1,&dwWrite,0);

	return STATUS_NORMAL;
}

// str
static INT64	string(PSTRCALC_PARAM prm,LPSTR *ppstr,HANDLE hStdout)
{
	LPSTR			ptr = *ppstr,pdest;
	CHAR			buf[SC_MAX_PARAMNAME+1];
	PARAM_INFO		pi;
	INT64			len,i;
	DWORD			dwWrite;

	if (_strnicmp(ptr,"str",3) || !isspace(ptr[3]))
		return STATUS_OTHERCHECK;

	// ϐ𒊏o
	ptr += 3 + 1;
	len = SC_MAX_PARAMNAME;
	for(pdest = buf;*ptr && *ptr != ';';ptr++){
		if (isspace(*ptr))
			continue;

		if (!len)
			break;
		*pdest++ = *ptr;
		len--;
	}
	*pdest = 0;
	*ppstr = ptr; // |C^Ăяo֔f

	// ؂蕶łȂꍇ̓G[
	if (*ptr && *ptr != ';')
		return STATUS_ILLEGAL_PARAMNAME;

	// ϐꎟzł͂Ȃꍇ̓G[
	if (!StrCalc_search_param(prm,buf,&pi) || pi.type != PRM_DIM1)
		return STATUS_ILLEGAL_PARAMNAME;

	// ꎟz̓e𕶎ƌȂ

	for(len = 0;len < pi.width;len++){ // 𒲂ׂ
		if (pi.pval[len] == 0.0) //  0 Ƃ
			break;
	}

	if (!len) //  0 ̏ꍇ͏I
		return STATUS_NORMAL;

	pdest = new CHAR [len]; // f[^i[p
	if (!pdest)
		return STATUS_NOTENOUGHMEM;

	// zf[^ char ^ɕϊ
	i = 0;
	do{
		pdest[i] = (BYTE)pi.pval[i];
	}while(++i < len);

	WriteConsole(hStdout,pdest,(DWORD)len,&dwWrite,0);
	delete []pdest;

	return STATUS_NORMAL;
}

// ftHg
static INT64	defaultproc(PSTRCALC_PARAM prm,LPSTR *ppstr,HANDLE hStdout)
{
	LPSTR		ptr = *ppstr;
	CHAR		buf[32];
	INT64		t,ret;
	DWORD		dwWrite,lout;

	/*
	  ݈ʒu`Z~R܂͖܂ł͈̔͂vZA
	  ŕ\
	*/
	ptr = StrCalc_search_char(prm->str = ptr,";");
	t = *ptr;
	*ptr = 0;

	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;
	*(*ppstr = ptr) = (CHAR)t;

	lout = sprintf(buf,"%.16G",prm->ans);
	WriteConsole(hStdout,buf,lout,&dwWrite,0);

	return STATUS_NORMAL;
}

// print Xe[gg
INT64	usr_print(PSTRCALC_PARAM prm,LPSTR ptr,INT64 len,HANDLE hStdout)
{
	INT64	ret,loop;

	len;
	loop = 1;

	do{
		switch(*ptr){
			case	0:
					lend(hStdout);
					loop = 0;
					break;

			case	'\t':
			case	' ':
					ptr = jmp_space(ptr);
					break;

			case	'\"':
					ret = doublequote(&ptr,hStdout);
					if (ret != STATUS_NORMAL)
						return ret;
					break;

			case	';':
					if (!*(ptr = jmp_space(ptr)))
						loop = 0;
					break;

			case	'i':
			case	'I':
					ret = insspc(prm,&ptr,hStdout);
					if (ret == STATUS_NORMAL)
						break;
					else if (ret != STATUS_OTHERCHECK)
						return ret;
					ret = defaultproc(prm,&ptr,hStdout);
					if (ret != STATUS_NORMAL)
						return ret;
					break;

			case	's':
			case	'S':
					ret = string(prm,&ptr,hStdout);
					if (ret == STATUS_NORMAL)
						break;
					else if (ret != STATUS_OTHERCHECK)
						return ret;
					ret = defaultproc(prm,&ptr,hStdout);
					if (ret != STATUS_NORMAL)
						return ret;
					break;

			case	'c':
			case	'C':
					ret = character(prm,&ptr,hStdout);
					if (ret == STATUS_NORMAL)
						break;
					else if (ret != STATUS_OTHERCHECK)
						return ret;

			default:
					ret = defaultproc(prm,&ptr,hStdout);
					if (ret != STATUS_NORMAL)
						return ret;
					break;
		}
	}while(loop);

	return STATUS_NORMAL;
}

