#include <windows.h>
#include <ctype.h>
#include "sc39x64.h"
#include "textedit.h"
#include "cio.h"

/* ӂ̕񂩂ϐ̃|C^擾 */
static INT64	get_leftside(
					PSTRCALC_PARAM		prm,
					LPSTR				*ppstr,
					INT64				btemp,
					double				**ppval)
{
	LPSTR		pdest,ptr,pstop;
	INT64		cnt,ret,x,y;
	UINT64		type;
	PARAM_INFO	pi;

	/* ϐ擾 */
	ptr = *ppstr;
	cnt = SC_MAX_PARAMNAME;
	for(pdest = pi.name;*ptr && !StrCalc_issep(*ptr);ptr++){
		if (isspace(*ptr))
			continue;
		if (!cnt)
			break;
		*pdest++ = *ptr;
		cnt--;
	}
	*pdest = 0;

	/* 㑱؂蕶ł͂Ȃꍇ */
	if (!StrCalc_issep(*ptr))
		return STATUS_ILLEGAL_PARAMNAME;

	/* CR[̌ */
	if (*(pstop = StrCalc_search_char(ptr,"=")) == 0)
		return STATUS_NEED_EQUAL;

	/*
	  J}̍ہAEӂ܂ōsȂlɁACR[̈ʒuŊm
	  ~܂悤ɂĂ
	*/
	*pstop = 0;

	x = y = 0;
	if (*ptr == '('){ /* z̏ꍇ */
		double		args[2] = {0};

		if (*(StrCalc_search_char(ptr + 1,",")) == ',')
			type = PRM_DIM2; /* J}ꍇ͓񎟌z */
		else
			type = PRM_DIM1; /* J}ꍇ͈ꎟz */

		/* ̌vZ */
		ret = StrCalc_get_parenargs(prm,&ptr,args,type - PRM_SINGLE);
		if (ret != STATUS_NORMAL)
			return ret;

		/*
		  I[̊ʂƃCR[̊ԂɕԓA
		  㑱̕ʒuCR[̈ʒuł͂Ȃꍇ
		*/
		while(isspace(*ptr))
			ptr++;
		if (ptr != pstop)
			return STATUS_ERROR;

		x = (INT)args[0];
		y = (INT)args[1];

		if (!StrCalc_search_param(prm,pi.name,&pi)) /* AhX擾 */
			return STATUS_ILLEGAL_PARAMNAME;

	}else{ /* Pϐ̏ꍇ */
		type = PRM_SINGLE;
		if (!StrCalc_search_param(prm,pi.name,&pi)){

			/* ɑ݂ȂPϐw肳ꂽꍇ */
			pi.type = PRM_SINGLE;
			pi.btempflg = btemp;
			switch(StrCalc_new_param(prm,&pi)){ /* VK */
				case	-1: return STATUS_ILLEGAL_PARAMNAME;
				case	0: return STATUS_NOTENOUGHMEM;
			}

			StrCalc_search_param(prm,pi.name,&pi); /* AhXĎ擾 */
		}
	}

	if (pi.type != type) /* o^ϐƋLqقȂꍇ */
		return STATUS_ILLEGAL_PARAMNAME;

	/* wʒuvZ */
	*ppval = pi.pval;
	switch(type){
		case	PRM_DIM2:
				if (y < 0 || y >= pi.height)
					return STATUS_PARAM_RANGEOVER;
				*ppval += y * pi.width;

		case	PRM_DIM1:
				if (x < 0 || x >= pi.width)
					return STATUS_PARAM_RANGEOVER;
				*ppval += x;
	}

	*ppstr = pstop; /*
					ŏIʒuiCR[̏ꏊjԂ
					CR[kŒׂĂ鎖ɒ
					*/

	return STATUS_NORMAL;
}

static INT64	cb_eval(LPSTR psrc,UINT64 len,BOOL bfinish,PMEMINFO pi)
{
	if (bfinish == TRUE) /* s̉s͏o͂Ȃ */
		return STATUS_NORMAL;

	return (textedit_chain(pi,psrc,len) == FALSE)? /* textedit\chain.c */
		STATUS_NOTENOUGHMEM : STATUS_NORMAL;
}

/* @eval Xe[gg */
DECLARE INT64	usr_eval(
					PSTRCALC_PARAM		prm,
					LPSTR				ptr,
					INT64				len,
					PBASICPARAM			pbas)
{
	MEMINFO		mi;
	double		*pval;
	INT64		ret;

	/*  */
	ret = get_leftside(prm,&ptr,pbas->b_localparam,&pval);
	if (ret != STATUS_NORMAL)
		return ret;

	/* Eӂ̕񎮂ҏW */
	mi.pmem = NULL;
	ret = text_edit(
			prm,
			++ptr,
			(TEXTEDIT_CALLBACK)cb_eval,
			&mi);
	if (ret != STATUS_NORMAL){
		textedit_free(&mi);
		return ret;
	}

	if (!mi.pmem){
		*pval = 0.0;
		return STATUS_NORMAL;
	}

	ret = StrCalc_n(prm,mi.pmem,mi.use);

	textedit_free(&mi);

	if (ret != STATUS_NORMAL)
		return ret;

	*pval = prm->ans;

	return STATUS_NORMAL;
}

#define NAME_RETCODE		"sc_retcode"

/* @strcalc Xe[gg */
DECLARE INT64	usr_strcalc(
					PSTRCALC_PARAM		prm,
					LPSTR				ptr,
					INT64				len,
					PBASICPARAM			pbas)
{
	MEMINFO			mi;
	double			*pval;
	INT64			ret;
	PARAM_INFO		inf;

	/*  */
	ret = get_leftside(prm,&ptr,pbas->b_localparam,&pval);
	if (ret != STATUS_NORMAL)
		return ret;

	/* Eӂ̕񎮂ҏW */
	mi.pmem = NULL;
	ret = text_edit(
			prm,
			++ptr,
			(TEXTEDIT_CALLBACK)cb_eval,
			&mi);
	if (ret != STATUS_NORMAL){
		textedit_free(&mi);
		return ret;
	}

	if (mi.pmem){
		ret = StrCalc_n(prm,mi.pmem,mi.use);
		textedit_free(&mi);
		*pval = prm->ans;
	}else{
		*pval = 0.0;
		ret = STATUS_NORMAL;
	}

	if (StrCalc_search_param(prm,NAME_RETCODE,&inf))
		StrCalc_delete_param(prm,NAME_RETCODE);

	strcpy(inf.name,NAME_RETCODE);
	inf.type = PRM_SINGLE;
	inf.btempflg = pbas->b_localparam;
	StrCalc_new_param(prm,&inf);
	StrCalc_search_param(prm,NAME_RETCODE,&inf);

	*inf.pval = (double)ret;

	return STATUS_NORMAL;
}
