#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include "sc39x64.h"
#include "fio.h"
#include "local.h"

/* t@C̃N[Y */
DECLARE INT64	usr_close(
					PSTRCALC_PARAM		prm,
					LPSTR				ptr,
					INT64				len,
					FILE				**fptbl)
{
	INT64		i;
	double		val;

	if (*ptr != '#')
		return STATUS_CLOSE_INVALIDFILENO;

	ptr++;
	if (StrCalc_getargs(prm,&ptr,&val,1) != STATUS_NORMAL ||
		(i = (INT64)val) <= 0 || i > MAX_FILE ||
		fptbl[--i] == NULL)
		return STATUS_CLOSE_INVALIDFILENO;

	if (*ptr)
		return STATUS_CLOSE_SYNTAXERROR;

	fclose(fptbl[i]);
	fptbl[i] = NULL;

	return STATUS_NORMAL;
}

/* t@CSăN[Y */
DECLARE VOID		fio_close(FILE **fptbl)
{
	INT64		i;

	for(i = 0;i < MAX_FILE;i++)
		if (fptbl[i]){
			fclose(fptbl[i]);
			fptbl[i] = NULL;
		}
}
