#include <windows.h>
#include "sc39x64.h"
#include "gio.h"
#include "local.h"

/* hԂ */
DECLARE INT64	usr_fill(
					PSTRCALC_PARAM		prm,
					LPSTR				arg,
					INT64				len,
					LPVOID				dmy)
{
	double		val[3];
	HBRUSH		hBrush,hOldBrush;
	INT64		ret;
	INT			x,y,color;

	if ((ret = StrCalc_getargs(prm,&arg,val,3)) != STATUS_NORMAL)
		return ret;

	if (*arg)
		return STATUS_INVALIDARGS;

	if ((x = (INT)val[0]) < 0)
		x = 0;
	else if (x >= gnWidth)
		x = gnWidth - 1;
	if ((y = (INT)val[1]) < 0)
		y = 0;
	else if (y >= gnHeight)
		y = gnHeight - 1;

	color = GetPixel(ghDC,x,y);
	hBrush = CreateSolidBrush((INT)val[2]);

	hOldBrush = SelectObject(ghDC,hBrush);
	ExtFloodFill(ghDC,x,y,color,FLOODFILLSURFACE);
	SelectObject(ghDC,hOldBrush);

	DeleteObject(hBrush);

#ifdef SHOW_PROGRESS
	BitBlt(
		ghDC_main,
		0,0,
		gnWidth,gnHeight,
		ghDC,
		0,0,
		SRCCOPY);
#endif

	return STATUS_NORMAL;
}
