#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdio.h>
#include <string.h>
#include "sc39x64.h"
#include "simple.h"
#include "resource.h"

/* Xgr[̃JZbg */
VOID	SetColumn(HWND hWnd)
{
	LV_COLUMN		lvc;
	HWND			hList = GetDlgItem(hWnd,IDC_LIST1);

	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvc.fmt = LVCFMT_LEFT;

	lvc.iSubItem = 0;

	lvc.pszText = "ϐ"; lvc.cchTextMax = 7;
	lvc.cx = 200;
	ListView_InsertColumn(hList,lvc.iSubItem,&lvc);

	lvc.pszText = "e"; lvc.cchTextMax = 4;
	lvc.cx = 120;
	ListView_InsertColumn(hList,++lvc.iSubItem,&lvc);
}

/* ϐXg̍XV */
VOID	UpdateList(HWND hWnd,PPARAM_INFO pinf)
{
	HWND		hList;
	CHAR		buf[SC_MAX_PARAMNAME+3];
	INT			i,cnt;
	LV_ITEM		lvi;

	hList = GetDlgItem(hWnd,IDC_LIST1);

	/* ϐvs */
	cnt = ListView_GetItemCount(hList);
	for(i = 0;i < cnt;i++){
		ListView_GetItemText(hList,i,0,buf,sizeof(buf));

		/* vꍇAڂ̍ځiejXV */
		if (!_stricmp(buf,pinf->name)){
			sprintf(buf,"%.16G",*pinf->pval);
			ListView_SetItemText(hList,i,1,buf);
			return;
		}
	}

	/* vsꍇ͐VK */

	lvi.mask = LVIF_TEXT;
	lvi.iSubItem = 0;

	lvi.iItem = cnt;
	lvi.pszText = pinf->name;
	lvi.cchTextMax = (INT)strlen(lvi.pszText) + 1;
	lvi.iItem = ListView_InsertItem(hList,&lvi);

	lvi.cchTextMax = sprintf(buf,"%.16G",*pinf->pval) + 1;
	lvi.pszText = buf;
	lvi.iSubItem++;
	ListView_SetItem(hList,&lvi);
}

/* ϐ̍폜 */
VOID	DeleteParam(HWND hWnd)
{
	HWND			hList;
	CHAR			name[SC_MAX_PARAMNAME+3];
	INT				i,cnt,ret;

	hList = GetDlgItem(hWnd,IDC_LIST1);

	/* IĂϐSč폜 */

	if ((cnt = ListView_GetSelectedCount(hList)) == 0){
		MessageBox(hWnd,"폜Ώۂ̕ϐIĂ܂",
			gpszWinName,MB_OK | MB_ICONHAND);
		return;
	}

	if (MessageBox(hWnd,"IĂϐ폜܂B낵łH",
		gpszWinName,MB_YESNO | MB_ICONQUESTION) == IDNO)
		return;

	while((i = ListView_GetNextItem(hList,-1,LVNI_SELECTED)) >= 0){
		ListView_GetItemText(hList,i,0,name,sizeof(name));

		/*
		  -1 ́AϐKʂł͂ȂꍇA֐E萔폜悤Ƃ
		  ꍇɕԂ܂B
		  Xgɂϐ͑SĐ̂ł͂łAÔ߃G[
		  `FbN͍s܂B
		*/
		switch(StrCalc_delete_param(&gsc,name)){
			case	-1:
					ret = STATUS_MEMERROR;
					break;

			case	0:
					ret = STATUS_NOTENOUGHMEM;
					break;

			default:
					ret = STATUS_NORMAL;
		}
		if (ret != STATUS_NORMAL){
			MessageBox(hWnd,errormes_StrCalc(ret),
				gpszWinName,MB_OK | MB_ICONHAND);
			return;
		}
		ListView_DeleteItem(hList,i); /* Xg폜 */
	}
}

static VOID		DrawItemColumn(HDC hdc,LPTSTR lpsz,LPRECT prcClip)
{
	const LPSTR		szEllipsis = "...";
	SIZE			sizeString,sizeEllipsis;
	INT				len;
	UINT			uColWidth;
	CHAR			szTemp[LVDRAW_MAXSTR+1];

	uColWidth = prcClip->right - prcClip->left - 4;
	len = (INT)strlen(lpsz);
	if (!GetTextExtentPoint32(hdc,lpsz,len,&sizeString))
		return;

	if ((ULONG)sizeString.cx <= uColWidth){
		ExtTextOut(hdc,prcClip->left + 2,prcClip->top + 1,
			ETO_CLIPPED | ETO_OPAQUE,prcClip,lpsz,len,0);
		return;
	}

	if (!GetTextExtentPoint32(hdc,szEllipsis,(INT)strlen(szEllipsis),
		&sizeEllipsis))
		return;

	strcpy(szTemp,lpsz);
	while(len > 0){
		szTemp[--len] = 0;
		if (!GetTextExtentPoint32(hdc,szTemp,len,&sizeString))
			return;

		if ((ULONG)(sizeString.cx + sizeEllipsis.cx) <= uColWidth &&
			LVDRAW_MAXSTR >= (INT)(len + strlen(szEllipsis))){
			strcat(szTemp,szEllipsis);
			ExtTextOut(hdc,prcClip->left + 2,prcClip->top + 1,
				ETO_CLIPPED | ETO_OPAQUE,prcClip,szTemp,
				(UINT)strlen(szTemp),0);
			return;
		}
	}
}

/* Xgr[̃I[i[` */
VOID	DrawListViewItem(LPDRAWITEMSTRUCT lpDrawItem)
{
	CHAR			lpszString[LVDRAW_MAXSTR+1];
	INT				cxImage = 0,cyImage = 0,i;
	RECT			rcClip;
	UINT			uFirstColWidth,uiFlags = ILD_TRANSPARENT;
	HIMAGELIST		himl;
	LV_ITEM			lvi;
	LV_COLUMN		lvc;

	lvi.mask = LVIF_IMAGE | LVIF_STATE;
	lvi.iItem = lpDrawItem->itemID;
	lvi.iSubItem = 0;
	ListView_GetItem(lpDrawItem->hwndItem,&lvi);

	if (lpDrawItem->itemState & ODS_SELECTED){
		SetTextColor(lpDrawItem->hDC,GetSysColor(COLOR_HIGHLIGHTTEXT));
		SetBkColor(lpDrawItem->hDC,GetSysColor(COLOR_HIGHLIGHT));
		uiFlags |= ILD_BLEND50;
	}else if (!IsWindowEnabled(lpDrawItem->hwndItem)){
		SetTextColor(lpDrawItem->hDC,GetSysColor(COLOR_GRAYTEXT));
		SetBkColor(lpDrawItem->hDC,GetSysColor(COLOR_3DFACE));
	}else{
		SetTextColor(lpDrawItem->hDC,GetSysColor(COLOR_WINDOWTEXT));
		SetBkColor(lpDrawItem->hDC,GetSysColor(COLOR_WINDOW));
	}

	if ((himl = ListView_GetImageList(
		lpDrawItem->hwndItem,LVSIL_SMALL)) != 0){
		ImageList_Draw(himl,lvi.iImage,lpDrawItem->hDC,
			lpDrawItem->rcItem.left,lpDrawItem->rcItem.top,uiFlags);
		ImageList_GetIconSize(himl,&cxImage,&cyImage);
    }

	uFirstColWidth = ListView_GetColumnWidth(lpDrawItem->hwndItem,0) - cxImage;

	rcClip.left = lpDrawItem->rcItem.left + cxImage;
	rcClip.top = lpDrawItem->rcItem.top;
	rcClip.bottom = lpDrawItem->rcItem.bottom;
	rcClip.right = lpDrawItem->rcItem.left + 
		ListView_GetColumnWidth(lpDrawItem->hwndItem,0);

	lvc.mask = LVCF_FMT | LVCF_WIDTH;
	for(i = 0;ListView_GetColumn(lpDrawItem->hwndItem,i,&lvc);i++){
		*lpszString = 0;
		ListView_GetItemText(lpDrawItem->hwndItem,lpDrawItem->itemID,i,
			lpszString,LVDRAW_MAXSTR);
		DrawItemColumn(lpDrawItem->hDC,lpszString,&rcClip);
		rcClip.left = rcClip.right;
		rcClip.right = rcClip.left + 
			ListView_GetColumnWidth(lpDrawItem->hwndItem,i + 1);
	}

	if (lpDrawItem->itemState & ODS_SELECTED){
		SetTextColor(lpDrawItem->hDC,GetSysColor(COLOR_WINDOWTEXT));
		SetBkColor(lpDrawItem->hDC,GetSysColor(COLOR_WINDOW));
	}

	if (lpDrawItem->itemState & ODS_FOCUS){
		rcClip = lpDrawItem->rcItem; rcClip.left += cxImage;
		DrawFocusRect(lpDrawItem->hDC,&rcClip);
	}
}

