#include <windows.h>
#include "sc39x64.h"
#include "simple.h"
#include "resource.h"

static LRESULT CALLBACK		DialogProc(
								HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	PAINTSTRUCT		ps;
	LPSTR			pret;

	switch(Msg){
		case	WM_INITDIALOG:
				if ((pret = OnInitDialog(hWnd)) != 0){ /* init.c */
					MessageBox(hWnd,pret,gpszWinName,MB_OK | MB_ICONHAND);
					EndDialog(hWnd,IDCANCEL);
				}
				break;

		case	WM_PAINT:
				BeginPaint(hWnd,&ps); EndPaint(hWnd,&ps);
				break;

		case	WM_CLOSE:
				StrCalc_term(&gsc); /* StrCalc ̏I */
				EndDialog(hWnd,IDOK);
				break;

		case	WM_COMMAND:
				switch(LOWORD(wParam)){
					case	IDC_CALC:
							OnOK(hWnd); /* calc.c */
							break;

					case	IDC_PARAM_ADD:
							CreateParam(hWnd); /* param.c */
							break;

					case	IDC_PARAM_DEL:
							DeleteParam(hWnd); /* list.c */
							break;
				}
				break;

		case	WM_DRAWITEM:
				DrawListViewItem((LPDRAWITEMSTRUCT)lParam); /* list.c */
				break;

		default:
				return FALSE;
	}
	return TRUE;
}

INT WINAPI		WinMain(
					HINSTANCE		hInstance,
					HINSTANCE		hPrevInstance,
					LPSTR			pszArgv,
					INT				nCmdShow)
{
	HWND		hWnd = GetDesktopWindow();

	ghInst = hInstance;

	if (DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),
		hWnd,(DLGPROC)DialogProc) < 0){
		MessageBox(hWnd,"EChE̍쐬Ɏs܂B",
			gpszWinName,MB_OK | MB_ICONHAND);
	}
	return 0;
}
