#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include "sc39x64.h"
#include "test.h"

/* \[Xt@C̓ǂݍ */
char	*load_src(char *filename,unsigned __int64 *psize)
{
	FILE		*fp;
	char		*ptr;
	size_t		ret,size;

	if ((fp = fopen(filename,"rb")) == NULL)
		return NULL;

	if ((long)(size = _filelength(_fileno(fp))) <= 0 ||
		(ptr = (char *)malloc(size + 1)) == NULL)
	{
		fclose(fp);
		return NULL;
	}
	*psize = size;

	ret = fread(ptr,1,size,fp);
	fclose(fp);

	if (ret < size){
		free(ptr);
		return NULL;
	}

	ptr[size] = 0;
	return ptr;
}
