#include <windows.h>
#include <process.h>
#include <stdio.h>
#include "sc39x64.h"
#include "resource.h"

typedef UINT	(*THREAD_ROUTINE)(LPVOID);

HANDLE			ghStop,ghThread;
STRCALC_PARAM	gsc;
BASICPARAM		gbas;

/* f̊Ď */
INT64	abortfunc(PSTRCALC_PARAM prm,LPVOID param)
{
	return (WaitForSingleObject(ghStop,250) == WAIT_OBJECT_0)?
		STATUS_USERABORT : STATUS_NORMAL;
}

/* @print */
INT64	usr_print(PSTRCALC_PARAM prm,LPSTR arg,INT64 len,HWND hWnd)
{
	INT64	ret;

	prm->str = arg;
	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;

	/* eLXgRg[֏o */
	SetDlgItemInt(hWnd,IDC_OUTPUT,(DWORD)prm->ans,FALSE);

	return STATUS_NORMAL;
}

/* BASIC Xbh */
UINT 	basic_thread(HWND hWnd)
{
	INT64		ret;

	ret = StrCalc_BASIC(&gsc,&gbas);

	if (ret == STATUS_USERABORT)
		SetDlgItemText(hWnd,IDC_OUTPUT,"f");
	else if (ret != STATUS_NORMAL)
		SetDlgItemText(hWnd,IDC_OUTPUT,"G[");

	return 0;
}

/* WM_CLOSE */
VOID	OnClose(HWND hWnd)
{
	CloseHandle(ghThread);
	CloseHandle(ghStop);
	StrCalc_term(&gsc);
}

USERSTATEMENT		table[] = {
	{ "print", 5, usr_print, NULL },
};

/* WM_INITDIALOG */
BOOL	OnInitDialog(HWND hWnd)
{
	if (!StrCalc_init(&gsc))
		return FALSE;

	gbas.stackcnt_if =
	gbas.stackcnt_for =
	gbas.stackcnt_gosub = 16;

	gbas.fevery = (APPPROC)abortfunc;

	table[0].param = hWnd;
	gbas.pus = table;
	gbas.uscnt = sizeof(table) / sizeof(USERSTATEMENT);

	gbas.psource = "\
			i = 0\n\
		$endless\n\
			@print i : i = i + 1\n\
			goto $endless\n\
	";
	gbas.src_size = strlen(gbas.psource);

	ghStop = CreateEvent(NULL,TRUE,FALSE,NULL);
	if (!ghStop){
		StrCalc_term(&gsc);
		return FALSE;
	}

	ghThread = (HANDLE)_beginthreadex(
						NULL,
						0,
						(THREAD_ROUTINE)basic_thread,
						hWnd,
						0,
						NULL);
	if (!ghThread){
		CloseHandle(ghStop);
		StrCalc_term(&gsc);
		return FALSE;
	}

	return TRUE;
}

LRESULT CALLBACK	DlgProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	PAINTSTRUCT		ps;

	switch(Msg){
		case	WM_PAINT:
				BeginPaint(hWnd,&ps);
				EndPaint(hWnd,&ps);
				break;

		case	WM_INITDIALOG:
				if (OnInitDialog(hWnd) == FALSE)
					EndDialog(hWnd,IDOK);
				break;

		case	WM_CLOSE:
				if (WaitForSingleObject(ghThread,150) != WAIT_OBJECT_0){
					SetEvent(ghStop);
					PostMessage(hWnd,WM_CLOSE,wParam,lParam);
					break;
				}
				OnClose(hWnd);
				EndDialog(hWnd,IDOK);
				break;

		case	WM_COMMAND:
				if (LOWORD(wParam) == IDOK){ /* f{^NbN */
					SetEvent(ghStop);
					EnableWindow((HWND)lParam,FALSE);
				}
				break;

		default:
				return FALSE;
	}

	return TRUE;
}

INT WINAPI		WinMain(
					HINSTANCE		hInstance,
					HINSTANCE		hPrevInstance,
					LPSTR			pszArgv,
					INT				nCmdShow)
{
	DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),
		NULL,(DLGPROC)DlgProc);
	return 0;
}

