#include <stdio.h>
#include "sc39x64.h"
#include "test.h"

/* ϐ̕\ */
void	disp_param(PPARAM_INFO pinf)
{
	__int64		i,j,k;

	switch(pinf->type){
		case	PRM_SINGLE:
				printf("P   %s\n",pinf->name);
				printf("val : %.16G\n",*pinf->pval);
				return;

		case	PRM_DIM1:
				printf("ꎟz  %s\n",pinf->name);
				printf("val : \n");
				for(i = 0;i < pinf->width;i++)
					printf("\t(%I64d) = %.16G\n",i,pinf->pval[i]);
				return;

		case	PRM_DIM2:
				printf("񎟌z  %s\n",pinf->name);
				printf("val : \n");
				for(i = k = 0;i < pinf->height;i++,k += pinf->width)
					for(j = 0;j < pinf->width;j++)
						printf("\t(%I64d,%I64d) = %.16G\n",
							j,i,pinf->pval[k + j]);
				return;
	}
	printf("G[ : %I64d\n",pinf->type);
}
