#include <stdio.h>
#include <string.h>
#include "sc39.h"

void	main(void)
{
	STRCALC_PARAM		prm;
	PARAM_INFO			inf;
	int 				ret;

	if (!StrCalc_init(&prm)){
		printf("̊mۂɎs܂\n");
		return;
	}

	inf.type = PRM_SINGLE; /* Pϐ */
	strcpy(inf.name,"test_param"); /* ϐ */
	inf.btempflg = 0; /* e| */

	/* ϐ쐬o^Ǎœo^ꂽϐ̎̂܂ */
	if (StrCalc_new_param(&prm,&inf) <= 0 ||
		!StrCalc_search_param(&prm,"test_param",&inf)){
		StrCalc_term(&prm);
		printf("ϐ̓o^Ɏs܂\n");
		return;
	}

	/* ϐ̎̂ɒlZbg܂ */
	*inf.pval = 4.53; /* test_param = 4.53 */

	/* ϐ̓emFĂ݂ */
	prm.str = "test_param";
	if ((ret = StrCalc(&prm)) != STATUS_NORMAL){
		StrCalc_term(&prm);
		printf("error.  %d\n",ret);
		return;
	}
	printf("test_param : %.16G\n",prm.ans);

	/* ϐvZŎgpĂ݂܂ */
	prm.str = "sin(test_param)^2 + cos(test_param)^2";
	ret = StrCalc(&prm);

	StrCalc_term(&prm);

	if (ret != STATUS_NORMAL)
		printf("error.  %d\n",ret);
	else
		printf("ans. : %.16G\n",prm.ans);
}
