#include <stdio.h>
#include <string.h>
#include "sc39x64.h"

__int64		set_param(PSTRCALC_PARAM );
void		print_param(PSTRCALC_PARAM );

char		*param_tbl[] = {
	"alpha", "bravo", "charlie", "delta", "echo", 0
};

void	main(void)
{
	STRCALC_PARAM		prm;

	if (!StrCalc_init(&prm)){
		printf("̊mۂɎs܂\n");
		return;
	}

	/* e[u̕ϐo^܂ */
	if (!set_param(&prm)){
		StrCalc_term(&prm);
		printf("ϐ̓o^Ɏs܂\n");
		return;
	}

	/* o^󋵂mFĂ݂ */
	printf("\no^\n");
	print_param(&prm);
	printf("\n");

	/* ϐalpha Acharlie 폜܂ */
	if (StrCalc_delete_param(&prm,"alpha") <= 0 ||
		StrCalc_delete_param(&prm,"charlie") <= 0){
		StrCalc_term(&prm);
		printf("ϐ폜Ɏs܂\n");
		return;
	}

	/* 폜̏󋵂mFĂ݂ */
	printf("\n폜\n");
	print_param(&prm);

	StrCalc_term(&prm);
}

/* e[u̕ϐo^ */
__int64		set_param(PSTRCALC_PARAM prm)
{
	PARAM_INFO		inf;
	char			**pptbl;

	inf.type = PRM_SINGLE; /* Pϐ */
	inf.btempflg = 0; /* e| */

	pptbl = param_tbl;
	do{
		strcpy(inf.name,*pptbl);
		if (StrCalc_new_param(prm,&inf) <= 0)
			return 0;
	}while(*++pptbl);

	return 1;
}

/* ϐe̊mF */
void		print_param(PSTRCALC_PARAM prm)
{
	char		**pptbl;
	__int64		ret;

	pptbl = param_tbl;
	do{
		printf("%s : ",prm->str = *pptbl);
		if ((ret = StrCalc(prm)) == STATUS_NORMAL && prm->ans == 0.0)
			printf("o^\n");
		else if (ret == STATUS_ILLEGALNUM_STR)
			printf("݂\n");
		else
			printf("G[  %I64d\n",ret);
	}while(*++pptbl);
}
