#include <stdio.h>
#include <string.h>
#include "sc39.h"

int 		set_param(PSTRCALC_PARAM );
void		print_param(PSTRCALC_PARAM );

typedef struct {
	char		*name;
	int 		btemp;
} PRMTBL,*PPRMTBL;

PRMTBL		param_tbl[] = {
	{ "alpha", 0 },
	{ "bravo", 0 },
	{ "charlie", 1 }, /* temp */
	{ "delta", 1 },   /* temp */
	{ "echo", 0 },
};

void	main(void)
{
	STRCALC_PARAM		prm;

	if (!StrCalc_init(&prm)){
		printf("̊mۂɎs܂\n");
		return;
	}

	/* e[u̕ϐo^܂ */
	if (!set_param(&prm)){
		StrCalc_term(&prm);
		printf("ϐ̓o^Ɏs܂\n");
		return;
	}

	/* o^󋵂mFĂ݂ */
	printf("\no^\n");
	print_param(&prm);
	printf("\n");

	/*
	  e|ϐ̂ݍ폜܂B
	  ł charlie  delta 폜܂
	*/
	if (!StrCalc_delete_tempparam(&prm)){
		StrCalc_term(&prm);
		printf("ϐ폜Ɏs܂\n");
		return;
	}

	/* 폜̏󋵂mFĂ݂ */
	printf("\n폜\n");
	print_param(&prm);

	StrCalc_term(&prm);
}

/* e[u̕ϐo^ */
int 		set_param(PSTRCALC_PARAM prm)
{
	PARAM_INFO		inf;
	PPRMTBL 		ptbl;
	int 			cnt;

	inf.type = PRM_SINGLE; /* Pϐ */
	inf.btempflg = 0; /* e| */

	ptbl = param_tbl;
	cnt = sizeof(param_tbl) / sizeof(PRMTBL);
	do{
		strcpy(inf.name,ptbl->name);
		inf.btempflg = ptbl->btemp;
		if (StrCalc_new_param(prm,&inf) <= 0)
			return 0;
		ptbl++;
	}while(--cnt);

	return 1;
}

/* ϐe̊mF */
void		print_param(PSTRCALC_PARAM prm)
{
	PPRMTBL 	ptbl;
	int 		cnt,ret;

	ptbl = param_tbl;
	cnt = sizeof(param_tbl) / sizeof(PRMTBL);
	do{
		printf("%s : ",prm->str = ptbl->name);
		if ((ret = StrCalc(prm)) == STATUS_NORMAL && prm->ans == 0.0)
			printf("o^\n");
		else if (ret == STATUS_ILLEGALNUM_STR)
			printf("݂\n");
		else
			printf("G[  %d\n",ret);
		ptbl++;
	}while(--cnt);
}
