#include <stdio.h>
#include "sc39x64.h"

void	main(void)
{
	STRCALC_PARAM		prm;
	__int64				ret;

	if (!StrCalc_init(&prm)){
		printf("̊mۂɎs܂\n");
		return;
	}

	if (StrCalc_setconst(&prm,"std_g",9.80665) <= 0 ||
		StrCalc_setconst(&prm,"radius_earth",6378000.0) <= 0){
		StrCalc_term(&prm);
		printf("萔̓o^Ɏs܂\n");
		return;
	}

	prm.str = "sqrt(std_g * radius_earth)";

	ret = StrCalc(&prm);

	StrCalc_term(&prm);

	if (ret != STATUS_NORMAL)
		printf("error.  %I64d\n",ret);
	else
		printf("ans. : %.16G  [m/s]\n",prm.ans);
}
