#include <stdio.h>
#include <string.h>
#include "sc39.h"

void	main(void)
{
	STRCALC_PARAM		prm;
	PARAM_INFO			inf;
	int 				ret,x,y;

	if (!StrCalc_init(&prm)){
		printf("̊mۂɎs܂\n");
		return;
	}

	/* 2z̓o^ */
	inf.type = PRM_DIM2;
	strcpy(inf.name,"test_dim");
	inf.width = 3;
	inf.height = 4;
	inf.btempflg = 0;

	if (StrCalc_new_param(&prm,&inf) <= 0){
		StrCalc_term(&prm);
		printf("ϐ̓o^Ɏs܂\n");
		return;
	}

	/* prm1 ̓o^ƌvZAʂ̊i[ */
	ret = StrCalc_substitution(
			&prm,
			"prm1 = 3 * pi / 2",
			0,
			NULL,
			0,
			0);
	if (ret != STATUS_NORMAL){
		StrCalc_term(&prm);
		printf("vZG[1 ... %d\n",ret);
		return;
	}

	/*
	  prm1 gvŽʂ test_dim(1,2) ֑

	  sin(prm1) = sin(3 * pi / 2) = -1 Ȃ̂
		  test_dim(1,2) = -1 * 987 = -987
	*/
	ret = StrCalc_substitution(
			&prm,
			"test_dim(1,2) = sin(prm1) * 987",
			0,
			&inf,
			&x,
			&y);
	if (ret != STATUS_NORMAL){
		StrCalc_term(&prm);
		printf("vZG[2 ... %d\n",ret);
		return;
	}

	printf("x : %d   y : %d\n",x,y);
	printf("vZ : %.16G\n",prm.ans);
	printf("ϐ̓e : %.16G\n",inf.pval[y * inf.width + x]);

	/* test_dim ̓e\ */
	printf("\ntest_dim ̓e\n");
	for(y = 0;y < inf.height;y++){
		for(x = 0;x < inf.width;x++)
			printf("%4.f   ",inf.pval[y * inf.width + x]);
		printf("\n");
	}

	StrCalc_term(&prm);
}
