/* StrCalc 3.9.5iWin32 DLLŁj2014 - 2018 RFiY.Koyamaj*/
#ifndef ___STRCALC39_H_ONCE
#define ___STRCALC39_H_ONCE

#ifdef __cplusplus
extern "C"{
#endif

#define SC_MAX_PARAMNAME		33

typedef struct {
	unsigned long	reserved1;
	char			*str;
	unsigned long	reserved2;
	long			paren_cnt;
	double			ans;
	char			**ppcheck_paramname;
	long			nametbl_cnt;
	long			b_hexchk;
	double			*pmem;
	long			memmax;
	unsigned char	reserved3[220];
} STRCALC_PARAM,*PSTRCALC_PARAM;

typedef struct {
	char			name[SC_MAX_PARAMNAME+3];
	unsigned		type;
	double			*pval;
	int				width;
	int				height;
	int				btempflg;
} PARAM_INFO,*PPARAM_INFO;

enum{ PRM_SINGLE = 0, PRM_DIM1, PRM_DIM2 };

typedef int			(__stdcall *APPPROC)(PSTRCALC_PARAM,void *);
typedef int 		(__stdcall *USFUNC)(PSTRCALC_PARAM,char *,int,void *);
typedef int			(__stdcall *EP_CALLBACK)(PPARAM_INFO,void *);
typedef double		(__stdcall *MFUNC)(double *,int,int *,void *);
typedef int			(__stdcall *SUBSTHOOK)(
						PSTRCALC_PARAM,char *,int,int,int *,void *);

typedef struct {
	char			*name;
	int				len;
	USFUNC			func;
	void			*param;
} USERSTATEMENT,*PUSERSTATEMENT;

typedef struct {
	char			*psource;
	unsigned long	src_size;

	unsigned		random_seed;
	int				stackcnt_if;
	int				stackcnt_for;
	int				stackcnt_gosub;
	int				b_localparam;
	int				b_ignore_subcnt;
	int				b_remark_colontype;
	int				b_remark_ignorestr;
	int				b_check_dup_label;
	int				b_naked_us;
	int				b_us_check;
	int				b_removespace;
	int				b_srand;

	unsigned long	reserved[11];

	APPPROC			fprologue;
	APPPROC			fevery;
	APPPROC			fepilogue;
	void			*proc_exparam;

	PUSERSTATEMENT	pus;
	int				uscnt;

	SUBSTHOOK		psubst;
	void			*subst_exparam;

	unsigned long	stop_lineno;
	int				sc_ret;
} BASICPARAM,*PBASICPARAM;

#define MAX_VERSTR				(128 + 4)

typedef struct {
	int				top,mid,bottom;
	int				bNormal;
	int				reserved;
	char			ver[MAX_VERSTR];
} SCVER,*PSCVER;

#define SCDECLARE				__declspec(dllimport)

SCDECLARE int __stdcall		StrCalc_init(PSTRCALC_PARAM);
SCDECLARE int __stdcall		StrCalc(PSTRCALC_PARAM);
SCDECLARE int __stdcall	 	StrCalc_n(PSTRCALC_PARAM,char *,int);
SCDECLARE int __stdcall		StrCalc_BASIC(PSTRCALC_PARAM,PBASICPARAM);
SCDECLARE void __stdcall	StrCalc_term(PSTRCALC_PARAM);
SCDECLARE int __stdcall		StrCalc_setfunc(
								PSTRCALC_PARAM,char *,int,MFUNC,void *);
SCDECLARE int __stdcall		StrCalc_setconst(PSTRCALC_PARAM,char *,double);
SCDECLARE int __stdcall		StrCalc_new_param(PSTRCALC_PARAM,PPARAM_INFO);
SCDECLARE int __stdcall		StrCalc_check_paramname(PSTRCALC_PARAM,char *);
SCDECLARE int __stdcall		StrCalc_delete_param(PSTRCALC_PARAM,char *);
SCDECLARE int __stdcall		StrCalc_delete_userfunc(PSTRCALC_PARAM,char *);
SCDECLARE int __stdcall		StrCalc_delete_param_all(PSTRCALC_PARAM);
SCDECLARE int __stdcall		StrCalc_delete_tempparam(PSTRCALC_PARAM);
SCDECLARE int __stdcall		StrCalc_substitution(
								PSTRCALC_PARAM,
								char *,
								int,
								PPARAM_INFO,
								int *,
								int *);
SCDECLARE int __stdcall		StrCalc_substitution_n(
								PSTRCALC_PARAM,
								char *,
								int,
								int,
								PPARAM_INFO,
								int *,
								int *);
SCDECLARE int __stdcall		StrCalc_getargs(
								PSTRCALC_PARAM,char **,double *,int);
SCDECLARE int __stdcall		StrCalc_get_parenargs(
								PSTRCALC_PARAM,char **,double *,int);
SCDECLARE int __stdcall		StrCalc_get_paramname(
								PSTRCALC_PARAM,char **,PPARAM_INFO,
								int *,int *);
SCDECLARE char * __stdcall	StrCalc_search_word(char *,char *,char *,int);
SCDECLARE char * __stdcall	StrCalc_search_char(char *,char *);
SCDECLARE char * __stdcall	StrCalc_stringcopy(char *,char *,int);
SCDECLARE char * __stdcall	StrCalc_getword(char *,char *,int,char **);
SCDECLARE int __stdcall		StrCalc_search_param(
								PSTRCALC_PARAM,char *,PPARAM_INFO);
SCDECLARE int __stdcall		StrCalc_enumerate_param(
								PSTRCALC_PARAM,EP_CALLBACK,void *);
SCDECLARE void __stdcall	StrCalc_copy_paraminfo(
								PSTRCALC_PARAM,PSTRCALC_PARAM);
SCDECLARE int __stdcall		StrCalc_issep(int);
SCDECLARE int __stdcall		StrCalc_set_tempflag(PSTRCALC_PARAM,char *,int);
SCDECLARE void __stdcall	StrCalc_srand(unsigned);
SCDECLARE void __stdcall	StrCalc_fpreset(void);
SCDECLARE void __stdcall	StrCalc_getversion(PSCVER);

enum {
	STATUS_NORMAL = 0,
	STATUS_ERROR = -1,
	STATUS_DIVIDEBYZERO = -2,
	STATUS_ILLEGAL_POWER = -3,
	STATUS_ILLEGALPARENTHESIS = -4,
	STATUS_PARENTHESIS_OVERNEST = -5,
	STATUS_MEMERROR = -6,
	STATUS_TOOMANYITEM = -7,
	STATUS_INVALIDARGS = -8,
	STATUS_ILLEGALFUNCTIONCALL = -9,
	STATUS_RANGEOVER = -10,
	STATUS_TOOLONGNUM = -11,
	STATUS_OP_ERROR = -12,
	STATUS_ILLEGALNUM_BIN = -13,
	STATUS_ILLEGALNUM_OCT = -14,
	STATUS_ILLEGALNUM_DEC = -15,
	STATUS_ILLEGALNUM_HEX = -16,
	STATUS_ONLY_PERIOD = -17,
	STATUS_INVALID_RADIX = -18,
	STATUS_ILLEGALNUM_FP = -19,
	STATUS_PARAM_RANGEOVER = -20,
	STATUS_ILLEGALNUM_STR = -21,
	STATUS_NEED_START_PAREN = -22,
	STATUS_NEED_LAST_PAREN = -23,
	STATUS_CONSTCHR_SYNTAXERROR = -24,
	STATUS_CONSTCHR_NEED_SQ = -25,
	STATUS_SCMEMORY_NOTREADY = -26,
	STATUS_SCMEMORY_RANGEOVER = -27,
	STATUS_BROKEN_PARAMETER_INFO = -28,
	STATUS_ILLEGAL_PARAMNAME = -29,
	STATUS_DUPLICATE_DEFINITION = -30,
	STATUS_NEED_EQUAL = -31,
	STATUS_SUBST_SYNTAXERROR = -32,

	STATUS_NOTENOUGHMEM = -100,
	STATUS_GOSUB_STACKOVERFLOW = -101,
	STATUS_IF_WITHOUT_THEN = -102,
	STATUS_IFBLOCK_STACKOVERFLOW = -103,
	STATUS_LABEL_SYNTAXERROR = -104,
	STATUS_ELSE_WITHOUT_IF = -105,
	STATUS_ELSE_SYNTAXERROR = -106,
	STATUS_ENDIF_WITHOUT_IF = -107,
	STATUS_ENDIF_SYNTAXERROR = -108,
	STATUS_THEN_SYNTAXERROR = -109,
	STATUS_CONTINUE_WITHOUT_FOR = -110,
	STATUS_BREAK_WITHOUT_FOR = -111,
	STATUS_NEXT_WITHOUT_FOR = -112,
	STATUS_FOR_WITHOUT_TO = -113,
	STATUS_FORLOOP_STACKOVERFLOW = -114,
	STATUS_NEXT_SYNTAXERROR = -115,
	STATUS_ON_WITHOUT_GOTO = -116,
	STATUS_UNDEFINED_USERSTATEMENT = -117,
	STATUS_IF_WITHOUT_ENDIF = -118,
	STATUS_FOR_WITHOUT_NEXT = -119,
	STATUS_UNDEFINED_LABEL = -120,
	STATUS_RETURN_WITHOUT_GOSUB = -121,
	STATUS_GOSUB_WITHOUT_RETURN = -122,
	STATUS_ILLEGAL_FORLOOP = -123,
	STATUS_IFSTACK_INITERR = -124,
	STATUS_FORSTACK_INITERR = -125,
	STATUS_GOSUBSTACK_INITERR = -126,
	STATUS_USERSTATEMENT_INITERR = -127,
	STATUS_DUPLICATE_LABEL = -128,
	STATUS_INVALID_NULLTERMINATION = -129,
	STATUS_UNDEFINED_PARAM = -130,
	STATUS_OUTOFDATA = -131,
	STATUS_UNDEFINED_DATALABEL = -132,

	STATUS_IF_CMP_ERROR = -200,
	STATUS_BREAK_CMP_ERROR = -201,
	STATUS_FOR_INIT_ERROR = -202,
	STATUS_FOR_CMP_ERROR = -203,
	STATUS_FOR_STEP_ERROR = -204,
	STATUS_CONTINUE_CMP_ERROR = -205,
	STATUS_ONGOTO_INDEX_ERROR = -206,
	STATUS_SUBST_ERROR = -207,
	STATUS_DIM_ERROR = -208,
	STATUS_RETURN_CMP_ERROR = -209,
	STATUS_END_CMP_ERROR = -210,
	STATUS_READ_ERROR = -211,
	STATUS_SKIP_ERROR = -212,

	STATUS_USERABORT = -900
};

#ifdef __cplusplus
}
#endif

#endif
