#include <ctype.h>
#include "sc39x64.h"

#define MEM_START			0xb1	  /*  */
#define MEM_END 			0xdd	  /*  */
#define MEM_MAX 			(MEM_END - MEM_START + 1)

__int64 StrCalc_substitution_SCM(PSTRCALC_PARAM prm,char *ptr,__int64 btemp)
{
	__int64		c,ret;

	while(isspace(*ptr)) /* 擪̋󔒂΂ */
		ptr++;

	/*
	  ŏ̕ 0xb1 ꍇ
	  W̑֐Ăяo
	*/
	if ((c = *(unsigned char *)ptr) < MEM_START)
		return StrCalc_substitution(prm,ptr,btemp,0,0,0);

	/* ̕CR[ł邩ׂ */
	do{
		ptr++;
	}while(isspace(*ptr));
	if (*ptr != '=')
		return STATUS_NEED_EQUAL;

	/* single character memory gp֎~ł邩ׂ */
	if (!prm->pmem || prm->memmax <= 0)
		return STATUS_SCMEMORY_NOTREADY;

	/* CfbNXő͈͂𒴂Ă邩ׂ */
	if ((c -= MEM_START) > MEM_MAX || c >= prm->memmax)
		return STATUS_SCMEMORY_RANGEOVER;

	/* Eӂ̌vZƃւ̑ */
	prm->str = ptr + 1;
	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;
	prm->pmem[c] = prm->ans;

	return STATUS_NORMAL;
}

#include <stdio.h>

void	main(void)
{
	STRCALC_PARAM		prm;
	double				mem[5] = {0};
	char				*pstr;
	__int64				ret;

	if (!StrCalc_init(&prm)){
		printf("init err.\n");
		return;
	}

	prm.pmem = mem;
	prm.memmax = sizeof(mem) / sizeof(double);

	pstr = "  = 1+2+3+4+5";
	ret = StrCalc_substitution_SCM(&prm,pstr,0);

	StrCalc_term(&prm);

	/*  ɂ 15 i[܂ */
	if (ret != STATUS_NORMAL)
		printf("err.%I64d\n",ret);
	else
		printf("%.16G\n",mem['' - '']);
}
