#ifndef ___BMPPROC_H_ONCE
#define ___BMPPROC_H_ONCE

#define WIN_WIDTH				640
#define WIN_HEIGHT				480
#define WIDTH(S)				((S).right - (S).left)
#define HEIGHT(S)				((S).bottom - (S).top)

#define BMP_FILENAME			"sample.bmp"
#define SRC_FILENAME			"proc.txt"

typedef UINT		(__stdcall *THREAD_ROUTINE)(LPVOID);

typedef struct {
	HWND				hWnd;
	HDC					hVDC;
	HBITMAP				hVBmp;
	BITMAPDATA			bmpdata;
	STRCALC_PARAM		sc;
	BASICPARAM			bas;
	BOOL				bReady;
} INFO,*PINFO;

INT					OnCreate(HWND);
VOID				OnDestroy(HWND);

LPSTR				StartBASIC(HWND);
VOID				errormes_V39(HWND,INT,PBASICPARAM);
LPSTR				CurrentPath(LPSTR);

INT __stdcall		func_stopevent(PSTRCALC_PARAM,HANDLE);
INT __stdcall		func_substproc(PSTRCALC_PARAM,LPSTR,INT,INT,LPINT,PINFO);

double __stdcall	user_f_mem(double *,INT,LPINT,PBITMAPDATA);
double __stdcall	user_f_mkrgb(double *,INT,LPINT,LPVOID);
double __stdcall	user_f_getR(double *,INT,LPINT,LPVOID);
double __stdcall	user_f_getG(double *,INT,LPINT,LPVOID);
double __stdcall	user_f_getB(double *,INT,LPINT,LPVOID);

#ifdef ___MAIN_OBJECT
LPSTR					gpszWinName = "bmp process";
INFO					ginf;
HANDLE					ghThread;
#else
extern LPSTR			gpszWinName;
extern INFO				ginf;
extern HANDLE			ghThread;
#endif

#endif
