#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "errmsg.h"
#include "resource.h"

#define VAL_CNT				16
#define MAC_CNT				64
#define COMMENT_CNT			1024

/*
  errdat.txt ... 1R[h̃tH[}bg

      @ ̐liԃR[hj
      A }N
      B 
*/
typedef struct {
	CHAR		val[VAL_CNT];
	CHAR		mac[MAC_CNT];
	CHAR		comment[COMMENT_CNT];
} REC,*PREC;

/* ŏɔskɒu */
VOID	del_lf(LPSTR ptr)
{
	while(*ptr && *ptr != '\r' && *ptr != '\n') ptr++;
	*ptr = 0;
}

/* 1R[hǂݍ */
BOOL		read_rec(FILE *fp,PREC prec)
{
	/* evf͉sŋ؂Ă */

	if (fgets(prec->val,VAL_CNT,fp) == NULL ||
		fgets(prec->mac,MAC_CNT,fp) == NULL ||
		fgets(prec->comment,COMMENT_CNT,fp) == NULL)
		return FALSE;

	/* ̉s */
	del_lf(prec->val);
	del_lf(prec->mac);

	return TRUE;
}

/* lł̌ */
VOID	search_val(HWND hWnd)
{
	FILE		*fp;
	REC			buf;
	INT			key,rec;
	LPSTR		pscan;
	BOOL		ret;

	/* ͂ꂽl int^ɕϊ */
	key = (INT)GetDlgItemInt(hWnd,IDC_EDIT1,&ret,TRUE);
	if (ret == FALSE){
		MessageBox(hWnd,"l͂Ă",
			gpszWinName,MB_OK | MB_ICONHAND);
		return;
	}

	if ((fp = fopen(gszSearchFile,"rb")) == NULL){
		MessageBox(hWnd,"t@CI[vł܂",
			gpszWinName,MB_OK | MB_ICONHAND);
		return;
	}

	while(read_rec(fp,&buf)){
		/* ԃR[h int^ɕϊ */
		rec = (INT)strtol(buf.val,&pscan,10);
		if (*pscan) continue;

		if (key == rec){
			/* v}NƐ\ */
			SetDlgItemText(hWnd,IDC_EDIT2,buf.mac);
			SetDlgItemText(hWnd,IDC_EDIT3,buf.comment);
			fclose(fp);
			return;
		}
	}
	fclose(fp);

	MessageBox(hWnd,"v鐔l܂ł",
		gpszWinName,MB_OK | MB_ICONEXCLAMATION);
	SetDlgItemText(hWnd,IDC_EDIT2,"");
	SetDlgItemText(hWnd,IDC_EDIT3,"");
}

/* }Nł̌ */
VOID	search_mac(HWND hWnd)
{
	FILE		*fp;
	REC			buf;
	CHAR		key[MAC_CNT];

	/* ͂ꂽ}N̎擾 */
	if (!GetDlgItemText(hWnd,IDC_EDIT2,key,MAC_CNT)){
		MessageBox(hWnd,"}N͂Ă",
			gpszWinName,MB_OK | MB_ICONHAND);
		return;
	}

	if ((fp = fopen(gszSearchFile,"rb")) == NULL){
		MessageBox(hWnd,"t@CI[vł܂",
			gpszWinName,MB_OK | MB_ICONHAND);
		return;
	}

	while(read_rec(fp,&buf)){
		if (!_stricmp(key,buf.mac)){ /* 啶E̋ʖ */
			/* v琔liR[hjƐ\ */
			SetDlgItemText(hWnd,IDC_EDIT1,buf.val);
			SetDlgItemText(hWnd,IDC_EDIT3,buf.comment);
			fclose(fp);
			return;
		}
	}
	fclose(fp);

	MessageBox(hWnd,"v}N܂ł",
		gpszWinName,MB_OK | MB_ICONEXCLAMATION);
	SetDlgItemText(hWnd,IDC_EDIT1,"");
	SetDlgItemText(hWnd,IDC_EDIT3,"");
}

VOID		OnOK(HWND hWnd)
{
	if (SendDlgItemMessage(hWnd,IDC_RADIO1,BM_GETCHECK,0L,0L) == BST_CHECKED)
		search_val(hWnd);
	else
		search_mac(hWnd);
}
