/*
  C
  PɁAI[o[bvhEChE쐬邾̏łB
  É~{^NbNďIĂB
*/
#include <windows.h>
#include "sc39.h"
#include "test.h"

LRESULT CALLBACK	WinProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	PAINTSTRUCT		ps;

	switch(Msg){
		case	WM_PAINT:
				BeginPaint(hWnd,&ps);
				EndPaint(hWnd,&ps);
				break;

		case	WM_CLOSE:
				DestroyWindow(hWnd);
				break;

		case	WM_DESTROY:
				PostQuitMessage(0);
				break;
		default:
				return DefWindowProc(hWnd,Msg,wParam,lParam);
	}

	return 0;
}

INT WINAPI		WinMain(
					HINSTANCE		hInstance,
					HINSTANCE		hPrevInstance,
					LPSTR			pszArgv,
					INT				nCmdShow)
{
	HWND			hWnd,hWndOwner = GetDesktopWindow();
	WNDCLASSEX		wcx;
	MSG				m;
	INT				ret;
	WIN_INIT		wi = {
		DEF_XPOS, DEF_YPOS, DEF_WINWIDTH, DEF_WINHEIGHT, DEF_WINTITLE
	};

	if ((ret = Load_IniFile(&wi)) != STATUS_NORMAL){
		MessageBox(hWndOwner,ErrMsg(ret),"test.exe",MB_OK | MB_ICONHAND);
		return 0;
	}

	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = 0;
	wcx.hInstance = hInstance;
	wcx.hCursor = LoadCursor(NULL,IDC_ARROW);
	wcx.lpfnWndProc = (WNDPROC)WinProc;
	wcx.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcx.lpszClassName = wi.name;
	wcx.lpszMenuName = NULL;
	wcx.cbClsExtra = wcx.cbWndExtra = 0;
	wcx.hIcon = wcx.hIconSm = NULL;

	if (!RegisterClassEx(&wcx) ||
		(hWnd = CreateWindowEx(WS_EX_APPWINDOW,wi.name,wi.name,
			WS_OVERLAPPEDWINDOW,wi.x,wi.y,wi.width,wi.height,
			hWndOwner,NULL,hInstance,NULL)) == NULL)
		return 0;

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	while((ret = (INT)GetMessage(&m,NULL,0,0)) != 0 && ret != -1){
		TranslateMessage(&m);
		DispatchMessage(&m);
	}
	return m.wParam;
}
