#include <windows.h>
#include "lbas.h"

LPSTR		gpszWinName = "test";
HWND		hLineBas;

LRESULT CALLBACK	WinProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	PAINTSTRUCT		ps;

	switch(Msg){
		case	WM_CREATE:
				if ((hLineBas = LineBasDlg(hWnd)) == NULL) /* DLL\main.c */
					return -1;
				break;

		case	WM_PAINT:
				BeginPaint(hWnd,&ps);
				EndPaint(hWnd,&ps);
				break;

		case	WM_CLOSE:
				/* LineBas Iꍇ WM_CLOSE |XgĂ */
				PostMessage(hLineBas,WM_CLOSE,0L,0L);
				DestroyWindow(hWnd);
				break;

		case	WM_DESTROY:
				PostQuitMessage(0);
				break;

		default: return DefWindowProc(hWnd,Msg,wParam,lParam);
	}

	return 0;
}

INT WINAPI		WinMain(
					HINSTANCE		hInstance,
					HINSTANCE		hPrevInstance,
					LPSTR			pszArgv,
					INT				nCmdShow)
{
	HWND			hWnd,hWndOwner = GetDesktopWindow();
	WNDCLASSEX		wcx;
	MSG				m;
	INT				ret;

	/*
	  CƂȂEChEKɍ쐬Ă܂B
	  {́ABASIC ̌ʂLɊpł悤ȁAAvP[V
	  EChEłB
	*/

	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = 0;
	wcx.hInstance = hInstance;
	wcx.hCursor = LoadCursor(NULL,IDC_ARROW);
	wcx.lpfnWndProc = (WNDPROC)WinProc;
	wcx.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wcx.lpszClassName = gpszWinName;
	wcx.lpszMenuName = NULL;
	wcx.cbClsExtra = wcx.cbWndExtra = 0;
	wcx.hIcon = wcx.hIconSm = NULL;

	if (!RegisterClassEx(&wcx) ||
		(hWnd = CreateWindowEx(WS_EX_APPWINDOW,gpszWinName,gpszWinName,
			WS_OVERLAPPEDWINDOW,0,0,320,200,
			hWndOwner,NULL,hInstance,NULL)) == NULL)
		return 0;

	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);

	while((ret = (INT)GetMessage(&m,NULL,0,0)) != 0 && ret != -1){
		TranslateMessage(&m);
		DispatchMessage(&m);
	}
	return m.wParam;
}

