#include "test.h"

LPSTR				ban_str[] = {
	"chr", "insspc", "str"
};

/* StrCalc */
INT		inittbl(VOID)
{
	INT		i;

	for(i = 0;i < CNT_MAX;i++){
		if (!StrCalc_init(prm_tbl + i))
			break;
		prm_tbl[i].ppcheck_paramname = ban_str;
		prm_tbl[i].nametbl_cnt = sizeof(ban_str) / sizeof(LPSTR);
	}

	return i;
}

/* StrCalc */
VOID	freetbl(INT cnt)
{
	INT		i;

	for(i = 0;i < cnt;i++)
		StrCalc_term(prm_tbl + i);
}

/* psrc ɂϐ pdest փRs[ */
INT		copy_param(
			PSTRCALC_PARAM	pdest,
			PSTRCALC_PARAM	psrc,
			LPSTR			name)
{
	PARAM_INFO		src_inf,dest_inf;

	/* psrc  ϐ name  */
	if (!StrCalc_search_param(psrc,name,&src_inf))
		return 0;

	dest_inf = src_inf; /* o^ʂ */

	/* pdest ɓ̕ϐo^ */
	if (StrCalc_new_param(pdest,&dest_inf) <= 0 ||
		!StrCalc_search_param(pdest,name,&dest_inf))
		return 0;

	/* ẽRs[ */
	switch(src_inf.type){
		case	PRM_SINGLE:
				*dest_inf.pval = *src_inf.pval;
				break;

		case	PRM_DIM1:
				memcpy(dest_inf.pval,src_inf.pval,
					src_inf.width * sizeof(double));
				break;

		case	PRM_DIM2:
				memcpy(dest_inf.pval,src_inf.pval,
					src_inf.width * src_inf.height * sizeof(double));
				break;

		default:
				return 0;
	}

	return 1;
}
