#include <mbstring.h>
#include "sc39.h"
#include "test.h"

#define MBSINC(X)		((char *)_mbsinc((unsigned char *)(X)))

#define NULL			((void *)0)
#define REPLACE_CHAR	' '

/* VONH[gŊꂽ΂ */
static char		*jump_singlequote(char *ptr)
{
	char	*pstart = ptr;
	int		temp,cnt;

	temp = *ptr;
	for(cnt = 3;*++ptr && (*ptr != '\'' || temp == '\\') && cnt;cnt--)
		temp = (temp == '\\')? 0 : *ptr;

	return (cnt)? ptr : pstart + 1;
}

/* _uNH[gŊꂽ΂ */
static char		*jump_dblquote(char *ptr)
{
	ptr++;
	while(*ptr && *ptr != '\"'){
		if (*ptr == '\''){
			ptr += (*(ptr = jump_singlequote(ptr)) != 0);
			continue;
		}
		ptr = MBSINC(ptr);
	}

	return ptr + (*ptr == '\"');
}

/* ʂŊꂽ͈͂̉s󔒕ɒu */
static 	char	*replace_code(char *ptr)
{
	*ptr++ = REPLACE_CHAR; /* { 󔒂ɒu */

	while(*ptr && *ptr != '}'){
		switch(*ptr){
			case	'\"':
					ptr = jump_dblquote(ptr);
					continue;

			case	'\'':
					ptr += (*(ptr = jump_singlequote(ptr)) != 0);
					continue;

			case	'\r':
			case	'\n':
					*ptr++ = REPLACE_CHAR; /* s󔒂ɕύX */
					continue;

			case	'{': /* qɂ͂łȂ */
					return NULL;
		}

		ptr = MBSINC(ptr);
	}

	if (*ptr == '}')
		*ptr++ = REPLACE_CHAR; /* ʂ̏ꍇ͋󔒂ɕύX */

	return ptr;
}

int		preproc(char *ptr)
{
	while(*ptr){
		switch(*ptr){
			case	'\"':
					ptr = jump_dblquote(ptr);
					continue;

			case	'\'':
					ptr += (*(ptr = jump_singlequote(ptr)) != 0);
					continue;

			case	'{':
					if ((ptr = replace_code(ptr)) == NULL)
						return 0;
					continue;

			case	'}':
					return 0;
		}
		ptr = MBSINC(ptr);
	}

	return 1;
}
