#include <windows.h>
#include <string.h>
#include "sc39.h"
#include "smpbas.h"

INT		SimpleBasic::check_paramname(LPSTR name)
{
	return StrCalc_check_paramname(&sp,name);
}

INT		SimpleBasic::delete_param(LPSTR name)
{
	return StrCalc_delete_param(&sp,name);
}

INT		SimpleBasic::delete_param_all(VOID)
{
	return StrCalc_delete_param_all(&sp);
}

INT		SimpleBasic::delete_tempparam(VOID)
{
	return StrCalc_delete_tempparam(&sp);
}

INT		SimpleBasic::delete_userfunc(LPSTR name)
{
	return StrCalc_delete_userfunc(&sp,name);
}

INT		SimpleBasic::enumerate_param(EP_CALLBACK pfunc,LPVOID param)
{
	return StrCalc_enumerate_param(&sp,pfunc,param);
}

INT		SimpleBasic::get_paramname(
			LPSTR *pptr,PPARAM_INFO pinf,LPINT px,LPINT py)
{
	return StrCalc_get_paramname(&sp,pptr,pinf,px,py);
}

INT		SimpleBasic::new_param(PPARAM_INFO pinf)
{
	return StrCalc_new_param(&sp,pinf);
}

INT		SimpleBasic::new_param(LPSTR name,INT btemp)
{
	PARAM_INFO		inf;

	inf.type = PRM_SINGLE;
	strcpy(inf.name,name);
	inf.btempflg = btemp;

	return StrCalc_new_param(&sp,&inf);
}

INT		SimpleBasic::new_param(LPSTR name,INT cnt,INT btemp)
{
	PARAM_INFO		inf;

	inf.type = PRM_DIM1;
	strcpy(inf.name,name);
	inf.width = cnt;
	inf.btempflg = btemp;

	return StrCalc_new_param(&sp,&inf);
}

INT		SimpleBasic::new_param(LPSTR name,INT w,INT h,INT btemp)
{
	PARAM_INFO		inf;

	inf.type = PRM_DIM2;
	strcpy(inf.name,name);
	inf.width = w;
	inf.height = h;
	inf.btempflg = btemp;

	return StrCalc_new_param(&sp,&inf);
}

INT		SimpleBasic::search_param(LPSTR name,PPARAM_INFO pinf)
{
	return StrCalc_search_param(&sp,name,pinf);
}

INT		SimpleBasic::set_tempflag(LPSTR name,INT bflag)
{
	return StrCalc_set_tempflag(&sp,name,bflag);
}

INT		SimpleBasic::setconst(LPSTR name,double val)
{
	return StrCalc_setconst(&sp,name,val);
}

INT		SimpleBasic::setfunc(LPSTR name,INT argcnt,MFUNC pfunc,LPVOID param)
{
	return StrCalc_setfunc(&sp,name,argcnt,pfunc,param);
}

INT		SimpleBasic::substitution(
			LPSTR str,INT btemp,PPARAM_INFO pinf,LPINT px,LPINT py)
{
	return StrCalc_substitution(&sp,str,btemp,pinf,px,py);
}

INT		SimpleBasic::substitution(LPSTR str,INT btemp)
{
	return StrCalc_substitution(&sp,str,btemp,NULL,NULL,NULL);
}

INT		SimpleBasic::getargs(LPSTR *pptr,double *args,INT argcnt)
{
	return  StrCalc_getargs(&sp,pptr,args,argcnt);
}

INT		SimpleBasic::get_parenargs(LPSTR *pptr,double *args,INT argcnt)
{
	return  StrCalc_get_parenargs(&sp,pptr,args,argcnt);
}
