#include <windows.h>
#include <mbstring.h>
#include <ctype.h>
#include "sc39.h"
#include "cio.h"

#define TEXT_MAX		(80 * sizeof(short))

/* o̕\ */
LPSTR	show(PIOHANDLES pio,LPSTR ptr)
{
	if (*ptr == '\"'){
		LPSTR		pstart = ++ptr;
		DWORD		dwWrite;

		while(*ptr && *ptr != '\"')
			ptr = (LPSTR)_mbsinc((LPBYTE)ptr);

		WriteConsole(pio->hStdout,pstart,(DWORD)(ptr - pstart),&dwWrite,0);
		if (!*ptr)
			return NULL;

		do{
			ptr++;
		}while(isspace(*ptr));
		if (*ptr != ';')
			return NULL;

		do{
			ptr++;
		}while(isspace(*ptr));
	}

	return ptr; /* ϐ̐擪w */
}

static BOOL		copy_paramname(LPSTR pdest,LPSTR psrc)
{
	INT		cnt;

	for(cnt = SC_MAX_PARAMNAME;*psrc;psrc++){
		if (isspace(*psrc))
			continue;

		if (!cnt)
			break;
		*pdest++ = *psrc;
		cnt--;
	}
	*pdest = 0;

	return !*psrc;
}

/* l̓ */
DECLARE INT __stdcall	usr_input(
							PSTRCALC_PARAM		prm,
							LPSTR				ptr,
							INT					len,
							PIOHANDLES			pio)
{
	DWORD			dwRead;
	INT				ret;
	CHAR			buf[TEXT_MAX + 1],name[SC_MAX_PARAMNAME+1];
	PARAM_INFO		inf;

	if (!len || (ptr = show(pio,ptr)) == NULL ||
		copy_paramname(name,ptr) == FALSE)
		return STATUS_ERROR;

	if (!StrCalc_search_param(prm,name,&inf) || inf.type != PRM_SINGLE)
		return STATUS_UNDEFINED_PARAM;

	if (!ReadConsole(pio->hStdin,buf,TEXT_MAX/2,&dwRead,0))
		return STATUS_INTERNALERROR;
	buf[dwRead] = 0;

	prm->str = buf;
	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;

	*inf.pval = prm->ans;

	return STATUS_NORMAL;
}

/* ̓ */
DECLARE INT __stdcall	usr_sinput(
							PSTRCALC_PARAM		prm,
							LPSTR				ptr,
							INT					len,
							PIOHANDLES			pio)
{
	DWORD			dwRead,i;
	CHAR			buf[TEXT_MAX + 1],name[SC_MAX_PARAMNAME+1];
	PARAM_INFO		inf;

	if (!len || (ptr = show(pio,ptr)) == NULL ||
		copy_paramname(name,ptr) == FALSE)
		return STATUS_ERROR;

	if (!ReadConsole(pio->hStdin,buf,TEXT_MAX/2,&dwRead,0))
		return STATUS_INTERNALERROR;

	if (!StrCalc_search_param(prm,name,&inf) || inf.type != PRM_DIM1)
		return STATUS_UNDEFINED_PARAM;

	StrCalc_delete_param(prm,name);

	inf.width = dwRead + 1;
	if (StrCalc_new_param(prm,&inf) != 1 ||
		!StrCalc_search_param(prm,name,&inf))
		return STATUS_MEMERROR;

	for(i = 0;i < dwRead;i++)
		inf.pval[i] = (double)buf[i];

	inf.pval[i] = 0.0;

	return STATUS_NORMAL;
}
