#include <windows.h>
#include "sc39.h"
#include "cio.h"

/* J[\ʒu̕ύX */
DECLARE INT __stdcall	usr_locate(
							PSTRCALC_PARAM		prm,
							LPSTR				arg,
							INT					len,
							PIOHANDLES			pio)
{
	double						pos[2];
	INT							ret,x,y;
	COORD						coord;
	CONSOLE_SCREEN_BUFFER_INFO	csbi;

	if ((ret = StrCalc_getargs(prm,&arg,pos,2)) != STATUS_NORMAL)
		return ret;

	if (*arg)
		return STATUS_INVALIDARGS;

	if (GetConsoleScreenBufferInfo(pio->hStdout,&csbi) == FALSE)
		return STATUS_INTERNALERROR;

	if ((x = (INT)pos[0]) < 0)
		x = 0;
	else if (x >= csbi.dwSize.X)
		x = csbi.dwSize.X - 1;

	if ((y = (INT)pos[1]) < 0)
		y = 0;
	else if (y >= csbi.dwSize.Y)
		y = csbi.dwSize.Y - 1;

	coord.X = (SHORT)x;
	coord.Y = (SHORT)y;

	SetConsoleCursorPosition(pio->hStdout,coord);

	return STATUS_NORMAL;
}
