#include <windows.h>
#include "sc39.h"
#include "textedit.h"
#include "cio.h"

/* ϐƕ̃Rs[ */
static INT		param_proc(
					PSTRCALC_PARAM		prm,
					LPSTR				name,
					PMEMINFO			pmi,
					PBASICPARAM			pbas)
{
	PARAM_INFO		pi;
	INT				i,use;

	if (StrCalc_search_param(prm,name,&pi)){ /* w̕ϐꍇ */
		if (pi.type != PRM_DIM1) /* ꎟzȊȌꍇ̓G[ */
			return STATUS_ILLEGAL_PARAMNAME;

		if (StrCalc_delete_param(prm,name) <= 0) /* ϐ폜 */
			return STATUS_NOTENOUGHMEM;
	}

	/* VzĊmۂ */

	strcpy(pi.name,name);
	pi.type = PRM_DIM1;
	pi.width = pmi->use + 1;
	pi.btempflg = pbas->b_localparam;

	if (StrCalc_new_param(prm,&pi) <= 0)
		return STATUS_NOTENOUGHMEM;

	StrCalc_search_param(prm,name,&pi); /* o^ϐ̏擾 */

	/* zɃZbg */
	for(i = 0,use = pmi->use;i < use;i++)
		pi.pval[i] = (double)pmi->pmem[i];
	pi.pval[i] = 0;

	return STATUS_NORMAL;
}

INT __stdcall	cb_setstr(LPSTR psrc,DWORD len,BOOL bfinish,PMEMINFO pi)
{
	if (bfinish == TRUE) /* s̉s͏o͂Ȃ */
		return STATUS_NORMAL;

	return (textedit_chain(pi,psrc,len) == FALSE)? /* textedit\chain.c */
		STATUS_NOTENOUGHMEM : STATUS_NORMAL;
}

/* @setstr Xe[gg */
DECLARE INT __stdcall	usr_setstr(
							PSTRCALC_PARAM		prm,
							LPSTR				ptr,
							INT					len,
							PBASICPARAM			pbas)
{
	LPSTR			pdest;
	CHAR			name[SC_MAX_PARAMNAME+1];
	INT				ret,cnt;
	MEMINFO			mi;

	/* ϐ𒊏o */
	cnt = SC_MAX_PARAMNAME;
	for(pdest = name;*ptr && *ptr != '=';ptr++){
		if (!isspace(*ptr)){ /* 󔒁E^u */
			*pdest++ = *ptr;
			if (!--cnt){
				do{
					ptr++;
				}while(isspace(*ptr)); /* ~ʒu̎ */
				break;
			}
		}
	}
	*pdest = 0;

	/* ؂łȂꍇ̓G[ */
	if (*ptr != '=')
		return STATUS_ILLEGAL_PARAMNAME;

	/* 㑱̕񎮂ҏW */
	mi.pmem = NULL;
	ret = text_edit(
			prm,
			++ptr,
			(TEXTEDIT_CALLBACK)cb_setstr,
			&mi); /* textedit\textedit.c */

	if (ret != STATUS_NORMAL){
		textedit_free(&mi); /* textedit\chain.c */
		return ret;
	}

	ret = param_proc(prm,name,&mi,pbas); /* ϐƕ̃Rs[ */

	textedit_free(&mi); /* textedit\chain.c */

	return ret;
}
