#include <windows.h>
#include <stdio.h>
#include "sc39.h"
#include "fio.h"
#include "local.h"

/* lf[^idouble^j̓ǂݍ */
DECLARE INT __stdcall	usr_read(
							PSTRCALC_PARAM		prm,
							LPSTR				ptr,
							INT					len,
							FILE				**fptbl)
{
	FILE			*fp;
	INT				ret,x,y;
	double			*pval;
	PARAM_INFO		inf;

	switch(get_fileno(prm,&ptr,fptbl,&fp,FALSE)){
		case	INVALID_FILENO:
				return STATUS_READF_INVALIDFILENO;

		case	SYNTAXERROR:
				return STATUS_READF_SYNTAXERROR;
	}

	while(1){
		if ((ret = StrCalc_get_paramname(
			prm,&ptr,&inf,&x,&y)) != STATUS_NORMAL)
			return ret;

		switch(inf.type){
			case	PRM_SINGLE:
					pval = inf.pval;
					break;

			case	PRM_DIM1:
					pval = inf.pval + x;
					break;

			case	PRM_DIM2:
					pval = inf.pval + y * inf.width + x;
					break;

			default:
					return STATUS_BROKEN_PARAMETER_INFO;
		}

		if (!fread(pval,sizeof(double),1,fp))
			return STATUS_READF_ERROR;

		if (!*ptr)
			break;
		else if (*ptr != ',')
			return STATUS_READF_SYNTAXERROR;

		ptr++;
	}

	return STATUS_NORMAL;
}
