#include <windows.h>
#include <process.h>
#include <stdio.h>
#include "sc39.h"
#include "cio.h"
#include "fio.h"
#include "gio.h"
#include "errmsg.h"
#include "scbas.h"
#include "resource.h"

BOOL WINAPI HandlerRoutine(DWORD);

USERSTATEMENT		user[] = {
/* . */
	{ "sleep", 5, (USFUNC)usr_sleep, NULL }, /* sysfunc.c */
	{ "delete", 6, (USFUNC)usr_delete, NULL }, /* usr_delete.c */
	{ "pause", 5, (USFUNC)usr_pause, NULL }, /* usr_pause.c */
	{ "externalcode", 12, (USFUNC)usr_extcode, (LPVOID)&gsc }, /* usr_ext.c */

/* cio */
	{ "cls", 3, (USFUNC)usr_cls, (LPVOID)&ioh }, /* cls.c */
	{ "locate", 6, (USFUNC)usr_locate, (LPVOID)&ioh }, /* locate.c */
	{ "print", 5, (USFUNC)usr_print, (LPVOID)&ioh }, /* print.c */
	{ "color", 5, (USFUNC)usr_color, (LPVOID)&ioh }, /* color.c */
	{ "input", 5, (USFUNC)usr_input, (LPVOID)&ioh }, /* input.c */
	{ "sinput", 6, (USFUNC)usr_sinput, (LPVOID)&ioh }, /* input.c */
	{ "inkey", 5, (USFUNC)usr_inkey, (LPVOID)&ioh }, /* inkey.c */
	{ "eval", 4 , (USFUNC)usr_eval, (LPVOID)&gsc.bas }, /* eval.c */
	{ "strcalc", 7 , (USFUNC)usr_strcalc, (LPVOID)&gsc.bas }, /* eval.c */
	{ "setstr", 6 , (USFUNC)usr_setstr, (LPVOID)&gsc.bas }, /* setstr.c */

/* fio */
	{ "open", 4, (USFUNC)usr_open, (LPVOID)fptbl }, /* open.c */
	{ "read", 4, (USFUNC)usr_read, (LPVOID)fptbl }, /* fread.c */
	{ "write", 5, (USFUNC)usr_write, (LPVOID)fptbl }, /* write.c */
	{ "fprint", 6, (USFUNC)usr_fprint, (LPVOID)fptbl }, /* fprint.c */
	{ "close", 5, (USFUNC)usr_close, (LPVOID)fptbl }, /* close.c */

/* gio */
	{ "gcls", 4, (USFUNC)usr_gcls, NULL }, /* gclr.c */
	{ "line", 4, (USFUNC)usr_line, NULL }, /* line.c */
	{ "rect", 4, (USFUNC)usr_rect, NULL }, /* rect.c */
	{ "fillrect", 8, (USFUNC)usr_fillrect, NULL }, /* rect.c */
	{ "circle", 6, (USFUNC)usr_circle, NULL }, /* circle.c */
	{ "fillcircle", 10, (USFUNC)usr_fillcircle, NULL }, /* circle.c */
	{ "pie", 3, (USFUNC)usr_pie, NULL }, /* pie.c */
	{ "fillpie", 7, (USFUNC)usr_fillpie, NULL }, /* pie.c */
	{ "fill", 4, (USFUNC)usr_fill, NULL }, /* fill.c */
	{ "textout", 7, (USFUNC)usr_textout, NULL }, /* textout.c */
	{ "pset", 4, (USFUNC)usr_pset, NULL }, /* pset.c */

/* errmsg */
	{ "error", 5 , (USFUNC)usr_error, (LPVOID)&ioh } /* usr_error.c */
};

/* ϐ̋֎~[h */
LPSTR				ban_str[] = {
	/* @open Xe[ggŎgp */
	"as", "input", "output", "append",

	/* @print ƓҏW@\Xe[ggŎgp */
	"chr", "insspc", "str"
};

LPSTR	OnInitDialog(HWND hWnd)
{
	UINT		uID;

	if (!StrCalc_init(&gsc.sc)) /* StrCalc  */
		return "StrCalc ̏Ɏs܂";

	/* sc_basic ̐ݒFlɎԂgp */
	gsc.bseed_timeset = 1;

	/* sc_basic ̐ݒFvOɊ|ԂbZ[W{bNXŕ\ */
	gsc.bprocess_count = 0;

	/*
	  ĺAWCů֐srand̈ɓnlƓłB
	  tO b_srand Ƀ[ݒ肷ꍇAvOŗgp
	  ꍇ́Aݒ肵ȂĂ肠܂B
	*/
	gsc.bas.random_seed = 1;

	/*************************** tO ***************************/

	/* srand sF 1 ...  ^ 0 ... 蓮 */
	gsc.bas.b_srand = 1;

	/* ϐ̃e|F 1 ... t^ ^ 0 ... t^Ȃ */
	gsc.bas.b_localparam = 1;

	/* ߓ̃R̈F 1 ... sƌȂ ^ 0 ... ߂̈ꕔ */
	gsc.bas.b_remark_colontype = 0;

	/* ߓ̃_uNH[gԂ𖳎F 1 ... L ^ 0 ...  */
	gsc.bas.b_remark_ignorestr = 0;

	/* x̏d`FbNF 1 ... s ^ 0 ... sȂ */
	gsc.bas.b_check_dup_label = 1;

	/* [UXe[gg擪F 1 ... @ ^ 0 ... @t  */
	gsc.bas.b_naked_us = 0;

	/* [UXe[gge[ũ`FbNF 1 ... s ^ 0 ... sȂ */
 	gsc.bas.b_us_check = 1;

	/* vZ̋󔒕F 1 ...  ^ 0 ... Ȃ */
	gsc.bas.b_removespace = 0;

	/* Tu[`IF 1 ... I ^ 0 ... G[ */
	gsc.bas.b_ignore_subcnt = 0;

	/* ϐ16i`FbNF 1 ... s ^ 0 ... sȂ */
	gsc.sc.b_hexchk = 1;

	/*************************** lXgE ***************************/
	/*
	  ݒKv͂܂B{Iɂ͐ݒl傫قǁAvO
	  ՂȂ܂B
	  Xe[gg̃lXg`FbŃAw肳ꂽKwƓʂ̃g
	  p̂ŁAɒ[ɋȐ͎w肵Ȃǂł傤B

	  Eif ` then Afor ` next ͖|󎞂ɎgpB|Iɔj
	  Egosub ͎sɎgpBvOIɔj
	*/

	/*
	  if ` then Afor ` next ̃lXǵAʏA܂[Ȃ܂B
	  16炢AĂ 20 xŏ\łB
	*/
	gsc.bas.stackcnt_if = 16;
	gsc.bas.stackcnt_for = 16;

	/*
	  ł gosub  16 Kwݒ肵Ă܂Ax̕GvO
	  ꍇ́A]Tقǂ܂B
	*/
	gsc.bas.stackcnt_gosub = 16;

	/*
	  ʂ̃lXǵA[߂ƂȂ茩Ȃ܂̂ōTǂ̂ł
	  ݒقǓOꂷKv͖ł傤B

	  ł̓ftHgݒgp܂B
	*/
	/* gsc.sc.paren_cnt = 64; */

	/*********************** e[uށAR[obN ***********************/

	/*
	  w֐̓o^
	      user_f_mkrgb ... gio\func.c
	      user_f_fsize ... fio\func.c
	      user_f_tickcount ... sysfunc.c
	*/
	if (StrCalc_setfunc(&gsc.sc,"mkrgb",3,user_f_mkrgb,0) <= 0 ||
		StrCalc_setfunc(&gsc.sc,"fsize",1,user_f_fsize,(LPVOID)fptbl) <= 0||
		StrCalc_setfunc(&gsc.sc,"tick",0,user_f_tickcount,0) <= 0){
		StrCalc_term(&gsc.sc);
		return "w֐̓o^Ɏs܂";
	}

	/* 萔̓o^ */
	if (StrCalc_setconst(&gsc.sc,"win_width",WIN_WIDTH) <= 0||
		StrCalc_setconst(&gsc.sc,"win_height",WIN_HEIGHT) <= 0||
		StrCalc_setconst(&gsc.sc,"console_width",CONSOLE_WIDTH) <= 0||
		StrCalc_setconst(&gsc.sc,"console_height",CONSOLE_HEIGHT) <= 0){
		StrCalc_term(&gsc.sc);
		return "萔o^Ɏs܂";
	}

	/* ϐ̋֎~[h */
	gsc.sc.ppcheck_paramname = ban_str;
	gsc.sc.nametbl_cnt = sizeof(ban_str) / sizeof(LPSTR);

	/* fCxg̍쐬 */
	if ((gsc.bas.proc_exparam = (LPVOID)CreateEvent(0,TRUE,FALSE,0)) == 0){
		StrCalc_term(&gsc.sc);
		return "CxgIuWFNg쐬Ɏs܂";
	}

	/*
	  @sleep ̒ǉp[^ɂfCxg̃nhn܂B
	  e[u user ł̓o^ʒuɒӂĂB
	*/
	user[0].param = gsc.bas.proc_exparam;

	/* [UXe[gg̓o^ */
	gsc.bas.pus = user;
	gsc.bas.uscnt = sizeof(user) / sizeof(USERSTATEMENT);

	/*
	  fĎ邽߁AXebvɌĂяoR[obN֐
	  gp܂B
	*/
	gsc.bas.fevery = (APPPROC)func_stopevent; /* callback.c */

	/* vOJnAIɌĂяoR[obN֐ł */
	gsc.bas.fprologue = (APPPROC)func_prologue; /* callback.c */
	gsc.bas.fepilogue = (APPPROC)func_epilogue; /* callback.c */

	/* ftHg̑s NULL Zbg܂B*/
	gsc.bas.psubst = NULL;
	gsc.bas.subst_exparam = NULL;

	/*
	  single character memory ͎gp܂

	  ł̓ftHgݒgp܂B
	*/
	/* gsc.sc.pmem = NULL; */
	/* gsc.sc.memmax = 0; */

	/******************************************************************/

	/* OtBbN`悷EChEgpݒ肵܂ */
	gwi.hInst = ghInst;
	gwi.hWndOwner = hWnd;
	gwi.pszWinName = gpszWinName;
	gwi.nWidth = WIN_WIDTH;
	gwi.nHeight = WIN_HEIGHT;
	gwi.phwChild = &gsc.hWndChild;

	/* EChEXbh̍쐬 */
	if ((gsc.hWinThread = (HANDLE)_beginthreadex(
		0,0,(THREAD_ROUTINE)grpWindow,(LPVOID)&gwi,0,&uID)) == 0){
		StrCalc_term(&gsc.sc);
		return "Xbh̍쐬Ɏs܂";
	}

	/* R\[̍쐬 */
	AllocConsole();
	SetConsoleCtrlHandler(HandlerRoutine,TRUE);

	ioh.hStdin = GetStdHandle(STD_INPUT_HANDLE);
	ioh.hStdout = GetStdHandle(STD_OUTPUT_HANDLE);

	SetConsoleMode(ioh.hStdin,
		ENABLE_LINE_INPUT | ENABLE_ECHO_INPUT | ENABLE_PROCESSED_INPUT);
	SetConsoleMode(ioh.hStdout,
		ENABLE_PROCESSED_OUTPUT | ENABLE_WRAP_AT_EOL_OUTPUT);

	init_dropfile(hWnd); /* dropfile.c */

	return 0;
}

BOOL WINAPI HandlerRoutine(DWORD dwCtrlType)
{
	switch(dwCtrlType){
		case	CTRL_C_EVENT:
		case	CTRL_BREAK_EVENT:
		case	CTRL_CLOSE_EVENT:
				break;

		case	CTRL_LOGOFF_EVENT:
		case	CTRL_SHUTDOWN_EVENT:
				return FALSE;
	}

	return TRUE;
}
