#include <windows.h>
#include <stdio.h>
#include "sc39.h"
#include "cio.h"
#include "fio.h"
#include "gio.h"
#include "scbas.h"
#include "resource.h"

INT		GetVal(HWND hWnd,INT id,INT min,LPSTR cap)
{
	BOOL		bSuccess;
	INT			ret;
	CHAR		buf[128];

	ret = (INT)GetDlgItemInt(hWnd,id,&bSuccess,TRUE);
	if (bSuccess == FALSE){
		sprintf(buf,"%sɕϊłȂ܂܂Ă܂",cap);
		MessageBox(hWnd,buf,gpszWinName,MB_OK | MB_ICONHAND);
		return -1;
	}

	if (ret < min){
		sprintf(buf,"%sɂ %d ȏ̐ݒ肵Ă",cap,min);
		MessageBox(hWnd,buf,gpszWinName,MB_OK | MB_ICONHAND);
		return -1;
	}

	return ret;
}

BOOL	set_OnOK(HWND hWnd)
{
	BOOL	bSuccess;
	UINT	seed = (UINT)gsc.bas.random_seed;
	INT		nif,nfor,ngos,nparen;

	gsc.bseed_timeset =
		(SendDlgItemMessage(hWnd,IDC_CHECK1,BM_GETCHECK,0L,0L) == BST_CHECKED);

	if (!gsc.bseed_timeset){
		seed = GetDlgItemInt(hWnd,IDC_EDIT1,&bSuccess,FALSE);
		if (bSuccess == FALSE){
			MessageBox(hWnd,"lɕϊłȂ܂܂Ă܂",
			gpszWinName,MB_OK | MB_ICONHAND);
			return FALSE;
		}
	}

	if ((nif = GetVal(hWnd,IDC_EDIT2,1,"if lXg")) < 0)
		return FALSE;
	if ((nfor = GetVal(hWnd,IDC_EDIT3,1,"for lXg")) < 0)
		return FALSE;
	if ((ngos = GetVal(hWnd,IDC_EDIT4,1,"gosub lXg")) < 0)
		return FALSE;
	if ((nparen = GetVal(hWnd,IDC_EDIT5,1,"ʐ")) < 0)
		return FALSE;

	gsc.bas.random_seed = seed;
	gsc.bas.stackcnt_if = nif;
	gsc.bas.stackcnt_for = nfor;
	gsc.bas.stackcnt_gosub = ngos;
	gsc.sc.paren_cnt = nparen;

	gsc.bas.b_localparam =
		SendDlgItemMessage(hWnd,IDC_CHECK2,BM_GETCHECK,0L,0L) == BST_CHECKED;
	gsc.bas.b_ignore_subcnt =
		SendDlgItemMessage(hWnd,IDC_CHECK3,BM_GETCHECK,0L,0L) == BST_CHECKED;
	gsc.bas.b_remark_colontype =
		SendDlgItemMessage(hWnd,IDC_CHECK4,BM_GETCHECK,0L,0L) == BST_CHECKED;
	gsc.bas.b_remark_ignorestr = 
		SendDlgItemMessage(hWnd,IDC_CHECK5,BM_GETCHECK,0L,0L) == BST_CHECKED;
	gsc.bas.b_check_dup_label =
		SendDlgItemMessage(hWnd,IDC_CHECK6,BM_GETCHECK,0L,0L) == BST_CHECKED;
	gsc.sc.b_hexchk =
		SendDlgItemMessage(hWnd,IDC_CHECK7,BM_GETCHECK,0L,0L) == BST_CHECKED;
	gsc.bas.b_removespace =
		SendDlgItemMessage(hWnd,IDC_CHECK8,BM_GETCHECK,0L,0L) == BST_CHECKED;

	gsc.bas.fevery =
		(SendDlgItemMessage(hWnd,IDC_CHECK9,BM_GETCHECK,0L,0L) == BST_CHECKED)?
		0 : (APPPROC)func_stopevent; /* callback.c */

	gsc.bprocess_count =
		SendDlgItemMessage(hWnd,IDC_CHECK10,BM_GETCHECK,0L,0L) == BST_CHECKED;

	return TRUE;
}

VOID	set_OnInitDialog(HWND hWnd)
{
	SCVER		v;
	CHAR		buf[256];

	StrCalc_getversion(&v);
	sprintf(buf,"ݒ - DLL Ver %s %s",v.ver,(v.bNormal)? "Normal" : "OldWin");
	SetWindowText(hWnd,buf);

	SetDlgItemInt(hWnd,IDC_EDIT1,gsc.bas.random_seed,FALSE);
	SetDlgItemInt(hWnd,IDC_EDIT2,gsc.bas.stackcnt_if,TRUE);
	SetDlgItemInt(hWnd,IDC_EDIT3,gsc.bas.stackcnt_for,TRUE);
	SetDlgItemInt(hWnd,IDC_EDIT4,gsc.bas.stackcnt_gosub,TRUE);
	SetDlgItemInt(hWnd,IDC_EDIT5,gsc.sc.paren_cnt,TRUE);

	if (gsc.bseed_timeset){
		SendDlgItemMessage(hWnd,IDC_CHECK1,BM_SETCHECK,BST_CHECKED,0L);
		EnableWindow(GetDlgItem(hWnd,IDC_EDIT1),FALSE);
	}

	SendDlgItemMessage(hWnd,IDC_CHECK2,BM_SETCHECK,
		(gsc.bas.b_localparam)? BST_CHECKED : BST_UNCHECKED,0L);
	SendDlgItemMessage(hWnd,IDC_CHECK3,BM_SETCHECK,
		(gsc.bas.b_ignore_subcnt)? BST_CHECKED : BST_UNCHECKED,0L);
	SendDlgItemMessage(hWnd,IDC_CHECK4,BM_SETCHECK,
		(gsc.bas.b_remark_colontype)? BST_CHECKED : BST_UNCHECKED,0L);
	SendDlgItemMessage(hWnd,IDC_CHECK5,BM_SETCHECK,
		(gsc.bas.b_remark_ignorestr)? BST_CHECKED : BST_UNCHECKED,0L);
	SendDlgItemMessage(hWnd,IDC_CHECK6,BM_SETCHECK,
		(gsc.bas.b_check_dup_label)? BST_CHECKED : BST_UNCHECKED,0L);
	SendDlgItemMessage(hWnd,IDC_CHECK7,BM_SETCHECK,
		(gsc.sc.b_hexchk)? BST_CHECKED : BST_UNCHECKED,0L);
	SendDlgItemMessage(hWnd,IDC_CHECK8,BM_SETCHECK,
		(gsc.bas.b_removespace)? BST_CHECKED : BST_UNCHECKED,0L);
	SendDlgItemMessage(hWnd,IDC_CHECK9,BM_SETCHECK,
		(!gsc.bas.fevery)? BST_CHECKED : BST_UNCHECKED,0L);
	SendDlgItemMessage(hWnd,IDC_CHECK10,BM_SETCHECK,
		(gsc.bprocess_count)? BST_CHECKED : BST_UNCHECKED,0L);
}

LRESULT CALLBACK	SetDlg(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	PAINTSTRUCT		ps;

	switch(Msg){
		case	WM_INITDIALOG:
				set_OnInitDialog(hWnd);
				break;

		case	WM_PAINT:
				BeginPaint(hWnd,&ps);
				EndPaint(hWnd,&ps);
				break;

		case	WM_CLOSE:
				EndDialog(hWnd,IDOK);
				break;

		case	WM_COMMAND:
				switch(LOWORD(wParam)){
					case	IDC_CHECK1:
							if (SendDlgItemMessage(
								hWnd,IDC_CHECK1,BM_GETCHECK,0L,0L) ==
								BST_CHECKED)
								EnableWindow(GetDlgItem(hWnd,IDC_EDIT1),FALSE);
							else
								EnableWindow(GetDlgItem(hWnd,IDC_EDIT1),TRUE);
							break;

					case	IDCANCEL:
							PostMessage(hWnd,WM_CLOSE,0L,0L);
							break;

					case	IDOK:
							if (set_OnOK(hWnd) == FALSE)
								break;
							EndDialog(hWnd,IDOK);
							break;
				}
				break;
		default:
				return FALSE;
	}
	return TRUE;
}

VOID	OnSetDlg(HWND hWnd)
{
	if (DialogBox(ghInst,MAKEINTRESOURCE(IDD_DIALOG2),
		hWnd,(DLGPROC)SetDlg) < 0){
		MessageBox(hWnd,"EChE̍쐬Ɏs܂B",
			gpszWinName,MB_OK | MB_ICONHAND);
	}
}

