#include <windows.h>
#include <process.h>
#include <stdio.h>
#include <conio.h>
#include "sc39.h"
#include "cio.h"
#include "fio.h"
#include "gio.h"
#include "scbas.h"

#define NAME_RETCODE		"extbas_retcode"
#define NAME_LINENO			"extbas_lineno"
#define NAME_SCRET			"extbas_scret"

INT		extcode(
			PSTRCALC_PARAM		prm,
			LPSTR				arg,
			INT					len,
			PINFO				pinfo)
{
	CHAR			filename[MAX_PATH+1];
	LPSTR			ptr,*pptbl;
	INT				ret;
	BASICPARAM		extbas;
	PARAM_INFO		inf;
	static LPSTR	ptbl[] = { NAME_RETCODE, NAME_LINENO, NAME_SCRET, 0 };

	CopyMemory(&extbas,&pinfo->bas,sizeof(BASICPARAM));

	extbas.b_srand = 0; /* srand sȂ */
 	extbas.b_us_check = 0; /* [UXe[gg͓Ȃ̂Ń`FbNȂ */

	/*
	  BASIC vOJn^IɎsR[obN𖳌ɂĂ܂B
	  f͕KvȂ̂ŁAfevery ͌ĂяoƓ̂gp܂B
	*/
	extbas.fprologue = NULL;
	extbas.fepilogue = NULL;

	/* t@C̎擾 */
	if (*(ptr = StrCalc_stringcopy(filename,arg,sizeof(filename))) != '\"' ||
		(extbas.psource = LoadFile(
			filename,&extbas.src_size,GetProcessHeap())) == NULL)
		return STATUS_OPEN_OPENERROR;

	do{
		ptr++;
	}while(isspace(*ptr));
	if (*ptr)
		return STATUS_ERROR; /* t@Čɂ͉LqȂ */

	ret = StrCalc_BASIC(prm,&extbas);
	HeapFree(GetProcessHeap(),0,extbas.psource);

	for(pptbl = ptbl;*pptbl;pptbl++){
		/* ̕ϐꍇ͍폜 */
		if (StrCalc_search_param(prm,*pptbl,&inf))
			StrCalc_delete_param(prm,*pptbl);

		/* ϐ̓o^ */
		strcpy(inf.name,*pptbl);
		inf.type = PRM_SINGLE;
		inf.btempflg = extbas.b_localparam;
		StrCalc_new_param(prm,&inf);
	}

	if (!StrCalc_search_param(prm,NAME_RETCODE,&inf))
		return STATUS_MEMERROR;
	*inf.pval = (double)ret;

	if (!StrCalc_search_param(prm,NAME_LINENO,&inf))
		return STATUS_MEMERROR;
	*inf.pval = (double)extbas.stop_lineno;

	if (!StrCalc_search_param(prm,NAME_SCRET,&inf))
		return STATUS_MEMERROR;
	*inf.pval = (double)extbas.sc_ret;

	/*
	  f{^ŒfꍇAĂяoIȂ
	  CxgZbgĂ
	*/
	if (ret == STATUS_USERABORT &&
		WaitForSingleObject(pinfo->bas.proc_exparam,0) == WAIT_OBJECT_0){
		ResetEvent(pinfo->bas.proc_exparam);
		EnableWindow(GetDlgItem(pinfo->hWnd,IDOK),TRUE);
		SetDlgItemText(pinfo->hWnd,IDOK,"f");
	}

	return STATUS_NORMAL;
}

/* StrCalc BASIC t@ČĂяo */
INT __stdcall	usr_extcode(
					PSTRCALC_PARAM		prm,
					LPSTR				arg,
					INT					len,
					PINFO				pinfo)
{
	INT		ret;

	if (pinfo->extcode_nestcnt > EXTCODE_NESTMAX)
		return STATUS_EXTCODE_OVERNEST;

	pinfo->extcode_nestcnt++;
	ret = extcode(prm,arg,len,pinfo);
	pinfo->extcode_nestcnt--;

	return ret;
}


