#include <stdio.h>
#include <stdlib.h>
#include "sc39.h"
#include "test.h"

#define BAS_FILE		"test.txt"

USERSTATEMENT		table[] = { /* [UXe[ggo^e[u */
	{ "print", 5, usr_print, NULL },
	{ "def", 3, usr_def, NULL }
};

int __cdecl		main(void)
{
	STRCALC_PARAM		sc;
	BASICPARAM			bas = {0};
	DEF_STRUCT			def = {0};
	int 				ret;

	ret = StrCalc_init(&sc);
	if (!ret){
		printf("Ɏs\n");
		return 0;
	}

	bas.stackcnt_if =
	bas.stackcnt_for =
	bas.stackcnt_gosub = 16;

	bas.b_localparam = 1;
	bas.b_check_dup_label = 1;

	table[1].param = &def;
	bas.pus = table;
	bas.uscnt = sizeof(table) / sizeof(USERSTATEMENT);

	bas.psource = load_src(BAS_FILE,&bas.src_size);
	if (!bas.psource){
		StrCalc_term(&sc);
		printf(BAS_FILE "I[vł܂\n");
		return 0;
	}

	ret = StrCalc_BASIC(&sc,&bas);

	StrCalc_term(&sc);
	free(bas.psource);
	def_free(&def);

	if (ret != STATUS_NORMAL)
		printf("line : %lu     error.   %d\n",
			bas.stop_lineno,ret);

	return 0;
}

