#include <windows.h>
#include "sc39x64.h"
#include "bmp.h"
#include "bmpproc.h"

/* t@CɃJgpXǉ */
LPSTR		CurrentPath(LPSTR filename)
{
	static CHAR		path[MAX_PATH+1];
	static CHAR		drv[MAX_PATH+1],dir[MAX_PATH+1];
	static BOOL		bOnce = FALSE;

	if (bOnce == FALSE){
		CHAR		cp[MAX_PATH+1];

		GetModuleFileName(NULL,cp,sizeof(cp));
		_splitpath(cp,drv,dir,NULL,NULL);
		bOnce = TRUE;
	}
	_makepath(path,drv,dir,filename,NULL);
	return path;
}

/* WM_CREATE */
INT		OnCreate(HWND hWnd)
{
	HDC			hDC;
	LPSTR		ptr;

	/* zEChE쐬 */
	if ((hDC = GetDC(hWnd)) == 0 ||
		(ginf.hVDC = CreateCompatibleDC(hDC)) == 0 ||
		(ginf.hVBmp = CreateCompatibleBitmap(hDC,WIN_WIDTH,WIN_HEIGHT)) == 0)
		return -1;
	ReleaseDC(hWnd,hDC);
	SelectObject(ginf.hVDC,ginf.hVBmp);
	PatBlt(ginf.hVDC,0,0,WIN_WIDTH,WIN_HEIGHT,BLACKNESS);

	/* rbg}bvt@C̓ǂݍ */
	if (!Load24bitBMP(CurrentPath(BMP_FILENAME),&ginf.bmpdata))
		return -1;

	/* StrCalc BASIC ̊Jn */
	if ((ptr = StartBASIC(hWnd)) != 0){
		MessageBox(hWnd,ptr,gpszWinName,MB_OK | MB_ICONHAND);
		return -1;
	}else
		ginf.bReady = TRUE;

	return 0;
}

/* WM_DESTROY */
VOID		OnDestroy(HWND hWnd)
{
	if (ginf.bas.proc_exparam) CloseHandle(ginf.bas.proc_exparam);
	if (ginf.hVDC) DeleteDC(ginf.hVDC);
	if (ginf.hVBmp) DeleteObject(ginf.hVBmp);
	FreeBMP(&ginf.bmpdata);
	if (ginf.bas.psource) free(ginf.bas.psource);
	if (ginf.bReady != FALSE) StrCalc_term(&ginf.sc);
}
