#include <windows.h>
#include <mbstring.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <conio.h>
#include "sc39x64.h"
#include "cust_prn.h"

INT64	usr_cls(PSTRCALC_PARAM prm,LPSTR arg,INT64 len,HANDLE hStdout)
{
	DWORD						dwCharsWritten,dwConsoleSize;
	CONSOLE_SCREEN_BUFFER_INFO	csbi;
	static COORD				coordScreen;

	if (len)
		return STATUS_ERROR;

	if (GetConsoleScreenBufferInfo(hStdout,&csbi) == FALSE)
		return STATUS_INTERNALERROR;

	dwConsoleSize = csbi.dwSize.X * csbi.dwSize.Y;
	FillConsoleOutputCharacter(
		hStdout,' ',dwConsoleSize,coordScreen,&dwCharsWritten);
	if (GetConsoleScreenBufferInfo(hStdout,&csbi) == FALSE)
		return STATUS_INTERNALERROR;

	FillConsoleOutputAttribute(hStdout,csbi.wAttributes,dwConsoleSize,
		coordScreen,&dwCharsWritten);
	SetConsoleCursorPosition(hStdout,coordScreen);

	return STATUS_NORMAL;
}

INT64	usr_locate(PSTRCALC_PARAM prm,LPSTR arg,INT64 len,HANDLE hStdout)
{
	double						pos[2];
	INT64						ret,x,y;
	COORD						coord;
	CONSOLE_SCREEN_BUFFER_INFO	csbi;

	if ((ret = StrCalc_getargs(prm,&arg,pos,2)) != STATUS_NORMAL)
		return ret;

	if (*arg)
		return STATUS_INVALIDARGS;

	if (GetConsoleScreenBufferInfo(hStdout,&csbi) == FALSE)
		return STATUS_INTERNALERROR;

	if ((x = (INT64)pos[0]) < 0)
		x = 0;
	else if (x >= csbi.dwSize.X)
		x = csbi.dwSize.X - 1;

	if ((y = (INT64)pos[1]) < 0)
		y = 0;
	else if (y >= csbi.dwSize.Y)
		y = csbi.dwSize.Y - 1;

	coord.X = (SHORT)x; coord.Y = (SHORT)y;
	SetConsoleCursorPosition(hStdout,coord);

	return STATUS_NORMAL;
}

INT64	usr_inkey(PSTRCALC_PARAM prm,LPSTR arg,INT64 len,HANDLE hStdout)
{
	INT64			dmy,ret;
	WORD			temp;
	PARAM_INFO		inf;

	if ((ret = StrCalc_get_paramname(
		prm,&arg,&inf,&dmy,&dmy)) != STATUS_NORMAL ||
		*arg || inf.type != PRM_SINGLE)
		return STATUS_ERROR;

	if (!_kbhit()){
		*inf.pval = 0.0;
		return STATUS_NORMAL;
	}
	temp = (WORD)(BYTE)_getch();

	if (!_kbhit()){
		*inf.pval = (double)temp;
		return STATUS_NORMAL;
	}

	temp = (WORD)((temp << 8) | (WORD)(BYTE)_getch());
	*inf.pval = (double)temp;

	return STATUS_NORMAL;
}

/* ̊֐ lifegame2.txt p̕\łB */

CHAR		vmem[22][80];

INT64	usr_lg_showparam(
			PSTRCALC_PARAM	prm,
			LPSTR			arg,
			INT64			len,
			HANDLE			hStdout)
{
	INT64			i,j;
	DWORD			dwWrite;
	PARAM_INFO		inf;

	/*
	  ϐŌA𓾂
	  񎟌zȊO̕ϐ̓G[Ƃ
	*/
	if (!StrCalc_search_param(prm,arg,&inf) || inf.type != PRM_DIM2)
		return STATUS_UNDEFINED_PARAM;

	for(i = 0;i < 22;i++){
		for(j = 1;j <= 78;j++)
			vmem[i][j] =
				(CHAR)((inf.pval[j * 24 + (i + 1)] != 0.0)? '*' : '.');
		vmem[i][j] = '\n';
	}

	WriteConsole(hStdout,(LPSTR)vmem,sizeof(vmem),&dwWrite,0);

	return STATUS_NORMAL;
}
