#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "sc39x64.h"
#include "graph.h"
#include "resource.h"

static VOID		init(HWND hWnd)
{
	CHAR		buf[64];

	sprintf(buf,"%.16G",mag);
	SetDlgItemText(hWnd,IDC_EDIT1,buf);
}

static BOOL		OnOK(HWND hWnd)
{
	CHAR		buf[64];
	LPSTR		pscan;
	double		temp;

	GetDlgItemText(hWnd,IDC_EDIT1,buf,sizeof(buf));

	/*
	  ł͕WCu strtod gpĂ܂A֐StrCalc 
	  pƁAl̓͂ɌvZgp鎖ł悤ɂȂ܂B
	*/
	temp = strtod(buf,&pscan);
	if (*pscan){
		MessageBox(hWnd,"lɕϊłȂgpĂ܂",
			gpszWinName,MB_OK | MB_ICONHAND);
		return FALSE;
	}

	if (temp <= 0.0){
		MessageBox(hWnd,"0 ܂͕̒l͎wł܂",
			gpszWinName,MB_OK | MB_ICONHAND);
		return FALSE;
	}

	mag = temp;
	return TRUE;
}

LRESULT CALLBACK	MagSetDlg(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	PAINTSTRUCT		ps;

	switch(Msg){
		case	WM_INITDIALOG:
				init(hWnd);
				break;

		case	WM_PAINT:
				BeginPaint(hWnd,&ps);
				EndPaint(hWnd,&ps);
				break;

		case	WM_CLOSE:
				EndDialog(hWnd,IDCANCEL);
				break;

		case	WM_COMMAND:
				switch(LOWORD(wParam)){
					case	IDCANCEL:
							PostMessage(hWnd,WM_CLOSE,0L,0L);
							break;

					case	IDOK:
							if (OnOK(hWnd) == FALSE) break;
							EndDialog(hWnd,IDOK);
							break;
				}
				break;
		default:
				return FALSE;
	}
	return TRUE;
}

BOOL	MagSet(HWND hWnd)
{
	DialogBox(ghInst,MAKEINTRESOURCE(IDD_DIALOG2),
		hWnd,(DLGPROC)MagSetDlg);
	return TRUE;
}
