#ifndef ___TEST_H_ONCE
#define ___TEST_H_ONCE

#include <windows.h>
#include <mbstring.h>
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>
#include "sc39x64.h"

#define FILENAME					"testbas.txt"

#define STATUS_LOCALMEM_OVERFLOW		(STATUS_USERABORT - 1)
#define STATUS_LOCAL_WITHOUT_ENDLOCAL	(STATUS_USERABORT - 2)

#define CNT_MAX						8

#ifdef ___MAIN_OBJECT
STRCALC_PARAM			prm_tbl[CNT_MAX];
INT64					index;
#else
extern STRCALC_PARAM	prm_tbl[CNT_MAX];
extern INT64			index;
#endif

VOID	basic_setting(PBASICPARAM);
LPSTR	load_src(LPSTR,UINT64 *);

INT64	inittbl(VOID);
VOID	freetbl(INT64);
INT64	copy_param(PSTRCALC_PARAM,PSTRCALC_PARAM,LPSTR);

INT64	func_epirogue(PSTRCALC_PARAM,LPVOID);
INT64	usr_local(PSTRCALC_PARAM,LPSTR,INT64,LPVOID);
INT64	usr_endlocal(PSTRCALC_PARAM,LPSTR,INT64,LPVOID);
INT64	usr_print(PSTRCALC_PARAM,LPSTR,INT64,HANDLE);

#endif
