#include "plotter.h"

/* t@Cǂݍ */
LPSTR		LoadFile(LPSTR pfilename,LPUINT64 psize)
{
	HANDLE		hFile;
	DWORD		dwRead,size;
	BOOL		bret;
	LPSTR		ptr;

	hFile = CreateFile(
				pfilename,
				GENERIC_READ,
				0,
				NULL,
				OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL,
				NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return NULL;

	if ((LONG)(size = GetFileSize(hFile,NULL)) <= 0 ||
		(ptr = malloc(size + 1)) == NULL)
	{
		CloseHandle(hFile);
		return NULL;
	}
	*psize = (UINT64)size;

	bret = ReadFile(hFile,ptr,size,&dwRead,NULL);
	CloseHandle(hFile);

	if (bret == FALSE || dwRead < size)
	{
		free(ptr);
		return NULL;
	}

	ptr[size] = 0;

	return ptr;
}
