#include "plotter.h"

INT WINAPI		WinMain(
					HINSTANCE		hInstance,
					HINSTANCE		hPrevInstance,
					LPSTR			pszArgv,
					INT				nCmdShow)
{
	HWND			hWnd,hWndOwner = GetDesktopWindow();
	WNDCLASSEX		wcx;
	MSG				m = {0};
	RECT			rect;
	INT				ret;

	wcx.cbSize = sizeof(WNDCLASSEX);
	wcx.style = 0;
	wcx.hInstance = hInstance;
	wcx.hCursor = LoadCursor(NULL,IDC_ARROW);
	wcx.lpfnWndProc = (WNDPROC)WndProc;
	wcx.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wcx.lpszClassName = gpszWinName;
	wcx.lpszMenuName = NULL;
	wcx.cbClsExtra = wcx.cbWndExtra = 0;
	wcx.hIcon = wcx.hIconSm = NULL;

	if (!RegisterClassEx(&wcx))
		return 0;

	/* XbhfCxg */
	if ((ghStop = CreateEvent(NULL,TRUE,FALSE,NULL)) == NULL)
		return 0;

	/* BASIC \[Xt@C̓ǂݍ */
	if ((gpsrc = LoadFile(SRC_FILE,&gsize)) == NULL){
		CloseHandle(ghStop);
		MessageBox(hWndOwner,SRC_FILE "̓ǂݍ݂Ɏs܂",
			gpszWinName,MB_OK | MB_ICONHAND);
		return 0;
	}

	/* StrCalc  */
	if (!StrCalc_init(&gsc)){
		CloseHandle(ghStop);
		free(gpsrc);
		MessageBox(hWndOwner,"StrCalc ̏Ɏs܂",
			gpszWinName,MB_OK | MB_ICONHAND);
		return 0;
	}

	#define STYLE_DISABLE	(WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX)
	#define WINSTYLE		(WS_OVERLAPPEDWINDOW ^ STYLE_DISABLE)

	rect.right = WIN_WIDTH;
	rect.bottom = WIN_HEIGHT;
	rect.left = rect.top = 0;
	AdjustWindowRect(&rect,WINSTYLE,FALSE);

	hWnd = CreateWindowEx(
			WS_EX_APPWINDOW,
			gpszWinName,
			gpszWinName,
			WINSTYLE,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			rect.right - rect.left,
			rect.bottom - rect.top,
			hWndOwner,
			NULL,
			hInstance,
			NULL);
	if (!hWnd)
		MessageBox(hWndOwner,"EChȄɎs܂",
			gpszWinName,MB_OK | MB_ICONHAND);
	else{
		ShowWindow(hWnd,nCmdShow);
		UpdateWindow(hWnd);

		while((ret = (INT)GetMessage(&m,NULL,0,0)) != 0 && ret != -1){
			TranslateMessage(&m);
			DispatchMessage(&m);
		}
	}

	CloseHandle(ghStop);
	free(gpsrc);
	StrCalc_term(&gsc);

	return (INT)m.wParam;
}
