#include "plotter.h"

/* J}ŋ؂ꂽQ̎擾ƍW̍XV */
static INT64	getarg(PSTRCALC_PARAM prm,LPSTR arg,LPINT px,LPINT py)
{
	double		val[2];
	INT64		ret;

	if ((ret = StrCalc_getargs(prm,&arg,val,2)) != STATUS_NORMAL)
		return ret;
	if (*arg)
		return STATUS_INVALIDARGS;

	gx += val[0];
	gy += val[1];

	if ((*px = (INT)gx) < 0)
		*px = 0;
	else if (*px >= WIN_WIDTH)
		*px = WIN_WIDTH - 1;

	if ((*py = (INT)gy) < 0)
		*py = 0;
	else if (*py >= WIN_HEIGHT)
		*py = WIN_HEIGHT - 1;

	return STATUS_NORMAL;
}

/* [UXe[gg move x , y */
INT64	usr_move(PSTRCALC_PARAM prm,LPSTR arg,INT64 len,LPVOID dmy)
{
	INT		x,y;
	INT64	ret;

	if ((ret = getarg(prm,arg,&x,&y)) != STATUS_NORMAL)
		return ret;

	MoveToEx(ghVDC,x,y,NULL);
	MoveToEx(ghDC,x,y,NULL);

	return STATUS_NORMAL;
}

/* [UXe[gg draw x , y */
INT64	usr_draw(PSTRCALC_PARAM prm,LPSTR arg,INT64 len,LPVOID dmy)
{
	INT		x,y;
	INT64	ret;

	if ((ret = getarg(prm,arg,&x,&y)) != STATUS_NORMAL)
		return ret;

	LineTo(ghVDC,x,y);
	LineTo(ghDC,x,y);

	return STATUS_NORMAL;
}

/* [UXe[gg chpen c */
INT64	usr_chpen(PSTRCALC_PARAM prm,LPSTR arg,INT64 len,LPVOID dmy)
{
	INT64		ret;
	HPEN		hPen;

	prm->str = arg;
	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;

	if ((hPen = CreatePen(PS_SOLID,1,(COLORREF)prm->ans)) == NULL)
		return STATUS_CHANGEPEN_ERROR;

	DeleteObject(ghPen);

	ghPen = hPen;
	SelectObject(ghVDC,hPen);
	SelectObject(ghDC,hPen);

	return STATUS_NORMAL;
}

/* [UXe[gg resetpos */
INT64	usr_resetpos(PSTRCALC_PARAM prm,LPSTR arg,INT64 len,LPVOID dmy)
{
	if (len)
		return STATUS_ERROR;

	gx = ORG_X;
	gy = ORG_Y;

	MoveToEx(ghVDC,0,0,NULL);
	MoveToEx(ghDC,0,0,NULL);

	return STATUS_NORMAL;
}
