#include "plotter.h"

LRESULT CALLBACK		WndProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	switch(Msg){
		case	WM_CREATE:
				return OnCreate(hWnd); /* init.c */

		case	WM_PAINT:
				OnPaint(hWnd); /* paint.c */
				break;

		case	WM_CLOSE:
				if (WaitForSingleObject(ghThread,250) != WAIT_OBJECT_0){
					SetEvent(ghStop);
					PostMessage(hWnd,WM_CLOSE,0L,0L);
					break;
				}

				OnClose(hWnd); /* init.c */
				DestroyWindow(hWnd);
				break;

		case	WM_DESTROY:
				PostQuitMessage(0);
				break;

		case	WM_LBUTTONDOWN:
				SetEvent(ghStop);
				break;

		case	WM_USER:
				OnUser(hWnd,(INT64)wParam); /* onuser.c */
				break;

		default:
				return DefWindowProc(hWnd,Msg,wParam,lParam);
	}

	return 0;
}
