#include <windows.h>
#include <string.h>
#include "sc39x64.h"
#include "smpbas.h"

INT64	SimpleBasic::check_paramname(LPSTR name)
{
	return StrCalc_check_paramname(&sp,name);
}

INT64	SimpleBasic::delete_param(LPSTR name)
{
	return StrCalc_delete_param(&sp,name);
}

INT64	SimpleBasic::delete_param_all(VOID)
{
	return StrCalc_delete_param_all(&sp);
}

INT64	SimpleBasic::delete_tempparam(VOID)
{
	return StrCalc_delete_tempparam(&sp);
}

INT64	SimpleBasic::delete_userfunc(LPSTR name)
{
	return StrCalc_delete_userfunc(&sp,name);
}

INT64	SimpleBasic::enumerate_param(EP_CALLBACK pfunc,LPVOID param)
{
	return StrCalc_enumerate_param(&sp,pfunc,param);
}

INT64	SimpleBasic::get_paramname(
			LPSTR *pptr,PPARAM_INFO pinf,LPINT64 px,LPINT64 py)
{
	return StrCalc_get_paramname(&sp,pptr,pinf,px,py);
}

INT64	SimpleBasic::new_param(PPARAM_INFO pinf)
{
	return StrCalc_new_param(&sp,pinf);
}

INT64	SimpleBasic::new_param(LPSTR name,INT64 btemp)
{
	PARAM_INFO		inf;

	inf.type = PRM_SINGLE;
	strcpy(inf.name,name);
	inf.btempflg = btemp;

	return StrCalc_new_param(&sp,&inf);
}

INT64	SimpleBasic::new_param(LPSTR name,INT64 cnt,INT64 btemp)
{
	PARAM_INFO		inf;

	inf.type = PRM_DIM1;
	strcpy(inf.name,name);
	inf.width = cnt;
	inf.btempflg = btemp;

	return StrCalc_new_param(&sp,&inf);
}

INT64	SimpleBasic::new_param(LPSTR name,INT64 w,INT64 h,INT64 btemp)
{
	PARAM_INFO		inf;

	inf.type = PRM_DIM2;
	strcpy(inf.name,name);
	inf.width = w;
	inf.height = h;
	inf.btempflg = btemp;

	return StrCalc_new_param(&sp,&inf);
}

INT64	SimpleBasic::search_param(LPSTR name,PPARAM_INFO pinf)
{
	return StrCalc_search_param(&sp,name,pinf);
}

INT64	SimpleBasic::set_tempflag(LPSTR name,INT64 bflag)
{
	return StrCalc_set_tempflag(&sp,name,bflag);
}

INT64	SimpleBasic::setconst(LPSTR name,double val)
{
	return StrCalc_setconst(&sp,name,val);
}

INT64	SimpleBasic::setfunc(LPSTR name,INT64 argcnt,MFUNC pfunc,LPVOID param)
{
	return StrCalc_setfunc(&sp,name,argcnt,pfunc,param);
}

INT64	SimpleBasic::substitution(
			LPSTR str,INT64 btemp,PPARAM_INFO pinf,LPINT64 px,LPINT64 py)
{
	return StrCalc_substitution(&sp,str,btemp,pinf,px,py);
}

INT64	SimpleBasic::substitution(LPSTR str,INT64 btemp)
{
	return StrCalc_substitution(&sp,str,btemp,NULL,NULL,NULL);
}

INT64	SimpleBasic::getargs(LPSTR *pptr,double *args,INT64 argcnt)
{
	return  StrCalc_getargs(&sp,pptr,args,argcnt);
}

INT64	SimpleBasic::get_parenargs(LPSTR *pptr,double *args,INT64 argcnt)
{
	return  StrCalc_get_parenargs(&sp,pptr,args,argcnt);
}
