#ifndef ___SIMPLE_BASIC_H_ONCE
#define ___SIMPLE_BASIC_H_ONCE

#define STATUS_SRC_NOTREADY			-10000

typedef INT64		*LPINT64;
typedef UINT64		*LPUINT64;

class SimpleBasic{
	BASICPARAM			bp;
	STRCALC_PARAM		sp;

	BOOL				b_init_success; // ɐ^s
	LPSTR				psrc;           // BASIC \[XiNULL ͖ǁj
	UINT64				src_size;       // BASIC \[XTCY
	INT64				bas_ret;        // I ԃR[h

	VOID		init(VOID);

public:
	SimpleBasic(LPSTR pfilename = NULL,SimpleBasic **ppfunc = NULL);
	SimpleBasic(SimpleBasic &);
	~SimpleBasic();

	BOOL		calc(LPSTR,double *);
	BOOL		load_src(LPSTR);
	BOOL		run(VOID);
	BOOL		run(LPSTR);
	LPSTR		erroe_mes(BOOL);
	BOOL		check_subrange(VOID);

	INT64		substitution(LPSTR,INT64,PPARAM_INFO,LPINT64,LPINT64);
	INT64		substitution(LPSTR,INT64);
	INT64		check_paramname(LPSTR);
	INT64		delete_param(LPSTR);
	INT64		delete_param_all(VOID);
	INT64		delete_tempparam(VOID);
	INT64		delete_userfunc(LPSTR);
	INT64		enumerate_param(EP_CALLBACK,LPVOID);
	INT64		get_paramname(LPSTR *,PPARAM_INFO,LPINT64,LPINT64);
	INT64		new_param(PPARAM_INFO);
	INT64		new_param(LPSTR,INT64);
	INT64		new_param(LPSTR,INT64,INT64);
	INT64		new_param(LPSTR,INT64,INT64,INT64);
	INT64		search_param(LPSTR,PPARAM_INFO);
	INT64		set_tempflag(LPSTR,INT64);
	INT64		setconst(LPSTR,double);
	INT64		setfunc(LPSTR,INT64,MFUNC,LPVOID);
	INT64		getargs(LPSTR *,double *,INT64);
	INT64		get_parenargs(LPSTR *,double *,INT64);
};

#endif
