#include <windows.h>
#include <process.h>
#include <stdio.h>
#include "sc39x64.h"
#include "cio.h"
#include "fio.h"
#include "gio.h"
#include "scbas.h"
#include "resource.h"

static WNDPROC		gDefProc;
static CHAR			gszFileName[MAX_PATH+1];

LRESULT CALLBACK	EditProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam)
{
	HDROP		hDrop;

	if (Msg != WM_DROPFILES)
		return CallWindowProc(gDefProc,hWnd,Msg,wParam,lParam);

	hDrop = (HDROP)wParam;
	DragQueryFile(hDrop,0,gszFileName,sizeof(gszFileName));
	DragFinish(hDrop);
	SetWindowText(hWnd,gszFileName);

	return 0;
}

VOID		init_dropfile(HWND hWnd)
{
	HWND	hCtrl = GetDlgItem(hWnd,IDC_EDIT1);

	gDefProc = (WNDPROC)GetWindowLongPtr(hCtrl,GWLP_WNDPROC);
	SetWindowLongPtr(hCtrl,GWLP_WNDPROC,(LONG_PTR)EditProc);
}

