#ifndef ___FIO_H_ONCE
#define ___FIO_H_ONCE

#define MAX_FILE					16

#define STATUS_OPEN_FILENAMEERR			-2000
#define STATUS_OPEN_SYNTAXERROR			-2001
#define STATUS_OPEN_MODEERR				-2002
#define STATUS_OPEN_INVALIDFILENO		-2003
#define STATUS_OPEN_ALREADY				-2004
#define STATUS_OPEN_OPENERROR			-2005
#define STATUS_WRITE_INVALIDFILENO		-2006
#define STATUS_WRITE_SYNTAXERROR		-2007
#define STATUS_WRITE_ERROR				-2008
#define STATUS_FPRINT_INVALIDFILENO		-2009
#define STATUS_FPRINT_SYNTAXERROR		-2010
#define STATUS_FPRINT_ERROR				-2011
#define STATUS_READF_INVALIDFILENO		-2012
#define STATUS_READF_SYNTAXERROR		-2013
#define STATUS_READF_ERROR				-2014
#define STATUS_CLOSE_INVALIDFILENO		-2015
#define STATUS_CLOSE_SYNTAXERROR		-2016

#define STATUS_FUNC_INVALIDFLENO		-31

DECLARE VOID		fio_close(FILE **);

DECLARE INT64		usr_open(PSTRCALC_PARAM,LPSTR,INT64,FILE **);
DECLARE INT64		usr_read(PSTRCALC_PARAM,LPSTR,INT64,FILE **);
DECLARE INT64		usr_write(PSTRCALC_PARAM,LPSTR,INT64,FILE **);
DECLARE INT64		usr_fprint(PSTRCALC_PARAM,LPSTR,INT64,FILE **);
DECLARE INT64		usr_close(PSTRCALC_PARAM,LPSTR,INT64,FILE **);

DECLARE double		user_f_fsize(double *,INT64,INT64 *,FILE **);

#endif
