#include <windows.h>
#include <stdio.h>
#include "sc39x64.h"
#include "textedit.h"
#include "fio.h"
#include "local.h"

INT64	cb_fprint(LPSTR psrc,UINT64 len,BOOL bfinish,FILE *fp)
{
	return (fwrite(psrc,1,(size_t)len,fp) < (size_t)len)?
		STATUS_FPRINT_ERROR : STATUS_NORMAL;
}

/* ̏óB cio  @print Ƃقړł */
DECLARE INT64	usr_fprint(
					PSTRCALC_PARAM		prm,
					LPSTR				arg,
					INT64				len,
					FILE				**fptbl)
{
	FILE	*fp;

	switch(get_fileno(prm,&arg,fptbl,&fp,FALSE)){
		case	INVALID_FILENO:
				return STATUS_FPRINT_INVALIDFILENO;

		case	SYNTAXERROR:
				return STATUS_FPRINT_SYNTAXERROR;
	}

	return text_edit(
		prm,arg,(TEXTEDIT_CALLBACK)cb_fprint,fp); /* textedit\textedit.c */
}
