#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "sc39x64.h"
#include "fio.h"

static BOOL		check_keyword(LPSTR ptarget,LPSTR psrc,INT64 len)
{
	return isspace(ptarget[-1]) &&
		!_strnicmp(ptarget,psrc,len) &&
		isspace(ptarget[len]);
}

typedef struct {
	LPSTR		str;  /* [h */
	INT64		len;  /* [h̒(byte) */
	LPSTR		mode; /* ֐fopen ɓn[h */
}MODE,*PMODE;

enum { MODE_INPUT = 0, MODE_OUTPUT, MODE_APPEND, MODE_MAX };

MODE		open_mode[MODE_MAX] = {
	{ "input", 5, "rb" }, { "output", 6, "wb" }, { "append", 6, "ab" }
};

/* t@CI[v */
DECLARE INT64	usr_open(
					PSTRCALC_PARAM		prm,
					LPSTR				arg,
					INT64				len,
					FILE				**fptbl)
{
	CHAR		filename[MAX_PATH+8];
	LPSTR		ptr;
	INT64		mode,fidx;

	/* t@C̎擾 */
	if (*(ptr = StrCalc_stringcopy(filename,arg,sizeof(filename))) != '\"')
		return STATUS_OPEN_FILENAMEERR;

	/* 㑱 for LqĂ邩`FbN */
	do{
		ptr++;
	}while(isspace(*ptr));

	if (!check_keyword(ptr,"for",3))
		return STATUS_OPEN_SYNTAXERROR;

	/* [hŃe[uQƂ */
	ptr += 3;
	while(isspace(*ptr))
		ptr++;

	for(mode = 0;mode < MODE_MAX;mode++){
		if (check_keyword(ptr,open_mode[mode].str,open_mode[mode].len))
			break;
	}
	if (mode >= MODE_MAX)
		return STATUS_OPEN_MODEERR;

	/* 㑱 as LqĂ邩`FbN */
	ptr += open_mode[mode].len;
	while(isspace(*ptr))
		ptr++;

	if (!check_keyword(ptr,"as",2))
		return STATUS_OPEN_SYNTAXERROR;

	/* 㑱 # LqĂ邩`FbN */
	ptr += 2;
	while(isspace(*ptr))
		ptr++;

	if (*ptr != '#')
		return STATUS_OPEN_SYNTAXERROR;

	/* t@Cԍ̎擾 */
	prm->str = ++ptr;
	if (StrCalc(prm) != STATUS_NORMAL ||
		(fidx = (INT64)prm->ans) <= 0 || fidx > MAX_FILE)
		return STATUS_OPEN_INVALIDFILENO;

	if (fptbl[--fidx])
		return STATUS_OPEN_ALREADY;

	return ((fptbl[fidx] = fopen(filename,open_mode[mode].mode)) == NULL)?
		STATUS_OPEN_OPENERROR : STATUS_NORMAL;
}
