#include <windows.h>
#include <stdio.h>
#include "sc39x64.h"
#include "fio.h"
#include "local.h"

/* lf[^idouble^j̏ */
DECLARE INT64	usr_write(
					PSTRCALC_PARAM		prm,
					LPSTR				ptr,
					INT64				len,
					FILE				**fptbl)
{
	FILE			*fp;
	INT64			ret;
	double			val;

	switch(get_fileno(prm,&ptr,fptbl,&fp,FALSE)){
		case	INVALID_FILENO:
				return STATUS_WRITE_INVALIDFILENO;

		case	SYNTAXERROR:
				return STATUS_WRITE_SYNTAXERROR;
	}

	while(*ptr){
		if ((ret = StrCalc_getargs(prm,&ptr,&val,1)) != STATUS_NORMAL)
			return ret;

		if (!fwrite(&prm->ans,sizeof(double),1,fp))
			return STATUS_WRITE_ERROR;
		ptr += *ptr != 0;
	}

	return STATUS_NORMAL;
}
