#include <windows.h>
#include "sc39x64.h"
#include "gio.h"
#include "local.h"

DECLARE INT64	usr_line(
					PSTRCALC_PARAM		prm,
					LPSTR				arg,
					INT64				len,
					LPVOID				dmy)
{
	double		val[5];
	HPEN		hPen,hOldPen;
	INT64		ret;
	INT			x1,y1,x2,y2;

	if ((ret = StrCalc_getargs(prm,&arg,val,5)) != STATUS_NORMAL)
		return ret;

	if (*arg)
		return STATUS_INVALIDARGS;

	if ((x1 = (INT)val[0]) < 0)
		x1 = 0;
	else if (x1 >= gnWidth)
		x1 = gnWidth - 1;
	if ((y1 = (INT)val[1]) < 0)
		y1 = 0;
	else if (y1 >= gnHeight)
		y1 = gnHeight - 1;

	if ((x2 = (INT)val[2]) < 0)
		x2 = 0;
	else if (x2 >= gnWidth)
		x2 = gnWidth - 1;
	if ((y2 = (INT)val[3]) < 0)
		y2 = 0;
	else if (y2 >= gnHeight)
		y2 = gnHeight - 1;

	hPen = CreatePen(PS_SOLID,1,(DWORD)val[4]);

	hOldPen = SelectObject(ghDC,hPen);
	MoveToEx(ghDC,x1,y1,NULL);
	LineTo(ghDC,x2,y2);
	SelectObject(ghDC,hOldPen);

#ifdef SHOW_PROGRESS
	hOldPen = SelectObject(ghDC_main,hPen);
	MoveToEx(ghDC_main,x1,y1,NULL);
	LineTo(ghDC_main,x2,y2);
	SelectObject(ghDC_main,hOldPen);
#endif

	DeleteObject(hPen);

	return STATUS_NORMAL;
}
