#include <windows.h>
#include <ctype.h>
#include "sc39x64.h"
#include "textedit.h"
#include "gio.h"
#include "local.h"

INT64	cb_textout(LPSTR psrc,UINT64 len,BOOL bfinish,PMEMINFO pi)
{
	if (bfinish == TRUE) /* s̉s͏o͂Ȃ */
		return STATUS_NORMAL;

	return (textedit_chain(pi,psrc,len) == FALSE)? /* textedit\chain.c */
		STATUS_NOTENOUGHMEM : STATUS_NORMAL;
}

/* ̕` */
DECLARE INT64	usr_textout(
					PSTRCALC_PARAM		prm,
					LPSTR				ptr,
					INT64				len,
					LPVOID				dmy)
{
	double		val[3];
	INT			x,y,color;
	INT64		ret;
	MEMINFO		mi;

	/* x,y,color ܂Ŏ擾 */
	if ((ret = StrCalc_getargs(prm,&ptr,val,3)) != STATUS_NORMAL)
		return ret;

	if (*ptr != ',') /* ԂɃJ}鎖 */
		return STATUS_INVALIDARGS;

	/* 㑱̕񎮂ҏW */
	mi.pmem = NULL;
	ret = text_edit(
		prm,++ptr,(TEXTEDIT_CALLBACK)cb_textout,&mi); /* textedit\textedit.c */
	if (ret != STATUS_NORMAL){
		textedit_free(&mi); /* textedit\chain.c */
		return ret;
	}

	if (!mi.pmem) /* \ꍇ */
		return STATUS_NORMAL;

	if ((x = (INT)val[0]) < 0)
		x = 0;
	else if (x >= gnWidth)
		x = gnWidth - 1;
	if ((y = (INT)val[1]) < 0)
		y = 0;
	else if (y >= gnHeight)
		y = gnHeight - 1;

	SetTextColor(ghDC,color = (DWORD)val[2]);
	TextOut(ghDC,x,y,mi.pmem,(DWORD)mi.use);

#ifdef SHOW_PROGRESS
	SetTextColor(ghDC_main,color);
	TextOut(ghDC_main,x,y,mi.pmem,(DWORD)mi.use);
#endif

	textedit_free(&mi); /* textedit\chain.c */

	return STATUS_NORMAL;
}
