#include <windows.h>
#include <stdlib.h>
#include "sc39x64.h"
#include "textedit.h"

static BOOL		memalloc(PMEMINFO pi,UINT64 allocsize)
{
	LPSTR	ptemp;

	allocsize = ((allocsize >> 5) + 1) << 5;
	if ((ptemp = realloc(pi->pmem,allocsize + 1)) == NULL)
		return FALSE;

	pi->pmem = ptemp;
	pi->allocsize = allocsize;

	return TRUE;
}

/* ̐ƕ̘A */
DECLARE BOOL	textedit_chain(PMEMINFO pi,LPSTR pstr,UINT64 len)
{
	if (!pi->pmem){ /* VK̏ꍇ */
		if (memalloc(pi,len) == FALSE)
			return FALSE;

		CopyMemory(pi->pmem,pstr,len);
		pi->use = len;

	}else{ /* ɊmۂĂꍇ */

		UINT64	size = pi->use + len;

		if (size > pi->allocsize && memalloc(pi,size) == FALSE)
			return FALSE;

		CopyMemory(pi->pmem + pi->use,pstr,len);
		pi->use = size;
	}

	return TRUE;
}

/* ̉ */
DECLARE VOID	textedit_free(PMEMINFO pi)
{
	if (pi->pmem)
		free(pi->pmem);
}
