#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "sc39x64.h"
#include "test.h"

/* 󔒂̃Rs[ */
static __int64	copystr(char *pdest,char *psrc,__int64 size)
{
	__int64		len;

	for(len = 0;*psrc;psrc++){
		if (isspace(*psrc))
			continue;

		if (len >= size) /* ߂ꍇ */
			return -1;
		*pdest++ = *psrc;
		len++;
	}
	*pdest = 0;

	/* Rs[Ȃꍇ -1AI͕񒷂Ԃ */
	return (len)? len : -1;
}

/* ̍쐬 */
__int64		create_argtbl(char *ptr,PARG pa)
{
	char		*pleft,*ptemp;
	__int64		len,i;
	PARG_LIST	pl;

	/* Ă銇ʂ̐擪 */
	pleft = ptr;
	while(*pleft && *pleft != '(')
		pleft++;

	if (*pleft != '(')
		return STATUS_NEED_START_PAREN;
	ptemp = pleft; /* ̊JnʒuɂȂ邽ߕۑ */
	*ptemp = 0;

	/* Ă銇ʂ̖ */
	do{
		pleft++;
	}while(*pleft && *pleft != ')');

	if (*pleft != ')')
		return STATUS_NEED_LAST_PAREN;
	*pleft = 0;

	/* CR[̌ */
	do{
		pleft++;
	}while(isspace(*pleft));

	if (*pleft != '=')
		return STATUS_NEED_EQUAL;

	/* ֐Rs[ */
	if (copystr(pa->name,ptr,SC_MAX_PARAMNAME) < 0)
		return STATUS_ILLEGALFUNCTIONCALL;

	ptr = ptemp + 1; /* Jnʂ̎ */
	pl = pa->list;

	/* ̎擾 */
	for(ptr = strtok(ptr,",");ptr;ptr = strtok(NULL,",")){
		while(isspace(*ptr))
			ptr++;
		if (!*ptr)
			continue; /* 󔒂ꍇ͔΂ */

		if (pa->arg_cnt >= MAX_ARGS) /* ̌`FbN */
			return STATUS_ILLEGALFUNCTIONCALL;

		/* ̃Rs[ */
		if ((pl->len = copystr(pl->name,ptr,SC_MAX_PARAMNAME)) < 0)
			return STATUS_ILLEGALFUNCTIONCALL;

		pl++;
		pa->arg_cnt++;
	}

	/* Eӂ̃Rs[ */
	ptr = pleft + 1;
	if ((pa->rightside = malloc(strlen(ptr) + 1)) == NULL)
		return STATUS_NOTENOUGHMEM;
	strcpy(pa->rightside,ptr);

	/* ̊֘At */
	ptr = pa->rightside;
	do{
		/* 󔒂Ƌ؂蕶΂ */
		while(isspace(*ptr) || StrCalc_issep(*ptr))
			ptr++;
		if (!*ptr)
			break;

		/* 󔒁A؂蕶oʒui[h̖j */
		ptemp = ptr;
		while(*ptemp && !isspace(*ptemp) && !StrCalc_issep(*ptemp))
			ptemp++;
		len = ptemp - ptr; /* [h */

		/* XgɈv̂邩ׂ */
		pl = pa->list;
		for(i = 0;i < pa->arg_cnt;i++,pl++){
			if (pl->len == len && !_strnicmp(pl->name,ptr,len)){
				*ptr = (char)('' + i); /* scm */

				if (len > 1) /* c͋̕󔒂ɂ */
					memset(ptr + 1,' ',len - 1);

				break;
			}
		}

		ptr = ptemp; /* ̌ʒu */
		while(isspace(*ptr))
			ptr++;

	}while(*ptr);

	return STATUS_NORMAL;
}
