#include <stdio.h>
#include <io.h>
#include <memory.h>
#include <time.h>
#include <stdlib.h>
#include "sc39.h"

/*
    F

        @print  l܂͌vZ
*/
int __stdcall	usr_print(PSTRCALC_PARAM prm,char *arg,int len,void *param)
{
	int 		ret;

	prm->str = arg;
	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;

	printf("%.16G\n",prm->ans);

	return STATUS_NORMAL;
}

USERSTATEMENT		table[] = {
	{ "print", 5, usr_print, NULL }
};

void		basic_setting(PBASICPARAM pbas)
{
	pbas->random_seed = (unsigned)time(NULL);
	pbas->stackcnt_if = 16;
	pbas->stackcnt_for = 16;
	pbas->stackcnt_gosub = 16;
	pbas->b_localparam = 1;
	pbas->b_ignore_subcnt = 0;
	pbas->b_remark_colontype = 0;
	pbas->b_remark_ignorestr = 0;
	pbas->b_check_dup_label = 1;
	pbas->b_naked_us = 0;
	pbas->b_us_check = 0;
	pbas->b_removespace = 0;
	pbas->b_srand = 1;

	pbas->fprologue = NULL;
	pbas->fevery = NULL;
	pbas->fepilogue = NULL;
	pbas->proc_exparam = NULL;

	pbas->psubst = NULL;
	pbas->subst_exparam = NULL;

	pbas->pus = table;
	pbas->uscnt = sizeof(table) / sizeof(USERSTATEMENT);
}

/* t@CTCỸmۂAeLXgǂݍ */
char	*load_src(char *filename,unsigned long *psize)
{
	FILE		*fp;
	char		*ptr;
	size_t		ret,size;

	if ((fp = fopen(filename,"rb")) == NULL)
		return NULL;

	if ((long)(size = _filelength(_fileno(fp))) <= 0 ||
		(ptr = (char *)malloc(size + 1)) == NULL)
	{
		fclose(fp);
		return NULL;
	}
	*psize = size;

	ret = fread(ptr,1,size,fp);
	fclose(fp);

	if (ret < size){
		free(ptr);
		return NULL;
	}

	ptr[size] = 0;
	return ptr;
}

#define FILENAME			"testbas.txt"

void	main(void)
{
	STRCALC_PARAM		sc;
	BASICPARAM			bas;
	int 				ret;

	if (!StrCalc_init(&sc)){
		printf("Ɏs\n");
		return;
	}

	basic_setting(&bas);

	if ((bas.psource = load_src(FILENAME,&bas.src_size)) == NULL){
		StrCalc_term(&sc);
		printf("t@C̓ǂݍ݂Ɏs\n");
		return;
	}

	ret = StrCalc_BASIC(&sc,&bas);

	StrCalc_term(&sc);
	free(bas.psource);

	if (ret != STATUS_NORMAL)
		printf("line : %lu     error.   %d\n",bas.stop_lineno,ret);
}
