#include <stdio.h>
#include <string.h>
#include <memory.h>
#include "sc39x64.h"

#define STATUS_USR_ALREADY			-9999
#define STATUS_USR_NOTREADY 		-9998

__int64 			gbActive;
STRCALC_PARAM		gtemp_sc;

/* @enter */
__int64		usr_enter(PSTRCALC_PARAM prm,char *arg,__int64 len,void *param)
{
	/* ł͊ȒP̂߁A㑱ɕ񂪑݂ꍇ̓G[Ƃ܂B */
	if (len)
		return STATUS_ERROR;

	/*  @enter sĂꍇ̓G[Ƃ */
	if (gbActive)
		return STATUS_USR_ALREADY;

	memcpy(&gtemp_sc,prm,sizeof(STRCALC_PARAM)); /* ݂̊ޔ */

	if (!StrCalc_init(prm)){ /* V\z */

		/* Ɏsꍇ́AޔĂɖ߂ */
		memcpy(prm,&gtemp_sc,sizeof(STRCALC_PARAM));
		return STATUS_NOTENOUGHMEM;
	}

	gbActive = 1; /* ؂ւ */
	return STATUS_NORMAL;
}

/* @leave */
__int64		usr_leave(PSTRCALC_PARAM prm,char *arg,__int64 len,void *param)
{
	/* ł͊ȒP̂߁A㑱ɕ񂪑݂ꍇ̓G[Ƃ܂B */
	if (len)
		return STATUS_ERROR;

	/* @enter sĂȂꍇ̓G[Ƃ */
	if (!gbActive)
		return STATUS_USR_NOTREADY;

	StrCalc_term(prm); /* ݂̊j */
	memcpy(prm,&gtemp_sc,sizeof(STRCALC_PARAM)); /* ȑO̊߂ */

	gbActive = 0; /*  */
	return STATUS_NORMAL;
}

/* @print */
__int64		usr_print(PSTRCALC_PARAM prm,char *arg,__int64 len,void *param)
{
	__int64		ret;

	prm->str = arg;
	if ((ret = StrCalc(prm)) != STATUS_NORMAL)
		return ret;

	printf("%.16G\n",prm->ans);

	return STATUS_NORMAL;
}

USERSTATEMENT		table[] = {
	{ "print", 5, usr_print, NULL },
	{ "enter", 5, usr_enter, NULL },
	{ "leave", 5, usr_leave, NULL }
};

void	main(void)
{
	STRCALC_PARAM		sc;
	BASICPARAM			bas = {0};
	__int64				ret;

	if (!StrCalc_init(&sc)){
		printf("Ɏs\n");
		return;
	}

	bas.stackcnt_if = 16;
	bas.stackcnt_for = 16;
	bas.stackcnt_gosub = 16;

	bas.pus = table;
	bas.uscnt = sizeof(table) / sizeof(USERSTATEMENT);

	bas.psource = "\
\n\
		a = 10 : b = 20 : c = 30\n\
		gosub $test_sub\n\
		@print a : @print b : @print c\n\
		end\n\
\n\
	$test_sub\n\
		@enter\n\
\n\
		a = 1000 : b = 2000 : c = 3000\n\
		@print a : @print b : @print c\n\
\n\
		@leave\n\
\n\
		return\n\
	";
	bas.src_size = strlen(bas.psource);

	ret = StrCalc_BASIC(&sc,&bas);

	/*
	  G[Lq~X @leave sȂ́A
	   @leave ̏s
	*/
	if (gbActive && usr_leave(&sc,"",0,NULL) != STATUS_NORMAL)
		printf("debug : @leave error.\n");

	StrCalc_term(&sc);

	if (ret != STATUS_NORMAL)
		printf("line : %I64u     error.   %I64d\n",bas.stop_lineno,ret);
}
