#include <stdlib.h>
#include <ctype.h>
#include "sc39x64.h"
#include "longcalc.h"

/* 󔒂΂ */
void	jmpspc(char **ppstr)
{
	while(isspace(**ppstr))
		(*ppstr)++;
}

/* 񂩂֘A鐔l擾 */
static __int64		getval(
						PSTRCALC_PARAM		prm,
						char				**ppstr,
						__int64				btemp,
						long				*pres)
{
	long		val;
	__int64		s = 0;

	jmpspc(ppstr);
	switch(**ppstr){ /*  */
		case	'-':
				s = 1;

		case	'+':
				(*ppstr)++;
				jmpspc(ppstr);
	}

	if (**ppstr == '('){ /* ʂ̏ꍇ */
		(*ppstr)++;

		/* ʂ̒vZ */
		if (!longcalc(prm,ppstr,btemp,&val) || **ppstr != ')')
			return 0;

		(*ppstr)++;

	}else if (isalpha(**ppstr)){ /* p̏ꍇ */
		double		*pval;

		/*
		  ϐ擾ẪAhX𓾂
		  Pϐ̓o^͍sȂ
		*/
		if (get_paramname(prm,ppstr,0,btemp,&pval) != STATUS_NORMAL)
			return 0;

		val = (long)*pval;

	}else /* ̑ */
		val = strtol(*ppstr,ppstr,0); /* l long ^ɕϊ */

	if (s)
		val = -val;

	*pres = val;
	return 1;
}

/* 揜ZA] */
static __int64		muldiv(
						PSTRCALC_PARAM		prm,
						char				**ppstr,
						__int64				btemp,
						long				*pres)
{
	long	val,n;

	if (!getval(prm,ppstr,btemp,&val))
		return 0;

	while(1){
		jmpspc(ppstr);
		switch(**ppstr){
			case	'*': /* Z */
					(*ppstr)++;
					if (!getval(prm,ppstr,btemp,&n))
						return 0;
					val *= n;
					break;

			case	'/': /* Z */
					(*ppstr)++;
					if (!getval(prm,ppstr,btemp,&n) || !n)
						return 0;
					val /= n;
					break;

			case	'%': /* ] */
					(*ppstr)++;
					if (!getval(prm,ppstr,btemp,&n) || !n)
						return 0;
					val %= n;
					break;

			default:
					*pres = val;
					return 1;
		}
	}
}

/* long ^̌vZ */
__int64		longcalc(
				PSTRCALC_PARAM		prm,
				char				**ppstr,
				__int64				btemp,
				long				*pres)
{
	long	val,n;

	if (!muldiv(prm,ppstr,btemp,&val))
		return 0;

	while(1){
		jmpspc(ppstr);
		switch(**ppstr){
			case	'+': /* Z */
					(*ppstr)++;
					if (!muldiv(prm,ppstr,btemp,&n))
						return 0;
					val += n;
					break;

			case	'-': /* Z */
					(*ppstr)++;
					if (!muldiv(prm,ppstr,btemp,&n))
						return 0;
					val -= n;
					break;

			default:
					*pres = val;
					return 1;
		}
	}
}
