#include <memory.h>
#include "sc39x64.h"
#include "test.h"

/* psrc ɂϐ pdest փRs[ */
__int64		copy_param(
				PSTRCALC_PARAM	pdest,
				PSTRCALC_PARAM	psrc,
				char			*name)
{
	PARAM_INFO		src_inf,dest_inf;

	/* psrc  ϐ name  */
	if (!StrCalc_search_param(psrc,name,&src_inf))
		return 0;

	dest_inf = src_inf; /* o^ʂ */

	/* pdest ɓ̕ϐo^ */
	if (StrCalc_new_param(pdest,&dest_inf) <= 0 ||
		!StrCalc_search_param(pdest,name,&dest_inf))
		return 0;

	/* ẽRs[ */
	switch(src_inf.type){
		case	PRM_SINGLE:
				*dest_inf.pval = *src_inf.pval;
				break;

		case	PRM_DIM1:
				memcpy(dest_inf.pval,src_inf.pval,
					src_inf.width * sizeof(double));
				break;

		case	PRM_DIM2:
				memcpy(dest_inf.pval,src_inf.pval,
					src_inf.width * src_inf.height * sizeof(double));
				break;

		default:
				return 0;
	}

	return 1;
}
