#include <windows.h>
#include <string.h>
#include <stdio.h>
#include "sc39.h"

#define NORMAL_DLL		"sc39_normal.dll"
#define OLDWIN_DLL		"sc39_oldwin.dll"

#define FUNC_NAME		"_StrCalc_getversion@4" /*
												StrCalc_getversion ̊֐
												i__stdcallj
												*/

typedef VOID		(__stdcall *GETVER)(PSCVER);

typedef struct {
	HINSTANCE		hLib;
	GETVER			pfunc;
	LPSTR			pDllName;
} DLLINFO,*PDLLINFO;

/* DLL ̓ǂݍ݂Ɗ֐|C^̎擾 */
BOOL	LoadV39DLL(PDLLINFO pinf)
{
	if ((pinf->hLib = LoadLibrary(pinf->pDllName)) == NULL){
		printf("%s : ǂݍ݃G[\n",pinf->pDllName);
		return FALSE;
	}

	if ((pinf->pfunc = (GETVER)GetProcAddress(pinf->hLib,FUNC_NAME)) == NULL){
		FreeLibrary(pinf->hLib);
		printf("%s : ֐AhX̎擾Ɏs\n",pinf->pDllName);
		return FALSE;
	}

	return TRUE;
}

/* o[W̕\ */
VOID	ShowVer(PSCVER pver)
{
	printf("%d . %d . %d\n",pver->top,pver->mid,pver->bottom);
	printf("%s\n",(pver->bNormal)? "normal" : "oldWin");
	printf("%s\n",pver->ver);
}

VOID	main(VOID)
{
	DLLINFO 	dll1 = { NULL, NULL, NORMAL_DLL };
	DLLINFO 	dll2 = { NULL, NULL, OLDWIN_DLL };
	SCVER		ver1,ver2;

	if (LoadV39DLL(&dll1) == FALSE)
		return;

	if (LoadV39DLL(&dll2) == FALSE){
		FreeLibrary(dll1.hLib);
		return;
	}

	/* ֐StrCalc_getversion ̎s */
	dll1.pfunc(&ver1); /* normal DLL */
	dll2.pfunc(&ver2); /* oldWin DLL */

	/* e\ */
	ShowVer(&ver1); printf("\n");
	ShowVer(&ver2); printf("\n\n");

	/* o[W̔r */
	if (ver1.top != ver2.top || ver1.mid != ver2.mid || ver1.bottom != ver2.bottom ||
		ver1.bNormal != ver2.bNormal || strcmp(ver1.ver,ver2.ver))
		printf("قȂo[Wł\n");
	else
		printf("o[Wł\n");

	FreeLibrary(dll1.hLib);
	FreeLibrary(dll2.hLib);
}

